/*
 * geom-min.js
 *
 * Copyright (c) 2015 Emmanuel PUYBARET / eTeks <info@eteks.com>
 * 
 * Copyright (c) 1997, 2013, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied OpenJDK 8 source code.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 */

// Classes of java.awt.geom package of OpenJDK 8 translated to Javascript

// Requires core-min.js
function NoninvertibleTransformException(t){this.message=t}function IllegalPathStateException(t){this.message=t}function PathIterator(){}function Point2D(t,r){this.x=void 0!==t?t:0,this.y=void 0!==r?r:0}function Line2D(t,r,e,i){if(void 0===t)this.setLine(0,0,0,0);else if(void 0===e){var s=t,n=e;this.setLine(s,n)}else this.setLine(t,r,e,i)}function LineIterator(t,r){this.line=t,this.affine=r,this.index=0}function Rectangle2D(t,r,e,i){this.setRect(void 0!==t?t:0,void 0!==r?r:0,void 0!==e?e:0,void 0!==i?i:0)}function RectIterator(t,r){this.x=t.getX(),this.y=t.getY(),this.w=t.getWidth(),this.h=t.getHeight(),this.affine=r,this.w<0||this.h<0?this.index=6:this.index=0}function Ellipse2D(t,r,e,i){this.setFrame(void 0!==t?t:0,void 0!==r?r:0,void 0!==e?e:0,void 0!==i?i:0)}function EllipseIterator(t,r){this.x=t.getX(),this.y=t.getY(),this.w=t.getWidth(),this.h=t.getHeight(),this.affine=r,w<0||h<0?this.index=6:this.index=0}function AffineTransform(t,r,e,i,s,n,o){if(void 0===t)this.m00=1,this.m10=0,this.m01=0,this.m11=1,this.m02=0,this.m12=0,this.state=AffineTransform.APPLY_IDENTITY,this.type=AffineTransform.TYPE_IDENTITY;else if(t instanceof AffineTransform){var f=t;this.m00=f.m00,this.m10=f.m10,this.m01=f.m01,this.m11=f.m11,this.m02=f.m02,this.m12=f.m12,this.state=f.state,this.type=f.type}else void 0===o?(this.m00=t,this.m10=r,this.m01=e,this.m11=i,this.m02=s,this.m12=n,this.updateState()):(this.m00=t,this.m10=r,this.m01=e,this.m11=i,this.m02=s,this.m12=n,this.state=o,this.type=AffineTransform.TYPE_UNKNOWN)}function Path2D(t,r){if(this.numTypes=0,this.numCoords=0,void 0===t)return this.setWindingRule(PathIterator.WIND_NON_ZERO),this.pointTypes=new Array(Point2D.INIT_SIZE),void(this.pointCoords=new Array(2*Point2D.INIT_SIZE));if(void 0===r){if("object"!=typeof t){var e=t;return this.setWindingRule(e),this.pointTypes=new Array(Point2D.INIT_SIZE),void(this.pointCoords=new Array(2*Point2D.INIT_SIZE))}r=null}else if("object"!=typeof t){var e=t,i=r;return this.setWindingRule(e),this.pointTypes=new Array(i),void(this.pointCoords=new Array(2*i))}if(t instanceof Path2D){var s=t;this.setWindingRule(s.windingRule),this.numTypes=s.numTypes,this.pointTypes=s.pointTypes.splice(0),this.numCoords=s.numCoords,this.pointCoords=s.cloneCoordsFloat(r)}else{var n=t.getPathIterator(r);this.setWindingRule(n.getWindingRule()),this.pointTypes=new Array(Point2D.INIT_SIZE),this.pointCoords=new Array(2*Point2D.INIT_SIZE),this.append(n,!1)}}function Path2DIterator(t){this.path=t,this.typeIdx=0,this.pointIdx=0}function Path2DCopyIterator(t){Path2DIterator.call(this,t),this.pointCoords=t.pointCoords}function Path2DTxIterator(t,r){Path2DIterator.call(this,t),this.pointCoords=t.pointCoords,this.affine=r}function FlatteningPathIterator(t,r,e){if(this.hold=new Array(14),this.curx=0,this.cury=0,this.movx=0,this.movy=0,this.holdType=0,this.holdEnd=0,this.holdIndex=0,this.levelIndex=0,this.done=!1,void 0===e&&(e=10),0>r)throw new IllegalArgumentException("flatness must be >= 0");if(0>e)throw new IllegalArgumentException("limit must be >= 0");this.src=t,this.squareflat=r*r,this.limit=e,this.levels=new Array(e+1),this.next(!1)}function GeneralPath(t,r,e,i,s){if(void 0===t)Path2D.call(this,PathIterator.WIND_NON_ZERO,Point2D.INIT_SIZE);else if(void 0===r)if("object"==typeof t){var n=t;Path2D.call(this,n,null)}else Path2D.call(this,t,Point2D.INIT_SIZE);else if(void 0===e){var o=t,f=r;Path2D.call(this,o,f)}else this.windingRule=t,this.pointTypes=r,this.numTypes=e,this.pointCoords=i,this.numCoords=s}function QuadCurve2D(t,r,e,i,s,n){void 0===t?this.setCurve(0,0,0,0,0,0):this.setCurve(t,r,e,i,s,n)}function QuadIterator(t,r){this.quad=t,this.affine=r,this.index=0}function CubicCurve2D(t,r,e,i,s,n,o,f){void 0===t?this.setCurve(0,0,0,0,0,0,0,0):this.setCurve(t,r,e,i,s,n,o,f)}function CubicIterator(t,r){this.cubic=t,this.affine=r,this.index=0}function Area(t){void 0===t?this.curves=[]:t instanceof Area?this.curves=t.curves:this.curves=Area.pathToCurves(t.getPathIterator(null)),this.cachedBounds=null}function AreaIterator(t,r){this.curves=t,this.transform=r,this.index=0,this.prevcurve=null,t.length>=1?this.thiscurve=t[0]:this.thiscurve=null}function Curve(t){this.direction=t}function Order0(t,r){Curve.call(this,Curve.INCREASING),this.x=t,this.y=r}function Order1(t,r,e,i,s){Curve.call(this,s),this.x0=t,this.y0=r,this.x1=e,this.y1=i,e>t?(this.xmin=t,this.xmax=e):(this.xmin=e,this.xmax=t)}function Order2(t,r,e,i,s,n,o){Curve.call(this,o),r>i?i=r:i>n&&(i=n),this.x0=t,this.y0=r,this.cx0=e,this.cy0=i,this.x1=s,this.y1=n,this.xmin=Math.min(Math.min(t,s),e),this.xmax=Math.max(Math.max(t,s),e),this.xcoeff0=t,this.xcoeff1=e+e-t-t,this.xcoeff2=t-e-e+s,this.ycoeff0=r,this.ycoeff1=i+i-r-r,this.ycoeff2=r-i-i+n}function Order3(t,r,e,i,s,n,o,f,a){Curve.call(this,a),r>i&&(this.cy0=r),n>f&&(this.cy1=f),this.x0=t,this.y0=r,this.cx0=e,this.cy0=i,this.cx1=s,this.cy1=n,this.x1=o,this.y1=f,this.xmin=Math.min(Math.min(t,o),Math.min(e,s)),this.xmax=Math.max(Math.max(t,o),Math.max(e,s)),this.xcoeff0=t,this.xcoeff1=3*(e-t),this.xcoeff2=3*(s-e-e+t),this.xcoeff3=o-3*(s-e)-t,this.ycoeff0=r,this.ycoeff1=3*(i-r),this.ycoeff2=3*(n-i-i+r),this.ycoeff3=f-3*(n-i)-r,this.YforT1=this.YforT2=this.YforT3=r,this.TforY1=this.TforY2=this.TforY3=0}function Crossings(t,r,e,i){this.xlo=t,this.ylo=r,this.xhi=e,this.yhi=i,this.limit=0,this.yranges=new Array(10)}function CrossingsEvenOdd(t,r,e,i){Crossings.call(this,t,r,e,i)}function CrossingsNonZero(t,r,e,i){Crossings.call(this.xlo,r,e,i),this.crosscounts=new Array(this.yranges.length/2)}function AreaOp(){}function AreaOpCAGOp(){this.inLeft=!1,this.inRight=!1,this.inResult=!1}function AreaOpAddOp(){AreaOpCAGOp.call(this)}function AreaOpSubOp(){AreaOpCAGOp.call(this)}function AreaOpIntOp(){AreaOpCAGOp.call(this)}function AreaOpXorOp(){AreaOpCAGOp.call(this)}function AreaOpNZWindOp(){this.count=0}function AreaOpEOWindOp(){this.inside=!1}function ChainEnd(t,r){this.head=t,this.tail=t,this.partner=r,this.etag=t.getEdgeTag()}function CurveLink(t,r,e,i){if(this.curve=t,this.ytop=r,this.ybot=e,this.etag=i,this.next=null,this.ytop<t.getYTop()||this.ybot>t.getYBot())throw new InternalError("bad curvelink ["+ytop+"=>"+ybot+"] for "+t)}function Edge(t,r,e){void 0===e&&(e=AreaOp.ETAG_IGNORE),this.curve=t,this.ctag=r,this.etag=e,this.activey=0,this.equivalence=0,this.lastEdge=null,this.lastResult=0,this.lastLimit=0}PathIterator.WIND_EVEN_ODD=0,PathIterator.WIND_NON_ZERO=1,PathIterator.SEG_MOVETO=0,PathIterator.SEG_LINETO=1,PathIterator.SEG_QUADTO=2,PathIterator.SEG_CUBICTO=3,PathIterator.SEG_CLOSE=4,Point2D.prototype.getX=function(){return this.x},Point2D.prototype.getY=function(){return this.y},Point2D.prototype.setLocation=function(t,r){if(void 0===r){var e=t;this.setLocation(e.getX(),e.getY())}else this.x=t,this.y=r},Point2D.distanceSq=function(t,r,e,i){return t-=e,r-=i,t*t+r*r},Point2D.distance=function(t,r,e,i){return t-=e,r-=i,Math.sqrt(t*t+r*r)},Point2D.prototype.distanceSq=function(t,r){if(void 0!==r)return t-=this.getX(),r-=this.getY(),t*t+r*r;var e=t;this.distanceSq(e.getX(),e.getY())},Point2D.prototype.distance=function(t,r){if(void 0!==r)return x-=this.getX(),r-=this.getY(),Math.sqrt(t*t+r*r);var e=t;this.distance(e.getX(),e.getY())},Point2D.prototype.clone=function(){return new Point2D(this.x,this.y)},Point2D.prototype.equals=function(t){return t instanceof Point2D?this.getX()===t.getX()&&this.getY()===t.getY():!1},Line2D.prototype.getX1=function(){return this.x1},Line2D.prototype.getY1=function(){return this.y1},Line2D.prototype.getP1=function(){return new Point2D.Float(x1,y1)},Line2D.prototype.getX2=function(){return this.x2},Line2D.prototype.getY2=function(){return this.y2},Line2D.prototype.getP2=function(){return new Point2D.Float(x2,y2)},Line2D.prototype.setLine=function(t,r,e,i){if(void 0===r){var s=t;this.setLine(s.getX1(),s.getY1(),s.getX2(),s.getY2())}else if(void 0===e){var n=t,o=r;this.setLine(n.getX(),n.getY(),o.getX(),o.getY())}this.x1=t,this.y1=r,this.x2=e,this.y2=i},Line2D.prototype.getBounds2D=function(){var t,r,e,i;return this.x1<this.x2?(t=this.x1,e=this.x2-this.x1):(t=this.x2,e=this.x1-this.x2),this.y1<this.y2?(r=this.y1,i=this.y2-this.y1):(r=this.y2,i=this.y1-this.y2),new Rectangle2D(t,r,e,i)},Line2D.relativeCCW=function(t,r,e,i,s,n){e-=t,i-=r,s-=t,n-=r;var o=s*i-n*e;return 0===o&&(o=s*e+n*i,o>0&&(s-=e,n-=i,o=s*e+n*i,0>o&&(o=0))),0>o?-1:o>0?1:0},Line2D.prototype.relativeCCW=function(t,r){if(void 0===r){var e=t;return Line2D.relativeCCW(this.getX1(),this.getY1(),this.getX2(),this.getY2(),e.getX(),e.getY())}return Line2D.relativeCCW(this.getX1(),this.getY1(),this.getX2(),this.getY2(),t,r)},Line2D.linesIntersect=function(t,r,e,i,s,n,o,f){return Line2D.relativeCCW(t,r,e,i,s,n)*Line2D.relativeCCW(t,r,e,i,o,f)<=0&&Line2D.relativeCCW(s,n,o,f,t,r)*Line2D.relativeCCW(s,n,o,f,e,i)<=0},Line2D.prototype.intersectsLine=function(t,r,e,i){if(void 0===r){var s=t;return Line2D.linesIntersect(s.getX1(),s.getY1(),s.getX2(),s.getY2(),this.getX1(),this.getY1(),this.getX2(),this.getY2())}return Line2D.linesIntersect(t,r,e,i,this.getX1(),this.getY1(),this.getX2(),this.getY2())},Line2D.ptSegDistSq=function(t,r,e,i,s,n){e-=t,i-=r,s-=t,n-=r;var o,f=s*e+n*i;0>=f?o=0:(s=e-s,n=i-n,f=s*e+n*i,o=0>=f?0:f*f/(e*e+i*i));var a=s*s+n*n-o;return 0>a&&(a=0),a},Line2D.ptSegDist=function(t,r,e,i,s,n){return Math.sqrt(Line2D.ptSegDistSq(t,r,e,i,s,n))},Line2D.prototype.ptSegDistSq=function(t,r){if(void 0===r){var e=t;return Line2D.ptSegDistSq(this.getX1(),this.getY1(),this.getX2(),this.getY2(),e.getX(),e.getY())}return Line2D.ptSegDistSq(this.getX1(),this.getY1(),this.getX2(),this.getY2(),t,r)},Line2D.prototype.ptSegDist=function(t,r){if(void 0===r){var e=t;return Line2D.ptSegDist(this.getX1(),this.getY1(),this.getX2(),this.getY2(),e.getX(),e.getY())}return Line2D.ptSegDist(this.getX1(),this.getY1(),this.getX2(),this.getY2(),t,r)},Line2D.ptLineDistSq=function(t,r,e,i,s,n){e-=t,i-=r,s-=t,n-=r;var o=s*e+n*i,f=o*o/(e*e+i*i),a=s*s+n*n-f;return 0>a&&(a=0),a},Line2D.ptLineDist=function(t,r,e,i,s,n){return Math.sqrt(Line2D.ptLineDistSq(t,r,e,i,s,n))},Line2D.prototype.ptLineDistSq=function(t,r){if(void 0===r){var e=t;return Line2D.ptLineDistSq(this.getX1(),this.getY1(),this.getX2(),this.getY2(),e.getX(),e.getY())}return Line2D.ptLineDistSq(this.getX1(),this.getY1(),this.getX2(),this.getY2(),t,r)},Line2D.prototype.ptLineDist=function(t,r){if(void 0===r){var e=t;return Line2D.ptLineDist(this.getX1(),this.getY1(),this.getX2(),this.getY2(),e.getX(),e.getY())}return Line2D.ptLineDist(this.getX1(),this.getY1(),this.getX2(),this.getY2(),t,r)},Line2D.prototype.intersects=function(t,r,e,i){if(void 0===r){var s=t;return s.intersectsLine(this.getX1(),this.getY1(),this.getX2(),this.getY2())}return this.intersects(new Rectangle2D(t,r,e,i))},Line2D.prototype.contains=function(t,r,e,i){return!1},Line2D.prototype.getPathIterator=function(t,r){return new LineIterator(this,t)},Line2D.prototype.clone=function(){return new Line2D(this.getX1(),this.getY1(),this.getX2(),this.getY2())},LineIterator.prototype=Object.create(PathIterator.prototype),LineIterator.prototype.constructor=LineIterator,LineIterator.prototype.getWindingRule=function(){return PathIterator.WIND_NON_ZERO},LineIterator.prototype.isDone=function(){return this.index>1},LineIterator.prototype.next=function(){this.index++},LineIterator.prototype.currentSegment=function(t){if(this.isDone())throw new NoSuchElementException("line iterator out of bounds");var r;return 0===this.index?(t[0]=this.line.getX1(),t[1]=this.line.getY1(),r=PathIterator.SEG_MOVETO):(t[0]=this.line.getX2(),t[1]=this.line.getY2(),r=PathIterator.SEG_LINETO),null!==this.affine&&this.affine.transform(t,0,t,0,1),r},Rectangle2D.OUT_LEFT=1,Rectangle2D.OUT_TOP=2,Rectangle2D.OUT_RIGHT=4,Rectangle2D.OUT_BOTTOM=8,Rectangle2D.prototype.getX=function(){return this.x},Rectangle2D.prototype.getY=function(){return this.y},Rectangle2D.prototype.getWidth=function(){return this.width},Rectangle2D.prototype.getHeight=function(){return this.height},Rectangle2D.prototype.getMinX=function(){return this.getX()},Rectangle2D.prototype.getMinY=function(){return this.getY()},Rectangle2D.prototype.getMaxX=function(){return this.getX()+this.getWidth()},Rectangle2D.prototype.getMaxY=function(){return this.getY()+this.getHeight()},Rectangle2D.prototype.getCenterX=function(){return this.getX()+this.getWidth()/2},Rectangle2D.prototype.getCenterY=function(){return this.getY()+this.getHeight()/2},Rectangle2D.prototype.isEmpty=function(){return this.width<=0||this.height<=0},Rectangle2D.prototype.setRect=function(t,r,e,i){this.x=t,this.y=r,this.width=e,this.height=i},Rectangle2D.prototype.outcode=function(t,r){var e=0;return this.width<=0?e|=Rectangle2D.OUT_LEFT|Rectangle2D.OUT_RIGHT:t<this.x?e|=Rectangle2D.OUT_LEFT:t>this.x+this.width&&(e|=Rectangle2D.OUT_RIGHT),this.height<=0?e|=Rectangle2D.OUT_TOP|Rectangle2D.OUT_BOTTOM:r<this.y?e|=Rectangle2D.OUT_TOP:r>this.y+this.height&&(e|=Rectangle2D.OUT_BOTTOM),e},Rectangle2D.prototype.getBounds2D=function(){return new Rectangle2D(this.x,this.y,this.width,this.height)},Rectangle2D.prototype.createIntersection=function(t){var r=new Rectangle2D;return Rectangle2D.intersect(this,t,r),r},Rectangle2D.prototype.createUnion=function(t){var r=Rectangle2D();return Rectangle2D.union(this,t,r),r},Rectangle2D.prototype.intersectsLine=function(t,r,e,i){var s,n;if(0===(n=this.outcode(e,i)))return!0;for(;0!==(s=this.outcode(t,r));){if(0!==(s&n))return!1;if(0!==(s&(Rectangle2D.OUT_LEFT|Rectangle2D.OUT_RIGHT))){var o=this.getX();0!==(s&Rectangle2D.OUT_RIGHT)&&(o+=this.getWidth()),r+=(o-t)*(i-r)/(e-t),t=o}else{var f=this.getY();0!==(s&Rectangle2D.OUT_BOTTOM)&&(f+=this.getHeight()),t+=(f-r)*(e-t)/(i-r),r=f}}return!0},Rectangle2D.prototype.setFrame=function(t,r,e,i){this.setRect(t,r,e,i)},Rectangle2D.prototype.intersects=function(t,r,e,i){if(this.isEmpty()||0>=e||0>=i)return!1;var s=this.getX(),n=this.getY();return t+e>s&&r+i>n&&t<s+this.getWidth()&&r<n+this.getHeight()},Rectangle2D.prototype.contains=function(t,r,e,i){if(void 0===e){var s=this.getX(),n=this.getY();return t>=s&&r>=n&&t<s+this.getWidth()&&r<n+this.getHeight()}if(this.isEmpty()||0>=e||0>=i)return!1;var s=this.getX(),n=this.getY();return t>=s&&r>=n&&t+e<=s+this.getWidth()&&r+i<=n+this.getHeight()},Rectangle2D.intersect=function(t,r,e){var i=Math.max(t.getMinX(),r.getMinX()),s=Math.max(t.getMinY(),r.getMinY()),n=Math.min(t.getMaxX(),r.getMaxX()),o=Math.min(t.getMaxY(),r.getMaxY());e.setFrame(i,s,n-i,o-s)},Rectangle2D.union=function(t,r,e){var i=Math.min(t.getMinX(),r.getMinX()),s=Math.min(t.getMinY(),r.getMinY()),n=Math.max(t.getMaxX(),r.getMaxX()),o=Math.max(t.getMaxY(),r.getMaxY());e.setFrameFromDiagonal(i,s,n,o)},Rectangle2D.prototype.add=function(t,r){var e,i,s,n;if(void 0===r){if(!(t instanceof Rectangle2D)){var o=newX;return void this.add(o.getX(),o.getY())}var f=t;e=Math.min(this.getMinX(),f.getMinX()),i=Math.max(this.getMaxX(),f.getMaxX()),s=Math.min(this.getMinY(),f.getMinY()),n=Math.max(this.getMaxY(),f.getMaxY())}else e=Math.min(this.getMinX(),t),i=Math.max(this.getMaxX(),t),s=Math.min(this.getMinY(),r),n=Math.max(this.getMaxY(),r);this.setRect(e,s,i-e,n-s)},Rectangle2D.prototype.getPathIterator=function(t,r){return new RectIterator(this,t)},Rectangle2D.prototype.equals=function(t){return t===this?!0:t instanceof Rectangle2D?this.getX()===t.getX()&&this.getY()===t.getY()&&this.getWidth()===t.getWidth()&&this.getHeight()===t.getHeight():!1},RectIterator.prototype=Object.create(PathIterator.prototype),RectIterator.prototype.constructor=RectIterator,RectIterator.prototype.getWindingRule=function(){return PathIterator.WIND_NON_ZERO},RectIterator.prototype.isDone=function(){return this.index>5},RectIterator.prototype.next=function(){this.index++},RectIterator.prototype.currentSegment=function(t){if(this.isDone())throw new NoSuchElementException("rect iterator out of bounds");return 5===this.index?PathIterator.SEG_CLOSE:(t[0]=this.x,t[1]=this.y,(1===this.index||2===this.index)&&(t[0]+=this.w),(2===this.index||3===this.index)&&(t[1]+=this.h),null!==this.affine&&this.affine.transform(t,0,t,0,1),0===this.index?PathIterator.SEG_MOVETO:PathIterator.SEG_LINETO)},Ellipse2D.prototype.getX=function(){return this.x},Ellipse2D.prototype.getY=function(){return this.y},Ellipse2D.prototype.getWidth=function(){return this.width},Ellipse2D.prototype.getHeight=function(){return this.height},Ellipse2D.prototype.isEmpty=function(){return this.width<=0||this.height<=0},Ellipse2D.prototype.setFrame=function(t,r,e,i){this.x=t,this.y=r,this.width=e,this.height=i},Ellipse2D.prototype.getBounds2D=function(){return new Rectangle2D(this.x,this.y,this.width,this.height)},Ellipse2D.prototype.intersects=function(t,r,e,i){if(0>=e||0>=i)return!1;var s=this.getWidth();if(0>=s)return!1;var n=(t-this.getX())/s-.5,o=n+e/s,f=this.getHeight();if(0>=f)return!1;var a,h,u=(r-this.getY())/f-.5,A=u+i/f;return a=n>0?n:0>o?o:0,h=u>0?u:0>A?A:0,.25>a*a+h*h},Ellipse2D.prototype.contains=function(t,r,e,i){if(void 0===e){var s=this.getWidth();if(0>=s)return!1;var n=(t-this.getX())/s-.5,o=this.getHeight();if(0>=o)return!1;var f=(r-this.getY())/o-.5;return.25>n*n+f*f}return this.contains(t,r)&&this.contains(t+e,r)&&this.contains(t,r+i)&&this.contains(t+e,r+i)},Ellipse2D.prototype.getPathIterator=function(t){return new EllipseIterator(this,t)},Ellipse2D.prototype.equals=function(t){if(t===this)return!0;if(t instanceof Ellipse2D){var r=t;return this.getX()===r.getX()&&this.getY()===r.getY()&&this.getWidth()===r.getWidth()&&this.getHeight()===r.getHeight()}return!1};const CtrlVal=.5522847498307933,pcv=.5+.5*CtrlVal,ncv=.5-.5*CtrlVal;EllipseIterator.ctrlpts=[[1,pcv,pcv,1,.5,1],[ncv,1,0,pcv,0,.5],[0,ncv,ncv,0,.5,0],[pcv,0,1,ncv,1,.5]],EllipseIterator.prototype.getWindingRule=function(){return PathIterator.WIND_NON_ZERO},EllipseIterator.prototype.isDone=function(){return this.index>5},EllipseIterator.prototype.next=function(){this.index++},EllipseIterator.prototype.currentSegment=function(t){if(this.isDone())throw new NoSuchElementException("ellipse iterator out of bounds");if(5==this.index)return PathIterator.SEG_CLOSE;if(0==this.index){var r=EllipseIterator.ctrlpts[3];return t[0]=this.x+r[4]*this.w,t[1]=this.y+r[5]*this.h,null!=this.affine&&this.affine.transform(t,0,t,0,1),PathIterator.SEG_MOVETO}var r=EllipseIterator.ctrlpts[index-1];return t[0]=this.x+r[0]*this.w,t[1]=this.y+r[1]*this.h,t[2]=this.x+r[2]*this.w,t[3]=this.y+r[3]*this.h,t[4]=this.x+r[4]*this.w,t[5]=this.y+r[5]*this.h,null!=this.affine&&this.affine.transform(t,0,t,0,3),PathIterator.SEG_CUBICTO},AffineTransform.TYPE_UNKNOWN=-1,AffineTransform.TYPE_IDENTITY=0,AffineTransform.TYPE_TRANSLATION=1,AffineTransform.TYPE_UNIFORM_SCALE=2,AffineTransform.TYPE_GENERAL_SCALE=4,AffineTransform.TYPE_MASK_SCALE=AffineTransform.TYPE_UNIFORM_SCALE|AffineTransform.TYPE_GENERAL_SCALE,AffineTransform.TYPE_FLIP=64,AffineTransform.TYPE_QUADRANT_ROTATION=8,AffineTransform.TYPE_GENERAL_ROTATION=16,AffineTransform.TYPE_MASK_ROTATION=AffineTransform.TYPE_QUADRANT_ROTATION|AffineTransform.TYPE_GENERAL_ROTATION,AffineTransform.TYPE_GENERAL_TRANSFORM=32,AffineTransform.APPLY_IDENTITY=0,AffineTransform.APPLY_TRANSLATE=1,AffineTransform.APPLY_SCALE=2,AffineTransform.APPLY_SHEAR=4,AffineTransform.HI_SHIFT=3,AffineTransform.HI_IDENTITY=AffineTransform.APPLY_IDENTITY<<AffineTransform.HI_SHIFT,AffineTransform.HI_TRANSLATE=AffineTransform.APPLY_TRANSLATE<<AffineTransform.HI_SHIFT,AffineTransform.HI_SCALE=AffineTransform.APPLY_SCALE<<AffineTransform.HI_SHIFT,AffineTransform.HI_SHEAR=AffineTransform.APPLY_SHEAR<<AffineTransform.HI_SHIFT,AffineTransform.rot90conversion=[AffineTransform.APPLY_SHEAR,AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE,AffineTransform.APPLY_SHEAR,AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE,AffineTransform.APPLY_SCALE,AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE,AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE,AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE],AffineTransform.getTranslateInstance=function(t,r){var e=new AffineTransform;return e.setToTranslation(t,r),e},AffineTransform.getRotateInstance=function(t,r,e,i){var s=new AffineTransform;if(void 0===r){var n=t;s.setToRotation(n)}else if(void 0===e)s.setToRotation(t,r);else if(void 0===i){var n=t;i=e,e=r,s.setToRotation(n,e,i)}else s.setToRotation(t,r,e,i);return s},AffineTransform.getQuadrantRotateInstance=function(t,r,e){var i=new AffineTransform;return void 0===r?i.setToQuadrantRotation(t):i.setToQuadrantRotation(t,r,e),i},AffineTransform.getScaleInstance=function(t,r){var e=new AffineTransform;return e.setToScale(t,r),e},AffineTransform.getShearInstance=function(t,r){var e=new AffineTransform;return e.setToShear(t,r),e},AffineTransform.prototype.getType=function(){return this.type===AffineTransform.TYPE_UNKNOWN&&this.calculateType(),this.type},AffineTransform.prototype.calculateType=function(){var t,r,e,i,s,n,o=AffineTransform.TYPE_IDENTITY;switch(this.updateState(),this.state){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:o=AffineTransform.TYPE_TRANSLATION;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:if((e=this.m00)*(s=this.m01)+(n=this.m10)*(i=this.m11)!==0)return void(this.type=AffineTransform.TYPE_GENERAL_TRANSFORM);t=e>=0,r=i>=0,o|=t===r?e!==i||s!==-n?AffineTransform.TYPE_GENERAL_ROTATION|AffineTransform.TYPE_GENERAL_SCALE:e*i-s*n!==1?AffineTransform.TYPE_GENERAL_ROTATION|AffineTransform.TYPE_UNIFORM_SCALE:AffineTransform.TYPE_GENERAL_ROTATION:e!==-i||s!==n?AffineTransform.TYPE_GENERAL_ROTATION|AffineTransform.TYPE_FLIP|AffineTransform.TYPE_GENERAL_SCALE:e*i-s*n!==1?AffineTransform.TYPE_GENERAL_ROTATION|AffineTransform.TYPE_FLIP|AffineTransform.TYPE_UNIFORM_SCALE:AffineTransform.TYPE_GENERAL_ROTATION|AffineTransform.TYPE_FLIP;break;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:o=AffineTransform.TYPE_TRANSLATION;case AffineTransform.APPLY_SHEAR:t=(e=this.m01)>=0,r=(i=this.m10)>=0,o|=t!==r?e!==-i?AffineTransform.TYPE_QUADRANT_ROTATION|AffineTransform.TYPE_GENERAL_SCALE:1!==e&&-1!==e?AffineTransform.TYPE_QUADRANT_ROTATION|AffineTransform.TYPE_UNIFORM_SCALE:AffineTransform.TYPE_QUADRANT_ROTATION:e===i?AffineTransform.TYPE_QUADRANT_ROTATION|AffineTransform.TYPE_FLIP|AffineTransform.TYPE_UNIFORM_SCALE:AffineTransform.TYPE_QUADRANT_ROTATION|AffineTransform.TYPE_FLIP|AffineTransform.TYPE_GENERAL_SCALE;break;case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:o=AffineTransform.TYPE_TRANSLATION;case AffineTransform.APPLY_SCALE:t=(e=this.m00)>=0,r=(i=this.m11)>=0,o|=t===r?t?e===i?AffineTransform.TYPE_UNIFORM_SCALE:AffineTransform.TYPE_GENERAL_SCALE:e!==i?AffineTransform.TYPE_QUADRANT_ROTATION|AffineTransform.TYPE_GENERAL_SCALE:-1!==e?AffineTransform.TYPE_QUADRANT_ROTATION|AffineTransform.TYPE_UNIFORM_SCALE:AffineTransform.TYPE_QUADRANT_ROTATION:e===-i?1===e||-1===e?AffineTransform.TYPE_FLIP:AffineTransform.TYPE_FLIP|AffineTransform.TYPE_UNIFORM_SCALE:AffineTransform.TYPE_FLIP|AffineTransform.TYPE_GENERAL_SCALE;break;case AffineTransform.APPLY_TRANSLATE:o=AffineTransform.TYPE_TRANSLATION;break;case AffineTransform.APPLY_IDENTITY:}this.type=o},AffineTransform.prototype.getDeterminant=function(){switch(this.state){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:return this.m00*this.m11-this.m01*this.m10;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SHEAR:return-(this.m01*this.m10);case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SCALE:return this.m00*this.m11;case AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_IDENTITY:return 1}},AffineTransform.prototype.updateState=function(){0===this.m01&&0===this.m10?1===this.m00&&1===this.m11?0===this.m02&&0===this.m12?(this.state=AffineTransform.APPLY_IDENTITY,this.type=AffineTransform.TYPE_IDENTITY):(this.state=AffineTransform.APPLY_TRANSLATE,this.type=AffineTransform.TYPE_TRANSLATION):0===this.m02&&0===this.m12?(this.state=AffineTransform.APPLY_SCALE,this.type=AffineTransform.TYPE_UNKNOWN):(this.state=AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE,this.type=AffineTransform.TYPE_UNKNOWN):0===this.m00&&0===this.m11?0===this.m02&&0===this.m12?(this.state=AffineTransform.APPLY_SHEAR,this.type=AffineTransform.TYPE_UNKNOWN):(this.state=AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE,this.type=AffineTransform.TYPE_UNKNOWN):0===this.m02&&0===this.m12?(this.state=AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE,this.type=AffineTransform.TYPE_UNKNOWN):(this.state=AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE,this.type=AffineTransform.TYPE_UNKNOWN)},AffineTransform.prototype.stateError=function(){throw new InternalError("missing case in transform state switch")},AffineTransform.prototype.getMatrix=function(t){t[0]=this.m00,t[1]=this.m10,t[2]=this.m01,t[3]=this.m11,t.length>5&&(t[4]=this.m02,t[5]=this.m12)},AffineTransform.prototype.getScaleX=function(){return this.m00},AffineTransform.prototype.getScaleY=function(){return this.m11},AffineTransform.prototype.getShearX=function(){return this.m01},AffineTransform.prototype.getShearY=function(){return this.m10},AffineTransform.prototype.getTranslateX=function(){return this.m02},AffineTransform.prototype.getTranslateY=function(){return this.m12},AffineTransform.prototype.translate=function(t,r){switch(this.state){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:return this.m02=t*this.m00+r*this.m01+this.m02,this.m12=t*this.m10+r*this.m11+this.m12,void(0===this.m02&&0===this.m12&&(this.state=AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE,this.type!==AffineTransform.TYPE_UNKNOWN&&(this.type-=AffineTransform.TYPE_TRANSLATION)));case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:return this.m02=t*this.m00+r*this.m01,this.m12=t*this.m10+r*this.m11,void((0!==this.m02||0!==this.m12)&&(this.state=AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE,this.type|=AffineTransform.TYPE_TRANSLATION));case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:return this.m02=r*this.m01+this.m02,this.m12=t*this.m10+this.m12,void(0===this.m02&&0===this.m12&&(this.state=AffineTransform.APPLY_SHEAR,this.type!==AffineTransform.TYPE_UNKNOWN&&(this.type-=AffineTransform.TYPE_TRANSLATION)));case AffineTransform.APPLY_SHEAR:return this.m02=r*this.m01,this.m12=t*this.m10,void((0!==this.m02||0!==this.m12)&&(this.state=AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE,this.type|=AffineTransform.TYPE_TRANSLATION));case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:return this.m02=t*this.m00+this.m02,this.m12=r*this.m11+this.m12,void(0===this.m02&&0===this.m12&&(this.state=AffineTransform.APPLY_SCALE,this.type!==AffineTransform.TYPE_UNKNOWN&&(this.type-=AffineTransform.TYPE_TRANSLATION)));case AffineTransform.APPLY_SCALE:return this.m02=t*this.m00,this.m12=r*this.m11,void((0!==this.m02||0!==this.m12)&&(this.state=AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE,this.type|=AffineTransform.TYPE_TRANSLATION));case AffineTransform.APPLY_TRANSLATE:return this.m02=t+this.m02,this.m12=r+this.m12,void(0===this.m02&&0===this.m12&&(this.state=AffineTransform.APPLY_IDENTITY,this.type=AffineTransform.TYPE_IDENTITY));case AffineTransform.APPLY_IDENTITY:return this.m02=t,this.m12=r,void((0!==t||0!==r)&&(this.state=AffineTransform.APPLY_TRANSLATE,this.type=AffineTransform.TYPE_TRANSLATION))}},AffineTransform.prototype.rotate90=function(){var t=this.m00;this.m00=this.m01,this.m01=-t,t=this.m10,this.m10=this.m11,this.m11=-t;var r=rot90conversion[this.state];(r&(AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE))===AffineTransform.APPLY_SCALE&&1===this.m00&&1===this.m11&&(r-=AffineTransform.APPLY_SCALE),this.state=r,this.type=AffineTransform.TYPE_UNKNOWN},AffineTransform.prototype.rotate180=function(){this.m00=-this.m00,this.m11=-this.m11;var t=this.state;0!==(t&AffineTransform.APPLY_SHEAR)?(this.m01=-this.m01,this.m10=-this.m10):1===this.m00&&1===this.m11?this.state=t&~AffineTransform.APPLY_SCALE:this.state=t|AffineTransform.APPLY_SCALE,this.type=AffineTransform.TYPE_UNKNOWN},AffineTransform.prototype.rotate270=function(){var t=this.m00;this.m00=-this.m01,this.m01=t,t=this.m10,this.m10=-this.m11,this.m11=t;var r=rot90conversion[this.state];(r&(AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE))===AffineTransform.APPLY_SCALE&&1===this.m00&&1===this.m11&&(r-=AffineTransform.APPLY_SCALE),this.state=r,this.type=AffineTransform.TYPE_UNKNOWN},AffineTransform.prototype.rotate=function(t,r,e,i){if(void 0===r){var s=t,n=Math.sin(s);if(1===n)this.rotate90();else if(-1===n)this.rotate270();else{var o=Math.cos(s);if(-1===o)this.rotate180();else if(1!==o){var f,a;f=this.m00,a=this.m01,this.m00=o*f+n*a,this.m01=-n*f+o*a,f=this.m10,a=this.m11,this.m10=o*f+n*a,this.m11=-n*f+o*a,this.updateState()}}}else if(void 0===e)if(0===r)0>t&&this.rotate180();else if(0===t)r>0?this.rotate90():this.rotate270();else{var f,a,h=Math.sqrt(t*t+r*r),n=r/h,o=t/h;f=this.m00,a=this.m01,this.m00=o*f+n*a,this.m01=-n*f+o*a,f=this.m10,a=this.m11,this.m10=o*f+n*a,this.m11=-n*f+o*a,this.updateState()}else if(void 0===i){var s=t;i=e,e=r,this.translate(e,i),this.rotate(s),this.translate(-e,-i)}else this.translate(e,i),this.rotate(t,r),this.translate(-e,-i)},AffineTransform.prototype.quadrantRotate=function(t,r,e){if(void 0===r)switch(3&t){case 0:break;case 1:this.rotate90();break;case 2:this.rotate180();break;case 3:this.rotate270()}else{switch(3&t){case 0:return;case 1:this.m02+=r*(this.m00-this.m01)+e*(this.m01+this.m00),this.m12+=r*(this.m10-this.m11)+e*(this.m11+this.m10),this.rotate90();break;case 2:this.m02+=r*(this.m00+this.m00)+e*(this.m01+this.m01),this.m12+=r*(this.m10+this.m10)+e*(this.m11+this.m11),this.rotate180();break;case 3:this.m02+=r*(this.m00+this.m01)+e*(this.m01-this.m00),this.m12+=r*(this.m10+this.m11)+e*(this.m11-this.m10),this.rotate270()}0===this.m02&&0===this.m12?this.state&=~AffineTransform.APPLY_TRANSLATE:this.state|=AffineTransform.APPLY_TRANSLATE}},AffineTransform.prototype.scale=function(t,r){var e=this.state;switch(e){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:this.m00*=t,this.m11*=r;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SHEAR:return this.m01*=r,this.m10*=t,void(0===this.m01&&0===this.m10&&(e&=AffineTransform.APPLY_TRANSLATE,1===this.m00&&1===this.m11?this.type=e===AffineTransform.APPLY_IDENTITY?AffineTransform.TYPE_IDENTITY:AffineTransform.TYPE_TRANSLATION:(e|=AffineTransform.APPLY_SCALE,this.type=AffineTransform.TYPE_UNKNOWN),this.state=e));case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SCALE:return this.m00*=t,this.m11*=r,void(1===this.m00&&1===this.m11?(this.state=e&=AffineTransform.APPLY_TRANSLATE,this.type=e===AffineTransform.APPLY_IDENTITY?AffineTransform.TYPE_IDENTITY:AffineTransform.TYPE_TRANSLATION):this.type=AffineTransform.TYPE_UNKNOWN);case AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_IDENTITY:return this.m00=t,this.m11=r,void((1!==t||1!==r)&&(this.state=e|AffineTransform.APPLY_SCALE,this.type=AffineTransform.TYPE_UNKNOWN))}},AffineTransform.prototype.shear=function(t,r){var e=this.state;switch(e){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:var i,s;return i=this.m00,s=this.m01,this.m00=i+s*r,this.m01=i*t+s,i=this.m10,s=this.m11,this.m10=i+s*r,this.m11=i*t+s,void this.updateState();
case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SHEAR:return this.m00=this.m01*r,this.m11=this.m10*t,(0!==this.m00||0!==this.m11)&&(this.state=e|AffineTransform.APPLY_SCALE),void(this.type=AffineTransform.TYPE_UNKNOWN);case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SCALE:return this.m01=this.m00*t,this.m10=this.m11*r,(0!==this.m01||0!==this.m10)&&(this.state=e|AffineTransform.APPLY_SHEAR),void(this.type=AffineTransform.TYPE_UNKNOWN);case AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_IDENTITY:return this.m01=t,this.m10=r,void((0!==this.m01||0!==this.m10)&&(this.state=e|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_SHEAR,this.type=AffineTransform.TYPE_UNKNOWN))}},AffineTransform.prototype.setToIdentity=function(){this.m00=this.m11=1,this.m10=this.m01=this.m02=this.m12=0,this.state=AffineTransform.APPLY_IDENTITY,this.type=AffineTransform.TYPE_IDENTITY},AffineTransform.prototype.setToTranslation=function(t,r){this.m00=1,this.m10=0,this.m01=0,this.m11=1,this.m02=t,this.m12=r,0!==t||0!==r?(this.state=AffineTransform.APPLY_TRANSLATE,this.type=AffineTransform.TYPE_TRANSLATION):(this.state=AffineTransform.APPLY_IDENTITY,this.type=AffineTransform.TYPE_IDENTITY)},AffineTransform.prototype.setToRotation=function(t,r,e,i){if(void 0===r){var s,n=t,o=Math.sin(n);1===o||-1===o?(s=0,this.state=AffineTransform.APPLY_SHEAR,this.type=AffineTransform.TYPE_QUADRANT_ROTATION):(s=Math.cos(n),-1===s?(o=0,this.state=AffineTransform.APPLY_SCALE,this.type=AffineTransform.TYPE_QUADRANT_ROTATION):1===s?(o=0,this.state=AffineTransform.APPLY_IDENTITY,this.type=AffineTransform.TYPE_IDENTITY):(this.state=AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE,this.type=AffineTransform.TYPE_GENERAL_ROTATION)),this.m00=s,this.m10=o,this.m01=-o,this.m11=s,this.m02=0,this.m12=0}else if(void 0===e){var o,s;if(0===r)o=0,0>t?(s=-1,this.state=AffineTransform.APPLY_SCALE,this.type=AffineTransform.TYPE_QUADRANT_ROTATION):(s=1,this.state=AffineTransform.APPLY_IDENTITY,this.type=AffineTransform.TYPE_IDENTITY);else if(0===t)s=0,o=r>0?1:-1,this.state=AffineTransform.APPLY_SHEAR,this.type=AffineTransform.TYPE_QUADRANT_ROTATION;else{var f=Math.sqrt(t*t+r*r);s=t/f,o=r/f,this.state=AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE,this.type=AffineTransform.TYPE_GENERAL_ROTATION}this.m00=s,this.m10=o,this.m01=-o,this.m11=s,this.m02=0,this.m12=0}else if(void 0===i){var n=t;i=e,e=r,this.setToRotation(n);var o=this.m10,a=1-this.m00;this.m02=e*a+i*o,this.m12=i*a-e*o,(0!==this.m02||0!==this.m12)&&(this.state|=AffineTransform.APPLY_TRANSLATE,this.type|=AffineTransform.TYPE_TRANSLATION)}else{this.setToRotation(t,r);var o=this.m10,a=1-this.m00;this.m02=e*a+i*o,this.m12=i*a-e*o,(0!==this.m02||0!==this.m12)&&(this.state|=AffineTransform.APPLY_TRANSLATE,this.type|=AffineTransform.TYPE_TRANSLATION)}},AffineTransform.prototype.setToQuadrantRotation=function(t,r,e){if(void 0===r)switch(3&t){case 0:this.m00=1,this.m10=0,this.m01=0,this.m11=1,this.m02=0,this.m12=0,this.state=AffineTransform.APPLY_IDENTITY,this.type=AffineTransform.TYPE_IDENTITY;break;case 1:this.m00=0,this.m10=1,this.m01=-1,this.m11=0,this.m02=0,this.m12=0,this.state=AffineTransform.APPLY_SHEAR,this.type=AffineTransform.TYPE_QUADRANT_ROTATION;break;case 2:this.m00=-1,this.m10=0,this.m01=0,this.m11=-1,this.m02=0,this.m12=0,this.state=AffineTransform.APPLY_SCALE,this.type=AffineTransform.TYPE_QUADRANT_ROTATION;break;case 3:this.m00=0,this.m10=-1,this.m01=1,this.m11=0,this.m02=0,this.m12=0,this.state=AffineTransform.APPLY_SHEAR,this.type=AffineTransform.TYPE_QUADRANT_ROTATION}else switch(3&t){case 0:this.m00=1,this.m10=0,this.m01=0,this.m11=1,this.m02=0,this.m12=0,state=AffineTransform.APPLY_IDENTITY,type=AffineTransform.TYPE_IDENTITY;break;case 1:this.m00=0,this.m10=1,this.m01=-1,this.m11=0,this.m02=r+e,this.m12=e-r,0===this.m02&&0===this.m12?(this.state=AffineTransform.APPLY_SHEAR,this.type=AffineTransform.TYPE_QUADRANT_ROTATION):(this.state=AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE,this.type=AffineTransform.TYPE_QUADRANT_ROTATION|AffineTransform.TYPE_TRANSLATION);break;case 2:this.m00=-1,this.m10=0,this.m01=0,this.m11=-1,this.m02=r+r,this.m12=e+e,0===this.m02&&0===this.m12?(this.state=AffineTransform.APPLY_SCALE,this.type=AffineTransform.TYPE_QUADRANT_ROTATION):(this.state=AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE,this.type=AffineTransform.TYPE_QUADRANT_ROTATION|AffineTransform.TYPE_TRANSLATION);break;case 3:this.m00=0,this.m10=-1,this.m01=1,this.m11=0,this.m02=r-e,this.m12=e+r,0===this.m02&&0===this.m12?(this.state=AffineTransform.APPLY_SHEAR,this.type=AffineTransform.TYPE_QUADRANT_ROTATION):(this.state=AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE,this.type=AffineTransform.TYPE_QUADRANT_ROTATION|AffineTransform.TYPE_TRANSLATION)}},AffineTransform.prototype.setToScale=function(t,r){this.m00=t,this.m10=0,this.m01=0,this.m11=r,this.m02=0,this.m12=0,1!==t||1!==r?(this.state=AffineTransform.APPLY_SCALE,this.type=AffineTransform.TYPE_UNKNOWN):(this.state=AffineTransform.APPLY_IDENTITY,this.type=AffineTransform.TYPE_IDENTITY)},AffineTransform.prototype.setToShear=function(t,r){this.m00=1,this.m01=t,this.m10=r,this.m11=1,this.m02=0,this.m12=0,0!==t||0!==r?(this.state=AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE,this.type=AffineTransform.TYPE_UNKNOWN):(this.state=AffineTransform.APPLY_IDENTITY,this.type=AffineTransform.TYPE_IDENTITY)},AffineTransform.prototype.setTransform=function(t,r,e,i,s,n){if(t instanceof AffineTransform){var o=t;this.m00=o.m00,this.m10=o.m10,this.m01=o.m01,this.m11=o.m11,this.m02=o.m02,this.m12=o.m12,this.state=o.state,this.type=o.type}else this.m00=t,this.m10=r,this.m01=e,this.m11=i,this.m02=s,this.m12=n,this.updateState()},AffineTransform.prototype.concatenate=function(t){var r,e,i,s,n,o,f,a,h=this.state,u=t.state;switch(u<<AffineTransform.HI_SHIFT|h){case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_IDENTITY:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_SCALE:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_SHEAR:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:return;case AffineTransform.HI_SHEAR|AffineTransform.HI_SCALE|AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_IDENTITY:this.m01=t.m01,this.m10=t.m10;case AffineTransform.HI_SCALE|AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_IDENTITY:this.m00=t.m00,this.m11=t.m11;case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_IDENTITY:return this.m02=t.m02,this.m12=t.m12,this.state=u,void(this.type=t.type);case AffineTransform.HI_SHEAR|AffineTransform.HI_SCALE|AffineTransform.APPLY_IDENTITY:this.m01=t.m01,this.m10=t.m10;case AffineTransform.HI_SCALE|AffineTransform.APPLY_IDENTITY:return this.m00=t.m00,this.m11=t.m11,this.state=u,void(this.type=t.type);case AffineTransform.HI_SHEAR|AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_IDENTITY:this.m02=t.m02,this.m12=t.m12;case AffineTransform.HI_SHEAR|AffineTransform.APPLY_IDENTITY:return this.m01=t.m01,this.m10=t.m10,this.m00=this.m11=0,this.state=u,void(this.type=t.type);case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_SHEAR:case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_SCALE:case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_TRANSLATE:return void this.translate(t.m02,t.m12);case AffineTransform.HI_SCALE|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SCALE|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:case AffineTransform.HI_SCALE|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SCALE|AffineTransform.APPLY_SHEAR:case AffineTransform.HI_SCALE|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SCALE|AffineTransform.APPLY_SCALE:case AffineTransform.HI_SCALE|AffineTransform.APPLY_TRANSLATE:return void this.scale(t.m00,t.m11);case AffineTransform.HI_SHEAR|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SHEAR|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:return s=t.m01,n=t.m10,r=this.m00,this.m00=this.m01*n,this.m01=r*s,r=this.m10,this.m10=this.m11*n,this.m11=r*s,void(this.type=AffineTransform.TYPE_UNKNOWN);case AffineTransform.HI_SHEAR|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SHEAR|AffineTransform.APPLY_SHEAR:return this.m00=this.m01*t.m10,this.m01=0,this.m11=this.m10*t.m01,this.m10=0,this.state=h^(AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE),void(this.type=AffineTransform.TYPE_UNKNOWN);case AffineTransform.HI_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SHEAR|AffineTransform.APPLY_SCALE:return this.m01=this.m00*t.m01,this.m00=0,this.m10=this.m11*t.m10,this.m11=0,this.state=h^(AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE),void(this.type=AffineTransform.TYPE_UNKNOWN);case AffineTransform.HI_SHEAR|AffineTransform.APPLY_TRANSLATE:return this.m00=0,this.m01=t.m01,this.m10=t.m10,this.m11=0,this.state=AffineTransform.APPLY_TRANSLATE|AffineTransform.APPLY_SHEAR,void(this.type=AffineTransform.TYPE_UNKNOWN)}switch(i=t.m00,s=t.m01,f=t.m02,n=t.m10,o=t.m11,a=t.m12,h){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:this.state=h|u;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:return r=this.m00,e=this.m01,this.m00=i*r+n*e,this.m01=s*r+o*e,this.m02+=f*r+a*e,r=this.m10,e=this.m11,this.m10=i*r+n*e,this.m11=s*r+o*e,this.m12+=f*r+a*e,void(this.type=AffineTransform.TYPE_UNKNOWN);case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SHEAR:r=this.m01,this.m00=n*r,this.m01=o*r,this.m02+=a*r,r=this.m10,this.m10=i*r,this.m11=s*r,this.m12+=f*r;break;case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SCALE:r=this.m00,this.m00=i*r,this.m01=s*r,this.m02+=f*r,r=this.m11,this.m10=n*r,this.m11=o*r,this.m12+=a*r;break;case AffineTransform.APPLY_TRANSLATE:return this.m00=i,this.m01=s,this.m02+=f,this.m10=n,this.m11=o,this.m12+=a,this.state=u|AffineTransform.APPLY_TRANSLATE,void(this.type=AffineTransform.TYPE_UNKNOWN)}this.updateState()},AffineTransform.prototype.preConcatenate=function(t){var r,e,i,s,n,o,f,a,h=this.state,u=t.state;switch(u<<AffineTransform.HI_SHIFT|h){case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_IDENTITY:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_SCALE:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_SHEAR:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:case AffineTransform.HI_IDENTITY|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:return;case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_IDENTITY:case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_SCALE:case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_SHEAR:case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:return this.m02=t.m02,this.m12=t.m12,this.state=h|AffineTransform.APPLY_TRANSLATE,void(this.type|=AffineTransform.TYPE_TRANSLATION);case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_TRANSLATE|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:return this.m02=this.m02+t.m02,void(this.m12=this.m12+t.m12);case AffineTransform.HI_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SCALE|AffineTransform.APPLY_IDENTITY:this.state=h|AffineTransform.APPLY_SCALE;case AffineTransform.HI_SCALE|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SCALE|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:case AffineTransform.HI_SCALE|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SCALE|AffineTransform.APPLY_SHEAR:case AffineTransform.HI_SCALE|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SCALE|AffineTransform.APPLY_SCALE:return i=t.m00,o=t.m11,0!==(h&AffineTransform.APPLY_SHEAR)?(this.m01=this.m01*i,this.m10=this.m10*o,0!==(h&AffineTransform.APPLY_SCALE)&&(this.m00=this.m00*i,this.m11=this.m11*o)):(this.m00=this.m00*i,this.m11=this.m11*o),0!==(h&AffineTransform.APPLY_TRANSLATE)&&(this.m02=this.m02*i,this.m12=this.m12*o),void(this.type=AffineTransform.TYPE_UNKNOWN);case AffineTransform.HI_SHEAR|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SHEAR|AffineTransform.APPLY_SHEAR:h|=AffineTransform.APPLY_SCALE;case AffineTransform.HI_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SHEAR|AffineTransform.APPLY_IDENTITY:case AffineTransform.HI_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SHEAR|AffineTransform.APPLY_SCALE:this.state=h^AffineTransform.APPLY_SHEAR;case AffineTransform.HI_SHEAR|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.HI_SHEAR|AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:return s=t.m01,n=t.m10,r=this.m00,this.m00=this.m10*s,this.m10=r*n,r=this.m01,this.m01=this.m11*s,this.m11=r*n,r=this.m02,this.m02=this.m12*s,this.m12=r*n,void(this.type=AffineTransform.TYPE_UNKNOWN)}switch(i=t.m00,s=t.m01,f=t.m02,n=t.m10,o=t.m11,a=t.m12,h){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:r=this.m02,e=this.m12,f+=r*i+e*s,a+=r*n+e*o;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:this.m02=f,this.m12=a,r=this.m00,e=this.m10,this.m00=r*i+e*s,this.m10=r*n+e*o,r=this.m01,e=this.m11,this.m01=r*i+e*s,this.m11=r*n+e*o;break;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:r=this.m02,e=this.m12,f+=r*i+e*s,a+=r*n+e*o;case AffineTransform.APPLY_SHEAR:this.m02=f,this.m12=a,r=this.m10,this.m00=r*s,this.m10=r*o,r=this.m01,this.m01=r*i,this.m11=r*n;break;case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:r=this.m02,e=this.m12,f+=r*i+e*s,a+=r*n+e*o;case AffineTransform.APPLY_SCALE:this.m02=f,this.m12=a,r=this.m00,this.m00=r*i,this.m10=r*n,r=this.m11,this.m01=r*s,this.m11=r*o;break;case AffineTransform.APPLY_TRANSLATE:r=this.m02,e=this.m12,f+=r*i+e*s,a+=r*n+e*o;case AffineTransform.APPLY_IDENTITY:return this.m02=f,this.m12=a,this.m00=i,this.m10=n,this.m01=s,this.m11=o,this.state=h|u,void(this.type=AffineTransform.TYPE_UNKNOWN)}this.updateState()},AffineTransform.prototype.createInverse=function(){var t;switch(this.state){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:if(t=this.m00*this.m11-this.m01*this.m10,Math.abs(t)<=Double.MIN_VALUE)throw new NoninvertibleTransformException("Determinant is "+t);return new AffineTransform(this.m11/t,-this.m10/t,-this.m01/t,this.m00/t,(this.m01*this.m12-this.m11*this.m02)/t,(this.m10*this.m02-this.m00*this.m12)/t,AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE);case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:if(t=this.m00*this.m11-this.m01*this.m10,Math.abs(t)<=Double.MIN_VALUE)throw new NoninvertibleTransformException("Determinant is "+t);return new AffineTransform(this.m11/t,-this.m10/t,-this.m01/t,this.m00/t,0,0,AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE);case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:if(0===this.m01||0===this.m10)throw new NoninvertibleTransformException("Determinant is 0");return new AffineTransform(0,1/this.m01,1/this.m10,0,-this.m12/this.m10,-this.m02/this.m01,AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE);case AffineTransform.APPLY_SHEAR:if(0===this.m01||0===this.m10)throw new NoninvertibleTransformException("Determinant is 0");return new AffineTransform(0,1/this.m01,1/this.m10,0,0,0,AffineTransform.APPLY_SHEAR);case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:if(0===this.m00||0===this.m11)throw new NoninvertibleTransformException("Determinant is 0");return new AffineTransform(1/this.m00,0,0,1/this.m11,-this.m02/this.m00,-this.m12/this.m11,AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE);case AffineTransform.APPLY_SCALE:if(0===this.m00||0===this.m11)throw new NoninvertibleTransformException("Determinant is 0");return new AffineTransform(1/this.m00,0,0,1/this.m11,0,0,AffineTransform.APPLY_SCALE);case AffineTransform.APPLY_TRANSLATE:return new AffineTransform(1,0,0,1,-this.m02,-this.m12,AffineTransform.APPLY_TRANSLATE);case AffineTransform.APPLY_IDENTITY:return new AffineTransform}},AffineTransform.prototype.invert=function(){var t,r,e,i,s,n,o;switch(state){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:if(t=this.m00,r=this.m01,e=this.m02,i=this.m10,s=this.m11,n=this.m12,o=t*s-r*i,Math.abs(o)<=Double.MIN_VALUE)throw new NoninvertibleTransformException("Determinant is "+o);this.m00=s/o,this.m10=-i/o,this.m01=-r/o,this.m11=t/o,this.m02=(r*n-s*e)/o,this.m12=(i*e-t*n)/o;break;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:if(t=this.m00,r=this.m01,i=this.m10,s=this.m11,o=t*s-r*i,Math.abs(o)<=Double.MIN_VALUE)throw new NoninvertibleTransformException("Determinant is "+o);this.m00=s/o,this.m10=-i/o,this.m01=-r/o,this.m11=t/o;break;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:if(r=this.m01,e=this.m02,i=this.m10,n=this.m12,0===r||0===i)throw new NoninvertibleTransformException("Determinant is 0");this.m10=1/r,this.m01=1/i,this.m02=-n/i,this.m12=-e/r;break;case AffineTransform.APPLY_SHEAR:if(r=this.m01,i=this.m10,0===r||0===i)throw new NoninvertibleTransformException("Determinant is 0");this.m10=1/r,this.m01=1/i;break;case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:if(t=this.m00,e=this.m02,s=this.m11,n=this.m12,0===t||0===s)throw new NoninvertibleTransformException("Determinant is 0");this.m00=1/t,this.m11=1/s,this.m02=-e/t,this.m12=-n/s;break;case AffineTransform.APPLY_SCALE:if(t=this.m00,s=this.m11,0===t||0===s)throw new NoninvertibleTransformException("Determinant is 0");this.m00=1/t,this.m11=1/s;break;case AffineTransform.APPLY_TRANSLATE:this.m02=-this.m02,this.m12=-this.m12;break;case AffineTransform.APPLY_IDENTITY:}},AffineTransform.prototype.transform=function(t,r,e,i,s){if(t instanceof Point2D){var n=t,o=r;null===o&&(o=new Point2D);var f=n.getX(),a=n.getY();switch(this.state){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:return o.setLocation(f*this.m00+a*this.m01+this.m02,f*this.m10+a*this.m11+this.m12),o;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:return o.setLocation(f*this.m00+a*this.m01,f*this.m10+a*this.m11),o;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:return o.setLocation(a*this.m01+this.m02,f*this.m10+this.m12),o;case AffineTransform.APPLY_SHEAR:return o.setLocation(a*this.m01,f*this.m10),o;case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:return o.setLocation(f*this.m00+this.m02,a*this.m11+this.m12),o;case AffineTransform.APPLY_SCALE:return o.setLocation(f*this.m00,a*this.m11),o;case AffineTransform.APPLY_TRANSLATE:return o.setLocation(f+this.m02,a+this.m12),o;case AffineTransform.APPLY_IDENTITY:return o.setLocation(f,a),o}}else if(t[0]instanceof Point2D)for(var n=t,o=e,h=this.state;--s>=0;){var u=n[r++],f=u.getX(),a=u.getY(),A=o[i++];switch(null===A&&(A=new Point2D,o[i-1]=A),h){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:A.setLocation(f*this.m00+a*this.m01+this.m02,f*this.m10+a*this.m11+this.m12);break;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:A.setLocation(f*this.m00+a*this.m01,f*this.m10+a*this.m11);break;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:A.setLocation(a*this.m01+this.m02,f*this.m10+this.m12);break;case AffineTransform.APPLY_SHEAR:A.setLocation(a*this.m01,f*this.m10);break;case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:A.setLocation(f*this.m00+this.m02,a*this.m11+this.m12);break;case AffineTransform.APPLY_SCALE:A.setLocation(f*this.m00,a*this.m11);break;case AffineTransform.APPLY_TRANSLATE:A.setLocation(f+this.m02,a+this.m12);break;case AffineTransform.APPLY_IDENTITY:A.setLocation(f,a)}}else{var T,c,m,p,E,P;switch(e===t&&i>r&&r+2*s>i&&(System.arraycopy(t,r,e,i,2*s),r=i),this.state){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:for(T=this.m00,c=this.m01,m=this.m02,p=this.m10,E=this.m11,P=this.m12;--s>=0;){var f=t[r++],a=t[r++];e[i++]=T*f+c*a+m,e[i++]=p*f+E*a+P}return;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:for(T=this.m00,c=this.m01,p=this.m10,E=this.m11;--s>=0;){var f=t[r++],a=t[r++];e[i++]=T*f+c*a,e[i++]=p*f+E*a}return;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:for(c=this.m01,m=this.m02,p=this.m10,P=this.m12;--s>=0;){var f=t[r++];e[i++]=c*t[r++]+m,e[i++]=p*f+P}return;case AffineTransform.APPLY_SHEAR:for(c=this.m01,p=this.m10;--s>=0;){var f=t[r++];e[i++]=c*t[r++],e[i++]=p*f}return;case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:for(T=this.m00,m=this.m02,E=this.m11,P=this.m12;--s>=0;)e[i++]=T*t[r++]+m,e[i++]=E*t[r++]+P;return;case AffineTransform.APPLY_SCALE:for(T=this.m00,E=this.m11;--s>=0;)e[i++]=T*t[r++],e[i++]=E*t[r++];return;case AffineTransform.APPLY_TRANSLATE:for(m=this.m02,P=this.m12;--s>=0;)e[i++]=t[r++]+m,e[i++]=t[r++]+P;return;case AffineTransform.APPLY_IDENTITY:return void((t!==e||r!==i)&&System.arraycopy(t,r,e,i,2*s))}}},AffineTransform.prototype.inverseTransform=function(t,r,e,i,s){if(void 0===e){var n=t,o=r;null===o&&(o=new Point2D);var f=n.getX(),a=n.getY();switch(this.state){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:f-=this.m02,a-=this.m12;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:var h=this.m00*this.m11-this.m01*this.m10;if(Math.abs(h)<=Double.MIN_VALUE)throw new NoninvertibleTransformException("Determinant is "+h);return o.setLocation((f*this.m11-a*this.m01)/h,(a*this.m00-f*this.m10)/h),o;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:f-=this.m02,a-=this.m12;case AffineTransform.APPLY_SHEAR:if(0===this.m01||0===this.m10)throw new NoninvertibleTransformException("Determinant is 0");return o.setLocation(a/this.m10,f/this.m01),o;case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:f-=this.m02,a-=this.m12;case AffineTransform.APPLY_SCALE:if(0===this.m00||0===this.m11)throw new NoninvertibleTransformException("Determinant is 0");return o.setLocation(f/this.m00,a/this.m11),o;case AffineTransform.APPLY_TRANSLATE:return o.setLocation(f-this.m02,a-this.m12),o;case AffineTransform.APPLY_IDENTITY:return o.setLocation(f,a),o}}else{var u,A,T,c,m,p,h;switch(e===t&&i>r&&r+2*s>i&&(System.arraycopy(t,r,e,i,2*s),r=i),this.state){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:if(u=this.m00,A=this.m01,T=this.m02,c=this.m10,m=this.m11,p=this.m12,h=u*m-A*c,Math.abs(h)<=Double.MIN_VALUE)throw new NoninvertibleTransformException("Determinant is "+h);for(;--s>=0;){var f=t[r++]-T,a=t[r++]-p;e[i++]=(f*m-a*A)/h,e[i++]=(a*u-f*c)/h}return;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:if(u=this.m00,A=this.m01,c=this.m10,m=this.m11,h=u*m-A*c,Math.abs(h)<=Double.MIN_VALUE)throw new NoninvertibleTransformException("Determinant is "+h);for(;--s>=0;){var f=t[r++],a=t[r++];e[i++]=(f*m-a*A)/h,e[i++]=(a*u-f*c)/h}return;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:if(A=this.m01,T=this.m02,c=this.m10,p=this.m12,0===A||0===c)throw new NoninvertibleTransformException("Determinant is 0");for(;--s>=0;){var f=t[r++]-T;e[i++]=(t[r++]-p)/c,e[i++]=f/A}return;case AffineTransform.APPLY_SHEAR:if(A=this.m01,c=this.m10,0===A||0===c)throw new NoninvertibleTransformException("Determinant is 0");for(;--s>=0;){var f=t[r++];e[i++]=t[r++]/c,e[i++]=f/A}return;case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:if(u=this.m00,T=this.m02,m=this.m11,p=this.m12,0===u||0===m)throw new NoninvertibleTransformException("Determinant is 0");for(;--s>=0;)e[i++]=(t[r++]-T)/u,e[i++]=(t[r++]-p)/m;return;case AffineTransform.APPLY_SCALE:if(u=this.m00,m=this.m11,0===u||0===m)throw new NoninvertibleTransformException("Determinant is 0");for(;--s>=0;)e[i++]=t[r++]/u,e[i++]=t[r++]/m;return;case AffineTransform.APPLY_TRANSLATE:for(T=this.m02,p=this.m12;--s>=0;)e[i++]=t[r++]-T,e[i++]=t[r++]-p;return;case AffineTransform.APPLY_IDENTITY:return void((t!==e||r!==i)&&System.arraycopy(t,r,e,i,2*s))}}},AffineTransform.prototype.deltaTransform=function(t,r,e,i,s){if(void 0===e){var n=t,o=r;null===o&&(o=new Point2D);var f=n.getX(),a=n.getY();switch(this.state){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:return o.setLocation(f*this.m00+a*this.m01,f*this.m10+a*this.m11),o;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SHEAR:return o.setLocation(a*this.m01,f*this.m10),o;case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SCALE:return o.setLocation(f*this.m00,a*this.m11),o;case AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_IDENTITY:return o.setLocation(f,a),o}}else{var h,u,A,T;switch(e===t&&i>r&&r+2*s>i&&(System.arraycopy(t,r,e,i,2*s),r=i),this.state){default:this.stateError();case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_SCALE:for(h=this.m00,u=this.m01,A=this.m10,T=this.m11;--s>=0;){var f=t[r++],a=t[r++];e[i++]=f*h+a*u,e[i++]=f*A+a*T}return;case AffineTransform.APPLY_SHEAR|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SHEAR:for(u=this.m01,A=this.m10;--s>=0;){var f=t[r++];e[i++]=t[r++]*u,e[i++]=f*A}return;case AffineTransform.APPLY_SCALE|AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_SCALE:for(h=this.m00,T=this.m11;--s>=0;)e[i++]=t[r++]*h,e[i++]=t[r++]*T;return;case AffineTransform.APPLY_TRANSLATE:case AffineTransform.APPLY_IDENTITY:return void((t!==e||r!==i)&&System.arraycopy(t,r,e,i,2*s))}}},AffineTransform.prototype.createTransformedShape=function(t){return null===t?null:new Path2D(t,this)},AffineTransform.prototype.isIdentity=function(){return this.state===AffineTransform.APPLY_IDENTITY||this.getType()===AffineTransform.TYPE_IDENTITY},AffineTransform.prototype.clone=function(){return new AffineTransform(this)},AffineTransform.prototype.equals=function(t){return t instanceof AffineTransform?this.m00===t.m00&&this.m01===t.m01&&this.m02===t.m02&&this.m10===t.m10&&this.m11===t.m11&&this.m12===t.m12:!1},Point2D.INIT_SIZE=20,Point2D.EXPAND_MAX=500,Path2D.prototype.cloneCoordsFloat=function(t){var r;return null===t?r=this.pointCoords.splice(0):(r=new Array(this.pointCoords.length),t.transform(this.pointCoords,0,r,0,this.numCoords/2)),r},Path2D.prototype.append=function(t,r){if(t instanceof PathIterator)for(var e=t,i=new Array(6);!e.isDone();){switch(e.currentSegment(i)){case PathIterator.SEG_MOVETO:if(!r||this.numTypes<1||this.numCoords<1){this.moveTo(i[0],i[1]);break}if(this.pointTypes[this.numTypes-1]!==PathIterator.SEG_CLOSE&&this.pointCoords[this.numCoords-2]===i[0]&&this.pointCoords[this.numCoords-1]===i[1])break;this.lineTo(i[0],i[1]);break;case PathIterator.SEG_LINETO:this.lineTo(i[0],i[1]);break;case PathIterator.SEG_QUADTO:this.quadTo(i[0],i[1],i[2],i[3]);break;case PathIterator.SEG_CUBICTO:this.curveTo(i[0],i[1],i[2],i[3],i[4],i[5]);break;case PathIterator.SEG_CLOSE:this.closePath()}e.next(),r=!1}else if("object"==typeof t)this.append(t.getPathIterator(null),r);else{var s=t,n=r;this.pointCoords[this.numCoords++]=s,this.pointCoords[this.numCoords++]=n}},Point2D.prototype.getPoint=function(t){return new Point2D(this.pointCoords[t],this.pointCoords[t+1])},Path2D.prototype.needRoom=function(t,r){if(t&&0===this.numTypes)throw new IllegalPathStateException("missing initial moveto in path definition");var e=this.pointTypes.length;if(this.numTypes>=e){var i=e;i>Point2D.EXPAND_MAX&&(i=Point2D.EXPAND_MAX),this.pointTypes.push.apply(this.pointTypes,new Array(i))}if(e=this.pointCoords.length,this.numCoords+r>e){var i=e;i>2*Point2D.EXPAND_MAX&&(i=2*Point2D.EXPAND_MAX),r>i&&(i=r),this.pointCoords.push.apply(this.pointCoords,new Array(i))}},Path2D.prototype.moveTo=function(t,r){this.numTypes>0&&this.pointTypes[this.numTypes-1]===PathIterator.SEG_MOVETO?(this.pointCoords[this.numCoords-2]=t,this.pointCoords[this.numCoords-1]=r):(this.needRoom(!1,2),this.pointTypes[this.numTypes++]=PathIterator.SEG_MOVETO,this.pointCoords[this.numCoords++]=t,this.pointCoords[this.numCoords++]=r)},Path2D.prototype.lineTo=function(t,r){this.needRoom(!0,2),this.pointTypes[this.numTypes++]=PathIterator.SEG_LINETO,this.pointCoords[this.numCoords++]=t,this.pointCoords[this.numCoords++]=r},Path2D.prototype.quadTo=function(t,r,e,i){this.needRoom(!0,4),this.pointTypes[this.numTypes++]=PathIterator.SEG_QUADTO,this.pointCoords[this.numCoords++]=t,this.pointCoords[this.numCoords++]=r,this.pointCoords[this.numCoords++]=e,this.pointCoords[this.numCoords++]=i},Path2D.prototype.curveTo=function(t,r,e,i,s,n){this.needRoom(!0,6),this.pointTypes[this.numTypes++]=PathIterator.SEG_CUBICTO,this.pointCoords[this.numCoords++]=t,this.pointCoords[this.numCoords++]=r,this.pointCoords[this.numCoords++]=e,this.pointCoords[this.numCoords++]=i,this.pointCoords[this.numCoords++]=s,this.pointCoords[this.numCoords++]=n},Path2D.prototype.pointCrossings=function(t,r){var e,i,s,n,o,f,a=this.pointCoords;s=e=a[0],n=i=a[1];for(var h=0,u=2,A=1;A<this.numTypes;A++)switch(this.pointTypes[A]){case PathIterator.SEG_MOVETO:n!==i&&(h+=Curve.pointCrossingsForLine(t,r,s,n,e,i)),e=s=a[u++],i=n=a[u++];break;case PathIterator.SEG_LINETO:h+=Curve.pointCrossingsForLine(t,r,s,n,o=a[u++],f=a[u++]),s=o,n=f;break;case PathIterator.SEG_QUADTO:h+=Curve.pointCrossingsForQuad(t,r,s,n,a[u++],a[u++],o=a[u++],f=a[u++],0),s=o,n=f;break;case PathIterator.SEG_CUBICTO:h+=Curve.pointCrossingsForCubic(t,r,s,n,a[u++],a[u++],a[u++],a[u++],o=a[u++],f=a[u++],0),s=o,n=f;break;case PathIterator.SEG_CLOSE:n!==i&&(h+=Curve.pointCrossingsForLine(t,r,s,n,e,i)),s=e,n=i}return n!==i&&(h+=Curve.pointCrossingsForLine(t,r,s,n,e,i)),h},Path2D.prototype.rectCrossings=function(t,r,e,i){var s,n,o,f,a,h,u=this.pointCoords;
s=o=u[0],n=f=u[1];for(var A=0,T=2,c=1;A!==Curve.RECT_INTERSECTS&&c<this.numTypes;c++)switch(this.pointTypes[c]){case PathIterator.SEG_MOVETO:(s!==o||n!==f)&&(A=Curve.rectCrossingsForLine(A,t,r,e,i,s,n,o,f)),o=s=u[T++],f=n=u[T++];break;case PathIterator.SEG_LINETO:A=Curve.rectCrossingsForLine(A,t,r,e,i,s,n,a=u[T++],h=u[T++]),s=a,n=h;break;case PathIterator.SEG_QUADTO:A=Curve.rectCrossingsForQuad(A,t,r,e,i,s,n,u[T++],u[T++],a=u[T++],h=u[T++],0),s=a,n=h;break;case PathIterator.SEG_CUBICTO:A=Curve.rectCrossingsForCubic(A,t,r,e,i,s,n,u[T++],u[T++],u[T++],u[T++],a=u[T++],h=u[T++],0),s=a,n=h;break;case PathIterator.SEG_CLOSE:(s!==o||n!==f)&&(A=Curve.rectCrossingsForLine(A,t,r,e,i,s,n,o,f)),s=o,n=f}return A===Curve.RECT_INTERSECTS||s===o&&n===f||(A=Curve.rectCrossingsForLine(A,t,r,e,i,s,n,o,f)),A},Path2D.prototype.transform=function(t){t.transform(this.pointCoords,0,this.pointCoords,0,this.numCoords/2)},Path2D.prototype.getBounds2D=function(){var t,r,e,i,s=this.numCoords;if(s>0)for(r=i=this.pointCoords[--s],t=e=this.pointCoords[--s];s>0;){var n=this.pointCoords[--s],o=this.pointCoords[--s];t>o&&(t=o),r>n&&(r=n),o>e&&(e=o),n>i&&(i=n)}else t=r=e=i=0;return new Rectangle2D(t,r,e-t,i-r)},Path2D.prototype.closePath=function(){(0===this.numTypes||this.pointTypes[this.numTypes-1]!==PathIterator.SEG_CLOSE)&&(this.needRoom(!0,0),this.pointTypes[this.numTypes++]=PathIterator.SEG_CLOSE)},Path2D.prototype.getWindingRule=function(){return this.windingRule},Path2D.prototype.setWindingRule=function(t){if(t!==PathIterator.WIND_EVEN_ODD&&t!==PathIterator.WIND_NON_ZERO)throw new IllegalArgumentException("winding rule must be WIND_EVEN_ODD or WIND_NON_ZERO");this.windingRule=t},Path2D.prototype.getCurrentPoint=function(){var t=this.numCoords;if(this.numTypes<1||1>t)return null;if(this.pointTypes[this.numTypes-1]===PathIterator.SEG_CLOSE)t:for(var r=this.numTypes-2;r>0;r--)switch(this.pointTypes[r]){case PathIterator.SEG_MOVETO:break t;case PathIterator.SEG_LINETO:t-=2;break;case PathIterator.SEG_QUADTO:t-=4;break;case PathIterator.SEG_CUBICTO:t-=6;break;case PathIterator.SEG_CLOSE:}return this.getPoint(t-2)},Path2D.prototype.reset=function(){this.numTypes=this.numCoords=0},Path2D.prototype.createTransformedShape=function(t){var r=this.clone();return null!=t&&r.transform(t),r},Path2D.contains=function(t,r,e,i,s){if(void 0===e){if(r instanceof Rectangle2D){var n=r;return Path2D.contains(t,n.getX(),n.getY(),n.getWidth(),n.getHeight())}var o=r;return Path2D.contains(t,o.getX(),o.getY())}if(void 0===i){if(0*r+0*e===0){var f=t.getWindingRule()===PathIterator.WIND_NON_ZERO?-1:1,a=Curve.pointCrossingsForPath(t,r,e);return 0!==(a&f)}return!1}if(isNaN(r+i)||isNaN(e+s))return!1;if(0>=i||0>=s)return!1;var f=t.getWindingRule()===PathIterator.WIND_NON_ZERO?-1:2,h=Curve.rectCrossingsForPath(t,r,e,r+i,e+s);return h!==Curve.RECT_INTERSECTS&&0!==(h&f)},Path2D.prototype.contains=function(t,r,e,i){if(void 0===r){if(t instanceof Rectangle2D){var s=t;return this.contains(s.getX(),s.getY(),s.getWidth(),s.getHeight())}var n=t;return this.contains(n.getX(),n.getY())}if(void 0===e){if(0*t+0*r===0){if(this.numTypes<2)return!1;var o=this.windingRule===PathIterator.WIND_NON_ZERO?-1:1;return 0!==(this.pointCrossings(t,r)&o)}return!1}if(isNaN(t+e)||isNaN(r+i))return!1;if(0>=e||0>=i)return!1;var o=this.windingRule===PathIterator.WIND_NON_ZERO?-1:2,f=this.rectCrossings(t,r,t+e,r+i);return f!==Curve.RECT_INTERSECTS&&0!==(f&o)},Path2D.intersects=function(t,r,e,i,s){if(void 0===e){var n=r;return Path2D.intersects(t,n.getX(),n.getY(),n.getWidth(),n.getHeight())}if(isNaN(r+i)||isNaN(e+s))return!1;if(0>=i||0>=s)return!1;var o=t.getWindingRule()===PathIterator.WIND_NON_ZERO?-1:2,f=Curve.rectCrossingsForPath(t,r,e,r+i,e+s);return f===Curve.RECT_INTERSECTS||0!==(f&o)},Path2D.prototype.intersects=function(t,r,e,i){if(void 0===r){var s=r;return this.intersects(s.getX(),s.getY(),s.getWidth(),s.getHeight())}if(void 0===i){if(isNaN(t+e)||isNaN(r+i))return!1;if(0>=e||0>=i)return!1;var n=this.windingRule===PathIterator.WIND_NON_ZERO?-1:2,o=this.rectCrossings(t,r,t+e,r+i);return o===Curve.RECT_INTERSECTS||0!==(o&n)}},Path2D.prototype.getPathIterator=function(t,r){return void 0===r?null===t?new Path2DCopyIterator(this):new Path2DTxIterator(this,t):new FlatteningPathIterator(this.getPathIterator(t),r)},Path2D.prototype.clone=function(){return this instanceof GeneralPath?new GeneralPath(this):new Path2D(this)},Path2DIterator.prototype=Object.create(PathIterator.prototype),Path2DIterator.prototype.constructor=Path2DIterator,Path2DIterator.curvecoords=[2,2,4,6,0],Path2DIterator.prototype.getWindingRule=function(){return this.path.getWindingRule()},Path2DIterator.prototype.isDone=function(){return this.typeIdx>=this.path.numTypes},Path2DIterator.prototype.next=function(){var t=this.path.pointTypes[this.typeIdx++];this.pointIdx+=Path2DIterator.curvecoords[t]},Path2DCopyIterator.prototype=Object.create(Path2DIterator.prototype),Path2DCopyIterator.prototype.constructor=Path2DCopyIterator,Path2DCopyIterator.prototype.currentSegment=function(t){var r=this.path.pointTypes[this.typeIdx],e=Path2DIterator.curvecoords[r];return e>0&&System.arraycopy(this.pointCoords,this.pointIdx,t,0,e),r},Path2DTxIterator.prototype=Object.create(Path2DIterator.prototype),Path2DTxIterator.prototype.constructor=Path2DTxIterator,Path2DTxIterator.prototype.currentSegment=function(t){var r=this.path.pointTypes[this.typeIdx],e=Path2DIterator.curvecoords[r];return e>0&&this.affine.transform(this.pointCoords,this.pointIdx,t,0,e/2),r},FlatteningPathIterator.prototype=Object.create(PathIterator.prototype),FlatteningPathIterator.prototype.constructor=FlatteningPathIterator,FlatteningPathIterator.GROW_SIZE=24,FlatteningPathIterator.prototype.getFlatness=function(){return Math.sqrt(this.squareflat)},FlatteningPathIterator.prototype.getRecursionLimit=function(){return this.limit},FlatteningPathIterator.prototype.getWindingRule=function(){return this.src.getWindingRule()},FlatteningPathIterator.prototype.isDone=function(){return this.done},FlatteningPathIterator.prototype.ensureHoldCapacity=function(t){if(this.holdIndex-t<0){var r=this.hold.length-this.holdIndex,e=this.hold.length+FlatteningPathIterator.GROW_SIZE,i=new Array(e);System.arraycopy(this.hold,this.holdIndex,i,this.holdIndex+FlatteningPathIterator.GROW_SIZE,r),this.hold=i,this.holdIndex+=FlatteningPathIterator.GROW_SIZE,this.holdEnd+=FlatteningPathIterator.GROW_SIZE}},FlatteningPathIterator.prototype.next=function(t){void 0===t&&(t=!0);var r;if(this.holdIndex>=this.holdEnd){if(t&&this.src.next(),this.src.isDone())return void(this.done=!0);this.holdType=this.src.currentSegment(this.hold),this.levelIndex=0,this.levels[0]=0}switch(this.holdType){case PathIterator.SEG_MOVETO:case PathIterator.SEG_LINETO:this.curx=this.hold[0],this.cury=this.hold[1],this.holdType===PathIterator.SEG_MOVETO&&(this.movx=this.curx,this.movy=this.cury),this.holdIndex=0,this.holdEnd=0;break;case PathIterator.SEG_CLOSE:this.curx=this.movx,this.cury=this.movy,this.holdIndex=0,this.holdEnd=0;break;case PathIterator.SEG_QUADTO:for(this.holdIndex>=this.holdEnd&&(this.holdIndex=this.hold.length-6,this.holdEnd=this.hold.length-2,this.hold[this.holdIndex+0]=this.curx,this.hold[this.holdIndex+1]=this.cury,this.hold[this.holdIndex+2]=this.hold[0],this.hold[this.holdIndex+3]=this.hold[1],this.hold[this.holdIndex+4]=this.curx=this.hold[2],this.hold[this.holdIndex+5]=this.cury=this.hold[3]),r=this.levels[this.levelIndex];r<this.limit&&!(QuadCurve2D.getFlatnessSq(this.hold,this.holdIndex)<this.squareflat);)this.ensureHoldCapacity(4),QuadCurve2D.subdivide(this.hold,this.holdIndex,this.hold,this.holdIndex-4,this.hold,this.holdIndex),this.holdIndex-=4,r++,this.levels[this.levelIndex]=r,this.levelIndex++,this.levels[this.levelIndex]=r;this.holdIndex+=4,this.levelIndex--;break;case PathIterator.SEG_CUBICTO:for(this.holdIndex>=this.holdEnd&&(this.holdIndex=this.hold.length-8,this.holdEnd=this.hold.length-2,this.hold[this.holdIndex+0]=this.curx,this.hold[this.holdIndex+1]=this.cury,this.hold[this.holdIndex+2]=this.hold[0],this.hold[this.holdIndex+3]=this.hold[1],this.hold[this.holdIndex+4]=this.hold[2],this.hold[this.holdIndex+5]=this.hold[3],this.hold[this.holdIndex+6]=this.curx=this.hold[4],this.hold[this.holdIndex+7]=this.cury=this.hold[5]),r=this.levels[this.levelIndex];r<this.limit&&!(CubicCurve2D.getFlatnessSq(this.hold,this.holdIndex)<this.squareflat);)this.ensureHoldCapacity(6),CubicCurve2D.subdivide(this.hold,this.holdIndex,this.hold,this.holdIndex-6,this.hold,this.holdIndex),this.holdIndex-=6,r++,this.levels[this.levelIndex]=r,this.levelIndex++,this.levels[this.levelIndex]=r;this.holdIndex+=6,this.levelIndex--}},FlatteningPathIterator.prototype.currentSegment=function(t){if(this.isDone())throw new NoSuchElementException("flattening iterator out of bounds");var r=this.holdType;return r!==PathIterator.SEG_CLOSE&&(t[0]=this.hold[this.holdIndex+0],t[1]=this.hold[this.holdIndex+1],r!==PathIterator.SEG_MOVETO&&(r=PathIterator.SEG_LINETO)),r},GeneralPath.prototype=Object.create(Path2D.prototype),GeneralPath.prototype.constructor=GeneralPath,GeneralPath.intersects=Path2D.intersects,GeneralPath.contains=Path2D.contains,QuadCurve2D.BELOW=-2,QuadCurve2D.LOWEDGE=-1,QuadCurve2D.INSIDE=0,QuadCurve2D.HIGHEDGE=1,QuadCurve2D.ABOVE=2,QuadCurve2D.prototype.getX1=function(){return this.x1},QuadCurve2D.prototype.getY1=function(){return this.y1},QuadCurve2D.prototype.getP1=function(){return new Point2D(this.x1,this.y1)},QuadCurve2D.prototype.getCtrlX=function(){return this.ctrlx},QuadCurve2D.prototype.getCtrlY=function(){return this.ctrly},QuadCurve2D.prototype.getCtrlPt=function(){return new Point2D(this.ctrlx,this.ctrly)},QuadCurve2D.prototype.getX2=function(){return this.x2},QuadCurve2D.prototype.getY2=function(){return this.y2},QuadCurve2D.prototype.getP2=function(){return new Point2D(this.x2,this.y2)},QuadCurve2D.prototype.setCurve=function(t,r,e,i,s,n){if(void 0===r){var o=t;this.setCurve(o.getX1(),o.getY1(),o.getCtrlX(),o.getCtrlY(),o.getX2(),o.getY2())}else if(void 0===e){var f=r;if(u[0]instanceof Point2D){var a=t;this.setCurve(a[f+0],a[f+1],a[f+2],a[f+3],a[f+4],a[f+5])}else{var h=t;this.setCurve(h[f+0].getX(),h[f+0].getY(),h[f+1].getX(),h[f+1].getY(),h[f+2].getX(),h[f+2].getY())}}else if(void 0===i){var u=t,A=r,T=e;this.setCurve(u.getX(),u.getY(),A.getX(),A.getY(),T.getX(),T.getY())}else this.x1=t,this.y1=r,this.ctrlx=e,this.ctrly=i,this.x2=s,this.y2=n},QuadCurve2D.prototype.getBounds2D=function(){var t=Math.min(Math.min(this.x1,this.x2),this.ctrlx),r=Math.min(Math.min(this.y1,this.y2),this.ctrly),e=Math.max(Math.max(this.x1,this.x2),this.ctrlx),i=Math.max(Math.max(this.y1,this.y2),this.ctrly);return new Rectangle2D(t,r,e-t,i-r)},QuadCurve2D.getFlatnessSq=function(t,r,e,i,s,n){if(void 0===e){var o=t,f=r;return Line2D.ptSegDistSq(o[f+0],o[f+1],o[f+4],o[f+5],o[f+2],o[f+3])}return Line2D.ptSegDistSq(t,r,s,n,e,i)},QuadCurve2D.prototype.getFlatnessSq=function(){return Line2D.ptSegDistSq(this.getX1(),this.getY1(),this.getX2(),this.getY2(),this.getCtrlX(),this.getCtrlY())},QuadCurve2D.getFlatness=function(t,r,e,i,s,n){if(void 0===e){var o=t,f=r;return Line2D.ptSegDist(o[f+0],o[f+1],o[f+4],o[f+5],o[f+2],o[f+3])}return Line2D.ptSegDist(t,r,s,n,e,i)},QuadCurve2D.prototype.getFlatness=function(){return Line2D.ptSegDist(this.getX1(),this.getY1(),this.getX2(),this.getY2(),this.getCtrlX(),this.getCtrlY())},QuadCurve2D.prototype.subdivide=function(t,r){QuadCurve2D.subdivide(this,t,r)},QuadCurve2D.subdivide=function(t,r,e,i,s,n){if(void 0===i){s=e,e=r;var o=t.getX1(),f=t.getY1(),a=t.getCtrlX(),h=t.getCtrlY(),u=t.getX2(),A=t.getY2(),T=(o+a)/2,c=(f+h)/2,m=(u+a)/2,p=(A+h)/2;a=(T+m)/2,h=(c+p)/2,null!==e&&e.setCurve(o,f,T,c,a,h),null!==s&&s.setCurve(a,h,m,p,u,A)}else{var o=t[r+0],f=t[r+1],a=t[r+2],h=t[r+3],u=t[r+4],A=t[r+5];null!==e&&(e[i+0]=o,e[i+1]=f),null!==s&&(s[n+4]=u,s[n+5]=A),o=(o+a)/2,f=(f+h)/2,u=(u+a)/2,A=(A+h)/2,a=(o+u)/2,h=(f+A)/2,null!==e&&(e[i+2]=o,e[i+3]=f,e[i+4]=a,e[i+5]=h),null!==s&&(s[n+0]=a,s[n+1]=h,s[n+2]=u,s[n+3]=A)}},QuadCurve2D.solveQuadratic=function(t,r){if(void 0===r)return QuadCurve2D.solveQuadratic(t,t);var e=[0,0],i=t[1],s=t[0],n=0;if(0===e){if(0===i)return-1;r[n++]=-s/i}else{var o=i*i-4*e*s;if(0>o)return 0;o=Math.sqrt(o),0>i&&(o=-o);var f=(i+o)/-2;r[n++]=f/e,0!==f&&(r[n++]=s/f)}return n},QuadCurve2D.prototype.contains=function(t,r){if(void 0===r){var e=t;return this.contains(e.getX(),e.getY())}var i=this.getX1(),s=this.getY1(),n=this.getCtrlX(),o=this.getCtrlY(),f=this.getX2(),a=this.getY2(),h=i-2*n+f,u=s-2*o+a,A=t-i,T=r-s,c=f-i,m=a-s,p=(A*u-T*h)/(c*u-m*h);if(0>p||p>1||p!==p)return!1;var E=h*p*p+2*(n-i)*p+i,P=u*p*p+2*(o-s)*p+s,d=c*p+i,g=m*p+s;return t>=E&&d>t||t>=d&&E>t||r>=P&&g>r||r>=g&&P>r},QuadCurve2D.fillEqn=function(t,r,e,i,s){t[0]=e-r,t[1]=i+i-e-e,t[2]=e-i-i+s},QuadCurve2D.evalQuadratic=function(t,r,e,i,s,n,o,f){for(var a=0,h=0;r>h;h++){var u=t[h];if((e?u>=0:u>0)&&(i?1>=u:1>u)&&(null===s||s[1]+2*s[2]*u!==0)){var A=1-u;t[a++]=n*A*A+2*o*u*A+f*u*u}}return a},QuadCurve2D.getTag=function(t,r,e){return r>=t?r>t?QuadCurve2D.BELOW:QuadCurve2D.LOWEDGE:t>=e?t>e?QuadCurve2D.ABOVE:QuadCurve2D.HIGHEDGE:QuadCurve2D.INSIDE},QuadCurve2D.inwards=function(t,r,e){switch(t){case QuadCurve2D.BELOW:case QuadCurve2D.ABOVE:default:return!1;case QuadCurve2D.LOWEDGE:return r>=QuadCurve2D.INSIDE||e>=QuadCurve2D.INSIDE;case QuadCurve2D.INSIDE:return!0;case QuadCurve2D.HIGHEDGE:return r<=QuadCurve2D.INSIDE||e<=QuadCurve2D.INSIDE}},QuadCurve2D.prototype.intersects=function(t,r,e,i){if(void 0===r){var s=t;return this.intersects(s.getX(),s.getY(),s.getWidth(),s.getHeight())}if(0>=e||0>=i)return!1;var n=this.getX1(),o=this.getY1(),f=QuadCurve2D.getTag(n,t,t+e),a=QuadCurve2D.getTag(o,r,r+i);if(f===QuadCurve2D.INSIDE&&a===QuadCurve2D.INSIDE)return!0;var h=this.getX2(),u=this.getY2(),A=QuadCurve2D.getTag(h,t,t+e),T=QuadCurve2D.getTag(u,r,r+i);if(A===QuadCurve2D.INSIDE&&T===QuadCurve2D.INSIDE)return!0;var c=this.getCtrlX(),m=this.getCtrlY(),p=QuadCurve2D.getTag(c,t,t+e),E=QuadCurve2D.getTag(m,r,r+i);if(f<QuadCurve2D.INSIDE&&A<QuadCurve2D.INSIDE&&p<QuadCurve2D.INSIDE)return!1;if(a<QuadCurve2D.INSIDE&&T<QuadCurve2D.INSIDE&&E<QuadCurve2D.INSIDE)return!1;if(f>QuadCurve2D.INSIDE&&A>QuadCurve2D.INSIDE&&p>QuadCurve2D.INSIDE)return!1;if(a>QuadCurve2D.INSIDE&&T>QuadCurve2D.INSIDE&&E>QuadCurve2D.INSIDE)return!1;if(QuadCurve2D.inwards(f,A,p)&&QuadCurve2D.inwards(a,T,E))return!0;if(QuadCurve2D.inwards(A,f,p)&&QuadCurve2D.inwards(T,a,E))return!0;var P=0>=f*A,d=0>=a*T;if(f===QuadCurve2D.INSIDE&&A===QuadCurve2D.INSIDE&&d)return!0;if(a===QuadCurve2D.INSIDE&&T===QuadCurve2D.INSIDE&&P)return!0;var g=[0,0,0],l=[0,0,0];if(!d)return QuadCurve2D.fillEqn(g,a<QuadCurve2D.INSIDE?r:r+i,o,m,u),2===QuadCurve2D.solveQuadratic(g,l)&&2===QuadCurve2D.evalQuadratic(l,2,!0,!0,null,n,c,h)&&QuadCurve2D.getTag(l[0],t,t+e)*QuadCurve2D.getTag(l[1],t,t+e)<=0;if(!P)return QuadCurve2D.fillEqn(g,f<QuadCurve2D.INSIDE?t:t+e,n,c,h),2===QuadCurve2D.solveQuadratic(g,l)&&2===QuadCurve2D.evalQuadratic(l,2,!0,!0,null,o,m,u)&&QuadCurve2D.getTag(l[0],r,r+i)*QuadCurve2D.getTag(l[1],r,r+i)<=0;var v,C,y=h-n,L=u-o,Y=u*n-h*o;if(v=a===QuadCurve2D.INSIDE?f:QuadCurve2D.getTag((Y+y*(a<QuadCurve2D.INSIDE?r:r+i))/L,t,t+e),C=T===QuadCurve2D.INSIDE?A:QuadCurve2D.getTag((Y+y*(T<QuadCurve2D.INSIDE?r:r+i))/L,t,t+e),0>=v*C)return!0;v=0>=v*f?a:T,QuadCurve2D.fillEqn(g,C<QuadCurve2D.INSIDE?t:t+e,n,c,h);var I=QuadCurve2D.solveQuadratic(g,l);return QuadCurve2D.evalQuadratic(l,I,!0,!0,null,o,m,u),C=QuadCurve2D.getTag(l[0],r,r+i),0>=v*C},QuadCurve2D.prototype.contains=function(t,r,e,i){if(void 0===r){var s=t;return this.contains(s.getX(),s.getY(),s.getWidth(),s.getHeight())}return 0>=e||0>=i?!1:this.contains(t,r)&&this.contains(t+e,r)&&this.contains(t+e,r+i)&&this.contains(t,r+i)},QuadCurve2D.prototype.getPathIterator=function(t,r){return void 0===r?new QuadIterator(this,t):new FlatteningPathIterator(this.getPathIterator(t),r)},QuadCurve2D.prototype.clone=function(){return new QuadCurve2D(this.x1,this.y1,this.ctrlx,this.ctrly,this.x2,this.y2)},QuadIterator.prototype=Object.create(PathIterator.prototype),QuadIterator.prototype.constructor=QuadIterator,QuadIterator.prototype.getWindingRule=function(){return PathIterator.WIND_NON_ZERO},QuadIterator.prototype.isDone=function(){return this.index>1},QuadIterator.prototype.next=function(){this.index++},QuadIterator.prototype.currentSegment=function(t){if(this.isDone())throw new NoSuchElementException("quad iterator iterator out of bounds");var r;return 0===this.index?(t[0]=this.quad.getX1(),t[1]=this.quad.getY1(),r=PathIterator.SEG_MOVETO):(t[0]=this.quad.getCtrlX(),t[1]=this.quad.getCtrlY(),t[2]=this.quad.getX2(),t[3]=this.quad.getY2(),r=PathIterator.SEG_QUADTO),null!==this.affine&&this.affine.transform(t,0,t,0,0===this.index?1:2),r},CubicCurve2D.prototype.getX1=function(){return this.x1},CubicCurve2D.prototype.getY1=function(){return this.y1},CubicCurve2D.prototype.getP1=function(){return new Point2D.Float(this.x1,this.y1)},CubicCurve2D.prototype.getCtrlX1=function(){return this.ctrlx1},CubicCurve2D.prototype.getCtrlY1=function(){return this.ctrly1},CubicCurve2D.prototype.getCtrlP1=function(){return new Point2D.Float(this.ctrlx1,this.ctrly1)},CubicCurve2D.prototype.getCtrlX2=function(){return this.ctrlx2},CubicCurve2D.prototype.getCtrlY2=function(){return this.ctrly2},CubicCurve2D.prototype.getCtrlP2=function(){return new Point2D.Float(this.ctrlx2,this.ctrly2)},CubicCurve2D.prototype.getX2=function(){return this.x2},CubicCurve2D.prototype.getY2=function(){return this.y2},CubicCurve2D.prototype.getP2=function(){return new Point2D.Float(this.x2,this.y2)},CubicCurve2D.prototype.setCurve=function(t,r,e,i,s,n,o,f){if(void 0===r){var a=t;this.setCurve(a.getX1(),a.getY1(),a.getCtrlX1(),a.getCtrlY1(),a.getCtrlX2(),a.getCtrlY2(),a.getX2(),a.getY2())}else if(void 0===e){var h=r;if(t[0]instanceof Point2D){var u=t;this.setCurve(u[h+0].getX(),u[h+0].getY(),u[h+1].getX(),u[h+1].getY(),u[h+2].getX(),u[h+2].getY(),u[h+3].getX(),u[h+3].getY())}else{var A=t;this.setCurve(A[h+0],A[h+1],A[h+2],A[h+3],A[h+4],A[h+5],A[h+6],A[h+7])}}else if(void 0===s){var T=t,c=r,m=e,p=i;this.setCurve(T.getX(),T.getY(),c.getX(),c.getY(),m.getX(),m.getY(),p.getX(),p.getY())}else this.x1=t,this.y1=r,this.ctrlx1=e,this.ctrly1=i,this.ctrlx2=s,this.ctrly2=n,this.x2=o,this.y2=f},CubicCurve2D.prototype.getBounds2D=function(){var t=Math.min(Math.min(this.x1,this.x2),Math.min(this.ctrlx1,this.ctrlx2)),r=Math.min(Math.min(this.y1,this.y2),Math.min(this.ctrly1,this.ctrly2)),e=Math.max(Math.max(this.x1,this.x2),Math.max(this.ctrlx1,this.ctrlx2)),i=Math.max(Math.max(this.y1,this.y2),Math.max(this.ctrly1,this.ctrly2));return new Rectangle2D(t,r,e-t,i-r)},CubicCurve2D.getFlatnessSq=function(t,r,e,i,s,n,o,f){if(void 0===e){var a=t,h=r;return this.getFlatnessSq(a[h+0],a[h+1],a[h+2],a[h+3],a[h+4],a[h+5],a[h+6],a[h+7])}return Math.max(Line2D.ptSegDistSq(t,r,o,f,e,i),Line2D.ptSegDistSq(t,r,o,f,s,n))},CubicCurve2D.getFlatness=function(t,r,e,i,s,n,o,f){if(void 0===e){var a=t,h=r;return this.getFlatness(a[h+0],a[h+1],a[h+2],a[h+3],a[h+4],a[h+5],a[h+6],a[h+7])}return Math.sqrt(this.getFlatnessSq(t,r,e,i,s,n,o,f))},CubicCurve2D.prototype.getFlatnessSq=function(){return CubicCurve2D.getFlatnessSq(this.getX1(),this.getY1(),this.getCtrlX1(),this.getCtrlY1(),this.getCtrlX2(),this.getCtrlY2(),this.getX2(),this.getY2())},CubicCurve2D.prototype.getFlatness=function(){return CubicCurve2D.getFlatness(this.getX1(),this.getY1(),this.getCtrlX1(),this.getCtrlY1(),this.getCtrlX2(),this.getCtrlY2(),this.getX2(),this.getY2())},CubicCurve2D.prototype.subdivide=function(t,r){CubicCurve2D.subdivide(this,t,r)},CubicCurve2D.subdivide=function(t,r,e,i,s,n){if(void 0===i){s=e,e=r;var o=t.getX1(),f=t.getY1(),a=t.getCtrlX1(),h=t.getCtrlY1(),u=t.getCtrlX2(),A=t.getCtrlY2(),T=t.getX2(),c=t.getY2(),m=(a+u)/2,p=(h+A)/2;a=(o+a)/2,h=(f+h)/2,u=(T+u)/2,A=(c+A)/2;var E=(a+m)/2,P=(h+p)/2,d=(u+m)/2,g=(A+p)/2;m=(E+d)/2,p=(P+g)/2,null!==e&&e.setCurve(o,f,a,h,E,P,m,p),null!==s&&s.setCurve(m,p,d,g,u,A,T,c)}else{var o=t[r+0],f=t[r+1],a=t[r+2],h=t[r+3],u=t[r+4],A=t[r+5],T=t[r+6],c=t[r+7];null!==e&&(e[i+0]=o,e[i+1]=f),null!==s&&(s[n+6]=T,s[n+7]=c),o=(o+a)/2,f=(f+h)/2,T=(T+u)/2,c=(c+A)/2;var m=(a+u)/2,p=(h+A)/2;a=(o+m)/2,h=(f+p)/2,u=(T+m)/2,A=(c+p)/2,m=(a+u)/2,p=(h+A)/2,null!==e&&(e[i+2]=o,e[i+3]=f,e[i+4]=a,e[i+5]=h,e[i+6]=m,e[i+7]=p),null!==s&&(s[n+0]=m,s[n+1]=p,s[n+2]=u,s[n+3]=A,s[n+4]=T,s[n+5]=c)}},CubicCurve2D.solveCubic=function(t,r){if(void 0===r)return CubicCurve2D.solveCubic(t,t);var e=t[3];if(0===e)return QuadCurve2D.solveQuadratic(t,r);var i,s=t[2]/e,n=t[1]/e,o=t[0]/e,f=s*s,a=1/3*(-1/3*f+n),h=.5*(2/27*s*f-1/3*s*n+o),u=a*a*a,A=h*h+u,T=1/3*s;if(0>A){var c=1/3*Math.acos(-h/Math.sqrt(-u)),m=2*Math.sqrt(-a);if(r===t)for(t=t.slice(0,4);t.length<4;)t.push(0);r[0]=m*Math.cos(c),r[1]=-m*Math.cos(c+Math.PI/3),r[2]=-m*Math.cos(c-Math.PI/3),i=3;for(var p=0;i>p;++p)r[p]-=T}else{var E=Math.sqrt(A),P=Math.cbrt(E-h),d=-Math.cbrt(E+h),g=P+d;i=1;var l=12e8*CubicCurve2D.ulp(Math.abs(g)+Math.abs(T));if(CubicCurve2D.iszero(A,l)||CubicCurve2D.within(P,d,l)){if(r===t)for(t=t.slice(0,4);t.length<4;)t.push(0);r[1]=-(g/2)-T,i=2}r[0]=g-T}return i>1&&(i=CubicCurve2D.fixRoots(t,r,i)),i>2&&(r[2]===r[1]||r[2]===r[0])&&i--,i>1&&r[1]===r[0]&&(r[1]=r[--i]),i},CubicCurve2D.fixRoots=function(t,r,e){var i=[t[1],2*t[2],3*t[3]],s=QuadCurve2D.solveQuadratic(i,i);if(2===s&&i[0]===i[1]&&s--,2===s&&i[0]>i[1]){var n=i[0];i[0]=i[1],i[1]=n}if(3===e){var o=CubicCurve2D.getRootUpperBound(t),f=-o,a=r.slice(0,e).sort();if(e<r.length&&a.push.apply(a,r.slice(e)),r=a,2===s)return r[0]=CubicCurve2D.refineRootWithHint(t,f,i[0],r[0]),r[1]=CubicCurve2D.refineRootWithHint(t,i[0],i[1],r[1]),r[2]=CubicCurve2D.refineRootWithHint(t,i[1],o,r[2]),3;if(1===s){var h=t[3],u=-h,A=i[0],T=CubicCurve2D.solveEqn(t,3,A);CubicCurve2D.oppositeSigns(u,T)?r[0]=CubicCurve2D.bisectRootWithHint(t,f,A,r[0]):CubicCurve2D.oppositeSigns(T,h)?r[0]=CubicCurve2D.bisectRootWithHint(t,A,o,r[2]):r[0]=A}else 0===s&&(r[0]=CubicCurve2D.bisectRootWithHint(t,f,o,r[1]))}else if(2===e&&2===s){var c=r[0],m=r[1],A=i[0],p=i[1],E=Math.abs(A-c)>Math.abs(p-c)?A:p,P=CubicCurve2D.solveEqn(t,3,E);if(CubicCurve2D.iszero(P,1e7*CubicCurve2D.ulp(E))){var d=CubicCurve2D.solveEqn(t,3,m);return r[1]=Math.abs(d)<Math.abs(P)?m:E,2}}return 1},CubicCurve2D.refineRootWithHint=function(t,r,e,i){if(!CubicCurve2D.inInterval(i,r,e))return i;for(var s=[t[1],2*t[2],3*t[3]],n=i,o=0;3>o;o++){var f=CubicCurve2D.solveEqn(s,2,i),a=CubicCurve2D.solveEqn(t,3,i),h=-(a/f),u=i+h;if(0===f||0===a||i===u)break;i=u}return CubicCurve2D.within(i,n,1e3*CubicCurve2D.ulp(n))&&CubicCurve2D.inInterval(i,r,e)?i:n},CubicCurve2D.bisectRootWithHint=function(t,r,e,i){for(var s=Math.min(Math.abs(i-r)/64,.0625),n=Math.min(Math.abs(i-e)/64,.0625),o=i-s,f=i+n,a=CubicCurve2D.solveEqn(t,3,o),h=CubicCurve2D.solveEqn(t,3,f);CubicCurve2D.oppositeSigns(a,h);){if(o>=f)return o;r=o,e=f,s/=64,n/=64,o=i-s,f=i+n,a=CubicCurve2D.solveEqn(t,3,o),h=CubicCurve2D.solveEqn(t,3,f)}return 0===a?o:0===h?f:CubicCurve2D.bisectRoot(t,r,e)},CubicCurve2D.bisectRoot=function(t,r,e){for(var i=CubicCurve2D.solveEqn(t,3,r),s=r+(e-r)/2;s!==r&&s!==e;){var n=CubicCurve2D.solveEqn(t,3,s);if(0===n)return s;CubicCurve2D.oppositeSigns(i,n)?e=s:(i=n,r=s),s=r+(e-r)/2}return s},CubicCurve2D.inInterval=function(t,r,e){return t>=r&&e>=t},CubicCurve2D.within=function(t,r,e){var i=r-t;return e>=i&&i>=-e},CubicCurve2D.iszero=function(t,r){return CubicCurve2D.within(t,0,r)},CubicCurve2D.oppositeSigns=function(t,r){return 0>t&&r>0||t>0&&0>r},CubicCurve2D.solveEqn=function(t,r,e){for(var i=t[r];--r>=0;)i=i*e+t[r];return i},CubicCurve2D.ulp=function(t){return t=Number(t),0>t?CubicCurve2D.nextUp(t)-t:t- -CubicCurve2D.nextUp(-t)},CubicCurve2D.nextUp=function(t){if(t=Number(t),t!==t)return t;if(t===-Number.POSITIVE_INFINITY)return-Number.MAX_VALUE;if(t===Number.POSITIVE_INFINITY)return Number.POSITIVE_INFINITY;if(t===+Number.MAX_VALUE)return Number.POSITIVE_INFINITY;var r=t*(0>t?1-Number.EPSILON/2:1+Number.EPSILON);if(r===t){var e=Number.MIN_VALUE;0===e&&(e=2.2250738585072014e-308),e>5e-324&&(e=5e-324),r=t+e}r===Number.POSITIVE_INFINITY&&(r=Number.MAX_VALUE);var i=t+(r-t)/2;i>t&&r>i&&(r=i);var s=(r+t)/2;return s>t&&r>s&&(r=s),0===r?-0:r},CubicCurve2D.getRootUpperBound=function(t){var r=t[3],e=t[2],i=t[1],s=t[0],n=1+Math.max(Math.max(Math.abs(e),Math.abs(i)),Math.abs(s))/Math.abs(r);return n+=CubicCurve2D.ulp(n)+1},CubicCurve2D.prototype.contains=function(t,r,e,i){if(void 0===r){if(t instanceof Rectangle2D){var s=t;return this.contains(s.getX(),s.getY(),s.getWidth(),s.getHeight())}var n=t;return this.contains(n.getX(),n.getY())}if(void 0===e){if(0*t+0*r!==0)return!1;var o=this.getX1(),f=this.getY1(),a=this.getX2(),h=this.getY2(),u=Curve.pointCrossingsForLine(t,r,o,f,a,h)+Curve.pointCrossingsForCubic(t,r,o,f,this.getCtrlX1(),this.getCtrlY1(),this.getCtrlX2(),this.getCtrlY2(),a,h,0);return 1===(1&u)}if(0>=e||0>=i)return!1;var A=this.rectCrossings(t,r,e,i);return!(0===A||A===Curve.RECT_INTERSECTS)},CubicCurve2D.prototype.intersects=function(t,r,e,i){if(void 0===r){var s=t;return this.intersects(s.getX(),s.getY(),s.getWidth(),s.getHeight())}if(0>=e||0>=i)return!1;var n=this.rectCrossings(t,r,e,i);return 0!==n},CubicCurve2D.prototype.rectCrossings=function(t,r,e,i){var s=0;return this.getX1()===this.getX2()&&this.getY1()===this.getY2()||(s=Curve.rectCrossingsForLine(s,t,r,t+e,r+i,this.getX1(),this.getY1(),this.getX2(),this.getY2()),s!==Curve.RECT_INTERSECTS)?Curve.rectCrossingsForCubic(s,t,r,t+e,r+i,this.getX2(),this.getY2(),this.getCtrlX2(),this.getCtrlY2(),this.getCtrlX1(),this.getCtrlY1(),this.getX1(),this.getY1(),0):s},CubicCurve2D.prototype.getPathIterator=function(t,r){return void 0===r?new CubicIterator(this,t):new FlatteningPathIterator(this.getPathIterator(t),r)},CubicCurve2D.prototype.clone=function(){return new CubicCurve2D(this.x1,this.y1,this.ctrlx1,this.ctrly1,this.ctrlx2,this.ctrly2,this.x2,this.y2)},CubicIterator.prototype=Object.create(PathIterator.prototype),CubicIterator.prototype.constructor=CubicIterator,CubicIterator.prototype.getWindingRule=function(){return PathIterator.WIND_NON_ZERO},CubicIterator.prototype.isDone=function(){return this.index>1},CubicIterator.prototype.next=function(){this.index++},CubicIterator.prototype.currentSegment=function(t){if(this.isDone())throw new NoSuchElementException("cubic iterator iterator out of bounds");var r;return 0===this.index?(t[0]=this.cubic.getX1(),t[1]=this.cubic.getY1(),r=PathIterator.SEG_MOVETO):(t[0]=this.cubic.getCtrlX1(),t[1]=this.cubic.getCtrlY1(),t[2]=this.cubic.getCtrlX2(),t[3]=this.cubic.getCtrlY2(),t[4]=this.cubic.getX2(),t[5]=this.cubic.getY2(),r=PathIterator.SEG_CUBICTO),null!==this.affine&&this.affine.transform(t,0,t,0,0===this.index?1:3),r},Area.pathToCurves=function(t){for(var r,e,i=[],s=t.getWindingRule(),n=new Array(23),o=0,f=0,a=0,h=0;!t.isDone();){switch(t.currentSegment(n)){case PathIterator.SEG_MOVETO:Curve.insertLine(i,a,h,o,f),a=o=n[0],h=f=n[1],Curve.insertMove(i,o,f);break;case PathIterator.SEG_LINETO:r=n[0],e=n[1],Curve.insertLine(i,a,h,r,e),a=r,h=e;break;case PathIterator.SEG_QUADTO:r=n[2],e=n[3],Curve.insertQuad(i,a,h,n),a=r,h=e;break;case PathIterator.SEG_CUBICTO:r=n[4],e=n[5],Curve.insertCubic(i,a,h,n),a=r,h=e;break;case PathIterator.SEG_CLOSE:Curve.insertLine(i,a,h,o,f),a=o,h=f}t.next()}Curve.insertLine(i,a,h,o,f);var u;return u=s===PathIterator.WIND_EVEN_ODD?new AreaOpEOWindOp:new AreaOpNZWindOp,u.calculate(i,[])},Area.prototype.add=function(t){this.curves=(new AreaOpAddOp).calculate(this.curves,t.curves),this.invalidateBounds()},Area.prototype.subtract=function(t){this.curves=(new AreaOpSubOp).calculate(this.curves,t.curves),this.invalidateBounds()},Area.prototype.intersect=function(t){this.curves=(new AreaOpIntOp).calculate(this.curves,t.curves),this.invalidateBounds()},Area.prototype.exclusiveOr=function(t){this.curves=(new AreaOpXorOp).calculate(this.curves,t.curves),this.invalidateBounds()},Area.prototype.reset=function(){this.curves.length=0,this.invalidateBounds()},Area.prototype.isEmpty=function(){return 0===this.curves.length},Area.prototype.isPolygonal=function(){for(var t=0;t<this.curves.length;t++)if(this.curves[t].getOrder()>1)return!1;return!0},Area.prototype.isRectangular=function(){var t=this.curves.length;if(0===t)return!0;if(t>3)return!1;var r=this.curves[1],e=this.curves[2];return 1!==r.getOrder()||1!==e.getOrder()?!1:r.getXTop()!==r.getXBot()||e.getXTop()!==e.getXBot()?!1:r.getYTop()!==e.getYTop()||r.getYBot()!==e.getYBot()?!1:!0},Area.prototype.isSingular=function(){if(this.curves.length<3)return!0;for(var t=1;t<this.curves.length;t++)if(0===this.curves[t].getOrder())return!1;return!0},Area.prototype.invalidateBounds=function(){this.cachedBounds=null},Area.prototype.getCachedBounds=function(){if(null!==this.cachedBounds)return this.cachedBounds;var t=new Rectangle2D;if(this.curves.length>0){var r=this.curves[0];t.setRect(r.getX0(),r.getY0(),0,0);for(var e=1;e<this.curves.length;e++)this.curves[e].enlarge(t)}return this.cachedBounds=t},Area.prototype.getBounds2D=function(){return this.getCachedBounds().getBounds2D()},Area.prototype.clone=function(){return new Area(this)},Area.prototype.equals=function(t){if(t===this)return!0;if(null===t)return!1;var r=(new AreaOpXorOp).calculate(this.curves,t.curves);return r.isEmpty()},Area.prototype.transform=function(t){if(null===t)throw new NullPointerException("transform must not be null");this.curves=Area.pathToCurves(this.getPathIterator(t)),this.invalidateBounds()},Area.prototype.createTransformedArea=function(t){var r=new Area(this);return r.transform(t),r},Area.prototype.contains=function(t,r){if(!this.getCachedBounds().contains(t,r))return!1;for(var e=0,i=0;i<this.curves.length;i++){var s=this.curves[i];e+=s.crossingsFor(t,r)}return 1===(1&e)},Area.prototype.contains=function(t,r,e,i){if(void 0===r){if(t instanceof Rectangle2D){var s=t;return this.contains(s.getX(),s.getY(),s.getWidth(),s.getHeight())}var n=t;return this.contains(n.getX(),n.getY())}if(0>e||0>i)return!1;if(!this.getCachedBounds().contains(t,r,e,i))return!1;var o=Crossings.findCrossings(this.curves,t,r,t+e,r+i);return null!==o&&o.covers(r,r+i)},Area.prototype.intersects=function(t,r,e,i){if(void 0===r){var s=t;return this.intersects(s.getX(),s.getY(),s.getWidth(),s.getHeight())}if(0>e||0>i)return!1;if(!this.getCachedBounds().intersects(t,r,e,i))return!1;var n=Crossings.findCrossings(this.curves,t,r,t+e,r+i);return null===n||!n.isEmpty()},Area.prototype.getPathIterator=function(t,r){return void 0===r?new AreaIterator(this.curves,t):new FlatteningPathIterator(this.getPathIterator(t),r)},AreaIterator.prototype=Object.create(PathIterator.prototype),AreaIterator.prototype.constructor=AreaIterator,AreaIterator.prototype.getWindingRule=function(){return PathIterator.WIND_NON_ZERO},AreaIterator.prototype.isDone=function(){return null===this.prevcurve&&null===this.thiscurve},AreaIterator.prototype.next=function(){null!==this.prevcurve?this.prevcurve=null:(this.prevcurve=this.thiscurve,this.index++,this.index<this.curves.length?(this.thiscurve=this.curves[this.index],0!==this.thiscurve.getOrder()&&this.prevcurve.getX1()===this.thiscurve.getX0()&&this.prevcurve.getY1()===this.thiscurve.getY0()&&(this.prevcurve=null)):this.thiscurve=null)},AreaIterator.prototype.currentSegment=function(t){var r,e;if(null!==this.prevcurve){if(null===this.thiscurve||0===this.thiscurve.getOrder())return PathIterator.SEG_CLOSE;t[0]=this.thiscurve.getX0(),t[1]=this.thiscurve.getY0(),r=PathIterator.SEG_LINETO,e=1}else{if(null===this.thiscurve)throw new NoSuchElementException("area iterator out of bounds");r=this.thiscurve.getSegment(t),e=this.thiscurve.getOrder(),0===e&&(e=1)}return null!==this.transform&&this.transform.transform(t,0,t,0,e),r},Curve.INCREASING=1,Curve.DECREASING=-1,Curve.RECT_INTERSECTS=2147483648,Curve.TMIN=.001,Curve.prototype.getDirection=function(){return this.direction},Curve.prototype.getWithDirection=function(t){return this.direction===t?this:this.getReversedCurve();
},Curve.insertMove=function(t,r,e){t.push(new Order0(r,e))},Curve.insertLine=function(t,r,e,i,s){s>e?t.push(new Order1(r,e,i,s,Curve.INCREASING)):e>s&&t.push(new Order1(i,s,r,e,Curve.DECREASING))},Curve.insertQuad=function(t,r,r,e){var i=e[3];if(y0>i)Order2.insert(t,e,e[2],i,e[0],e[1],x0,y0,Curve.DECREASING);else{if(y0===i&&y0===e[1])return;Order2.insert(t,e,x0,y0,e[0],e[1],e[2],i,Curve.INCREASING)}},Curve.insertCubic=function(t,r,e,i){var s=i[5];if(e>s)Order3.insert(t,i,i[4],s,i[2],i[3],i[0],i[1],r,e,Curve.DECREASING);else{if(e===s&&e===i[1]&&e===i[3])return;Order3.insert(t,i,r,e,i[0],i[1],i[2],i[3],i[4],s,Curve.INCREASING)}},Curve.pointCrossingsForPath=function(t,r,e){if(t.isDone())return 0;var i=new Array(6);if(t.currentSegment(i)!==PathIterator.SEG_MOVETO)throw new IllegalPathStateException("missing initial moveto in path definition");t.next();for(var s,n,o=i[0],f=i[1],a=o,h=f,u=0;!t.isDone();){switch(t.currentSegment(i)){case PathIterator.SEG_MOVETO:h!==f&&(u+=Curve.pointCrossingsForLine(r,e,a,h,o,f)),o=a=i[0],f=h=i[1];break;case PathIterator.SEG_LINETO:s=i[0],n=i[1],u+=Curve.pointCrossingsForLine(r,e,a,h,s,n),a=s,h=n;break;case PathIterator.SEG_QUADTO:s=i[2],n=i[3],u+=Curve.pointCrossingsForQuad(r,e,a,h,i[0],i[1],s,n,0),a=s,h=n;break;case PathIterator.SEG_CUBICTO:s=i[4],n=i[5],u+=Curve.pointCrossingsForCubic(r,e,a,h,i[0],i[1],i[2],i[3],s,n,0),a=s,h=n;break;case PathIterator.SEG_CLOSE:h!==f&&(u+=Curve.pointCrossingsForLine(r,e,a,h,o,f)),a=o,h=f}t.next()}return h!==f&&(u+=Curve.pointCrossingsForLine(r,e,a,h,o,f)),u},Curve.pointCrossingsForLine=function(t,r,e,i,s,n){if(i>r&&n>r)return 0;if(r>=i&&r>=n)return 0;if(t>=e&&t>=s)return 0;if(e>t&&s>t)return n>i?1:-1;var o=e+(r-i)*(s-e)/(n-i);return t>=o?0:n>i?1:-1},Curve.pointCrossingsForQuad=function(t,r,e,i,s,n,o,f,a){if(i>r&&n>r&&f>r)return 0;if(r>=i&&r>=n&&r>=f)return 0;if(t>=e&&t>=s&&t>=o)return 0;if(e>t&&s>t&&o>t){if(r>=i){if(f>r)return 1}else if(r>=f)return-1;return 0}if(a>52)return Curve.pointCrossingsForLine(t,r,e,i,o,f);var h=(e+s)/2,u=(i+n)/2,A=(s+o)/2,T=(n+f)/2;return s=(h+A)/2,n=(u+T)/2,isNaN(s)||isNaN(n)?0:Curve.pointCrossingsForQuad(t,r,e,i,h,u,s,n,a+1)+Curve.pointCrossingsForQuad(t,r,s,n,A,T,o,f,a+1)},Curve.pointCrossingsForCubic=function(t,r,e,i,s,n,o,f,a,h,u){if(i>r&&n>r&&f>r&&h>r)return 0;if(r>=i&&r>=n&&r>=f&&r>=h)return 0;if(t>=e&&t>=s&&t>=o&&t>=a)return 0;if(e>t&&s>t&&o>t&&a>t){if(r>=i){if(h>r)return 1}else if(r>=h)return-1;return 0}if(u>52)return pointCrossingsForLine(t,r,e,i,a,h);var A=(s+o)/2,T=(n+f)/2;s=(e+s)/2,n=(i+n)/2,o=(o+a)/2,f=(f+h)/2;var c=(s+A)/2,m=(n+T)/2,p=(A+o)/2,E=(T+f)/2;return A=(c+p)/2,T=(m+E)/2,isNaN(A)||isNaN(T)?0:Curve.pointCrossingsForCubic(t,r,e,i,s,n,c,m,A,T,u+1)+Curve.pointCrossingsForCubic(t,r,A,T,p,E,o,f,a,h,u+1)},Curve.rectCrossingsForPath=function(t,r,e,i,s){if(r>=i||e>=s)return 0;if(t.isDone())return 0;var n=new Array(6);if(t.currentSegment(n)!==PathIterator.SEG_MOVETO)throw new IllegalPathStateException("missing initial moveto in path definition");t.next();var o,f,a,h,u,A;o=a=n[0],f=h=n[1];for(var T=0;T!==Curve.RECT_INTERSECTS&&!t.isDone();){switch(t.currentSegment(n)){case PathIterator.SEG_MOVETO:(o!==a||f!==h)&&(T=Curve.rectCrossingsForLine(T,r,e,i,s,o,f,a,h)),a=o=n[0],h=f=n[1];break;case PathIterator.SEG_LINETO:u=n[0],A=n[1],T=Curve.rectCrossingsForLine(T,r,e,i,s,o,f,u,A),o=u,f=A;break;case PathIterator.SEG_QUADTO:u=n[2],A=n[3],T=Curve.rectCrossingsForQuad(T,r,e,i,s,o,f,n[0],n[1],u,A,0),o=u,f=A;break;case PathIterator.SEG_CUBICTO:u=n[4],A=n[5],T=Curve.rectCrossingsForCubic(T,r,e,i,s,o,f,n[0],n[1],n[2],n[3],u,A,0),o=u,f=A;break;case PathIterator.SEG_CLOSE:(o!==a||f!==h)&&(T=Curve.rectCrossingsForLine(T,r,e,i,s,o,f,a,h)),o=a,f=h}t.next()}return T===Curve.RECT_INTERSECTS||o===a&&f===h||(T=Curve.rectCrossingsForLine(T,r,e,i,s,o,f,a,h)),T},Curve.rectCrossingsForLine=function(t,r,e,i,s,n,o,f,a){if(o>=s&&a>=s)return t;if(e>=o&&e>=a)return t;if(r>=n&&r>=f)return t;if(n>=i&&f>=i)return a>o?(e>=o&&t++,a>=s&&t++):o>a&&(e>=a&&t--,o>=s&&t--),t;if(n>r&&i>n&&o>e&&s>o||f>r&&i>f&&a>e&&s>a)return Curve.RECT_INTERSECTS;var h=n;e>o?h+=(e-o)*(f-n)/(a-o):o>s&&(h+=(s-o)*(f-n)/(a-o));var u=f;return e>a?u+=(e-a)*(n-f)/(o-a):a>s&&(u+=(s-a)*(n-f)/(o-a)),r>=h&&r>=u?t:h>=i&&u>=i?(a>o?(e>=o&&t++,a>=s&&t++):o>a&&(e>=a&&t--,o>=s&&t--),t):Curve.RECT_INTERSECTS},Curve.rectCrossingsForQuad=function(t,r,e,i,s,n,o,f,a,h,u,A){if(o>=s&&a>=s&&u>=s)return t;if(e>=o&&e>=a&&e>=u)return t;if(r>=n&&r>=f&&r>=h)return t;if(n>=i&&f>=i&&h>=i)return u>o?(e>=o&&u>e&&t++,s>o&&u>=s&&t++):o>u&&(e>=u&&o>e&&t--,s>u&&o>=s&&t--),t;if(i>n&&n>r&&s>o&&o>e||i>h&&h>r&&s>u&&u>e)return Curve.RECT_INTERSECTS;if(A>52)return Curve.rectCrossingsForLine(t,r,e,i,s,n,o,h,u);var T=(n+f)/2,c=(o+a)/2,m=(f+h)/2,p=(a+u)/2;return f=(T+m)/2,a=(c+p)/2,Double.isNaN(f)||Double.isNaN(a)?0:(t=Curve.rectCrossingsForQuad(t,r,e,i,s,n,o,T,c,f,a,A+1),t!==Curve.RECT_INTERSECTS&&(t=Curve.rectCrossingsForQuad(t,r,e,i,s,f,a,m,p,h,u,A+1)),t)},Curve.rectCrossingsForCubic=function(t,r,e,i,s,n,o,f,a,h,u,A,T,c){if(o>=s&&a>=s&&u>=s&&T>=s)return t;if(e>=o&&e>=a&&e>=u&&e>=T)return t;if(r>=n&&r>=f&&r>=h&&r>=A)return t;if(n>=i&&f>=i&&h>=i&&A>=i)return T>o?(e>=o&&T>e&&t++,s>o&&T>=s&&t++):o>T&&(e>=T&&o>e&&t--,s>T&&o>=s&&t--),t;if(n>r&&i>n&&o>e&&s>o||A>r&&i>A&&T>e&&s>T)return Curve.RECT_INTERSECTS;if(c>52)return Curve.rectCrossingsForLine(t,r,e,i,s,n,o,A,T);var m=(f+h)/2,p=(a+u)/2;f=(n+f)/2,a=(o+a)/2,h=(h+A)/2,u=(u+T)/2;var E=(f+m)/2,P=(a+p)/2,d=(m+h)/2,g=(p+u)/2;return m=(E+d)/2,p=(P+g)/2,Double.isNaN(m)||Double.isNaN(p)?0:(t=Curve.rectCrossingsForCubic(t,r,e,i,s,n,o,f,a,E,P,m,p,c+1),t!==Curve.RECT_INTERSECTS&&(t=Curve.rectCrossingsForCubic(t,r,e,i,s,m,p,d,g,h,u,A,T,c+1)),t)},Curve.round=function(t){return t},Curve.orderof=function(t,r){return r>t?-1:t>r?1:0},Curve.prototype.crossingsFor=function(t,r){return r>=this.getYTop()&&r<this.getYBot()&&t<this.getXMax()&&(t<this.getXMin()||t<this.XforY(r))?1:0},Curve.prototype.accumulateCrossings=function(t){var r=t.getXHi();if(this.getXMin()>=r)return!1;var e,i,s,n,o=t.getXLo(),f=t.getYLo(),a=t.getYHi(),h=this.getYTop(),u=this.getYBot();if(f>h){if(f>=u)return!1;i=f,e=this.TforY(f)}else{if(h>=a)return!1;i=h,e=0}u>a?(n=a,s=this.TforY(a)):(n=u,s=1);for(var A=!1,T=!1;;){var c=this.XforT(e);if(r>c){if(T||c>o)return!0;A=!0}else{if(A)return!0;T=!0}if(e>=s)break;e=this.nextVertical(e,s)}return A&&t.record(i,n,direction),!1},Curve.prototype.compareTo=function(t,r){var e=r[0],i=r[1];if(i=Math.min(Math.min(i,this.getYBot()),t.getYBot()),i<=r[0])throw new InternalError("backstepping from "+r[0]+" to "+i);if(r[1]=i,this.getXMax()<=t.getXMin())return this.getXMin()===t.getXMax()?0:-1;if(this.getXMin()>=t.getXMax())return 1;var s=this.TforY(e),n=this.YforT(s);e>n&&(s=this.refineTforY(s,n,e),n=this.YforT(s));var o=this.TforY(i);this.YforT(o)<e&&(o=this.refineTforY(o,this.YforT(o),e));var f=t.TforY(e),a=t.YforT(f);e>a&&(f=t.refineTforY(f,a,e),a=t.YforT(f));var h=t.TforY(i);t.YforT(h)<e&&(h=t.refineTforY(h,t.YforT(h),e));var u=this.XforT(s),A=t.XforT(f),T=Math.max(Math.abs(e),Math.abs(i)),c=Math.max(1e-14*T,1e-300);if(this.fairlyClose(u,A)){for(var m=c,p=Math.min(1e13*c,.1*(i-e)),E=e+m;i>=E;){if(!this.fairlyClose(this.XforY(E),t.XforY(E))){for(E-=m;;){m/=2;var P=E+m;if(E>=P)break;this.fairlyClose(this.XforY(P),t.XforY(P))&&(E=P)}break}(m*=2)>p&&(m=p),E+=m}if(E>e)return i>E&&(r[1]=E),0}for(;o>s&&h>f;){var d=this.nextVertical(s,o),g=this.XforT(d),l=this.YforT(d),v=t.nextVertical(f,h),C=t.XforT(v),y=t.YforT(v);try{if(this.findIntersect(t,r,c,0,0,s,u,n,d,g,l,f,A,a,v,C,y))break}catch(L){return 0}if(y>l){if(l>r[0]){l<r[1]&&(r[1]=l);break}s=d,u=g,n=l}else{if(y>r[0]){y<r[1]&&(r[1]=y);break}f=v,A=C,a=y}}var Y=(r[0]+r[1])/2;return Curve.orderof(this.XforY(Y),t.XforY(Y))},Curve.prototype.findIntersect=function(t,r,e,i,s,n,o,f,a,h,u,A,T,c,m,p,E){if(f>E||c>u)return!1;if(Math.min(o,h)>Math.max(T,p)||Math.max(o,h)<Math.min(T,p))return!1;if(a-n>Curve.TMIN){var P=(n+a)/2,d=this.XforT(P),g=this.YforT(P);if(P===n||P===a)throw new InternalError("no s progress!");if(m-A>Curve.TMIN){var l=(A+m)/2,v=t.XforT(l),C=t.YforT(l);if(l===A||l===m)throw new InternalError("no t progress!");if(g>=c&&C>=f&&this.findIntersect(t,r,e,i+1,s+1,n,o,f,P,d,g,A,T,c,l,v,C))return!0;if(g>=C&&this.findIntersect(t,r,e,i+1,s+1,n,o,f,P,d,g,l,v,C,m,p,E))return!0;if(C>=g&&this.findIntersect(t,r,e,i+1,s+1,P,d,g,a,h,u,A,T,c,l,v,C))return!0;if(u>=C&&E>=g&&this.findIntersect(t,r,e,i+1,s+1,P,d,g,a,h,u,l,v,C,m,p,E))return!0}else{if(g>=c&&this.findIntersect(t,r,e,i+1,s,n,o,f,P,d,g,A,T,c,m,p,E))return!0;if(E>=g&&this.findIntersect(t,r,e,i+1,s,P,d,g,a,h,u,A,T,c,m,p,E))return!0}}else if(m-A>Curve.TMIN){var l=(A+m)/2,v=t.XforT(l),C=t.YforT(l);if(l===A||l===m)throw new InternalError("no t progress!");if(C>=f&&this.findIntersect(t,r,e,i,s+1,n,o,f,a,h,u,A,T,c,l,v,C))return!0;if(u>=C&&this.findIntersect(t,r,e,i,s+1,n,o,f,a,h,u,l,v,C,m,p,E))return!0}else{var y=h-o,L=u-f,Y=p-T,I=E-c,_=T-o,S=c-f,N=Y*L-I*y;if(0!==N){var D=1/N,P=(Y*S-I*_)*D,l=(y*S-L*_)*D;if(P>=0&&1>=P&&l>=0&&1>=l){P=n+P*(a-n),l=A+l*(m-A);var O=(this.YforT(P)+t.YforT(l))/2;if(O<=r[1]&&O>r[0])return r[1]=O,!0}}}return!1},Curve.prototype.refineTforY=function(t,r,e){for(var i=1;;){var s=(t+i)/2;if(s===t||s===i)return i;var n=this.YforT(s);if(e>n)t=s,r=n;else{if(!(n>e))return i;i=s}}},Curve.prototype.fairlyClose=function(t,r){return Math.abs(t-r)<1e-10*Math.max(Math.abs(t),Math.abs(r))},Order0.prototype=Object.create(Curve.prototype),Order0.prototype.constructor=Order0,Order0.prototype.getOrder=function(){return 0},Order0.prototype.getXTop=function(){return this.x},Order0.prototype.getYTop=function(){return this.y},Order0.prototype.getXBot=function(){return this.x},Order0.prototype.getYBot=function(){return this.y},Order0.prototype.getXMin=function(){return this.x},Order0.prototype.getXMax=function(){return this.x},Order0.prototype.getX0=function(){return this.x},Order0.prototype.getY0=function(){return this.y},Order0.prototype.getX1=function(){return this.x},Order0.prototype.getY1=function(){return this.y},Order0.prototype.XforY=function(t){return this.y},Order0.prototype.TforY=function(t){return 0},Order0.prototype.XforT=function(t){return this.x},Order0.prototype.YforT=function(t){return this.y},Order0.prototype.dXforT=function(t,r){return 0},Order0.prototype.dYforT=function(t,r){return 0},Order0.prototype.nextVertical=function(t,r){return r},Order0.prototype.crossingsFor=function(t,r){return 0},Order0.prototype.accumulateCrossings=function(t){return this.x>t.getXLo()&&this.x<t.getXHi()&&this.y>t.getYLo()&&this.y<t.getYHi()},Order0.prototype.enlarge=function(t){t.add(this.x,this.y)},Order0.prototype.getSubCurve=function(t,r,e){return this},Order0.prototype.getReversedCurve=function(){return this},Order0.prototype.getSegment=function(t){return t[0]=this.x,t[1]=this.y,PathIterator.SEG_MOVETO},Order1.prototype=Object.create(Curve.prototype),Order1.prototype.constructor=Order1,Order1.prototype.getOrder=function(){return 1},Order1.prototype.getXTop=function(){return this.x0},Order1.prototype.getYTop=function(){return this.y0},Order1.prototype.getXBot=function(){return this.x1},Order1.prototype.getYBot=function(){return this.y1},Order1.prototype.getXMin=function(){return this.xmin},Order1.prototype.getXMax=function(){return this.xmax},Order1.prototype.getX0=function(){return this.direction===Curve.INCREASING?this.x0:this.x1},Order1.prototype.getY0=function(){return this.direction===Curve.INCREASING?this.y0:this.y1},Order1.prototype.getX1=function(){return this.direction===Curve.DECREASING?this.x0:this.x1},Order1.prototype.getY1=function(){return this.direction===Curve.DECREASING?this.y0:this.y1},Order1.prototype.XforY=function(t){return this.x0===this.x1||t<=this.y0?this.x0:t>=this.y1?this.x1:this.x0+(t-this.y0)*(this.x1-this.x0)/(this.y1-this.y0)},Order1.prototype.TforY=function(t){return t<=this.y0?0:t>=this.y1?1:(t-this.y0)/(this.y1-this.y0)},Order1.prototype.XforT=function(t){return this.x0+t*(this.x1-this.x0)},Order1.prototype.YforT=function(t){return this.y0+t*(this.y1-this.y0)},Order1.prototype.dXforT=function(t,r){switch(r){case 0:return this.x0+t*(this.x1-this.x0);case 1:return this.x1-this.x0;default:return 0}},Order1.prototype.dYforT=function(t,r){switch(r){case 0:return this.y0+t*(this.y1-this.y0);case 1:return this.y1-this.y0;default:return 0}},Order1.prototype.nextVertical=function(t,r){return r},Order1.prototype.accumulateCrossings=function(t){var r=t.getXLo(),e=t.getYLo(),i=t.getXHi(),s=t.getYHi();if(this.xmin>=i)return!1;var n,o,f,a;if(this.y0<e){if(this.y1<=e)return!1;o=e,n=this.XforY(e)}else{if(this.y0>=s)return!1;o=this.y0,n=this.x0}return this.y1>s?(a=s,f=this.XforY(s)):(a=this.y1,f=this.x1),n>=i&&f>=i?!1:n>r||f>r?!0:(t.record(o,a,this.direction),!1)},Order1.prototype.enlarge=function(t){t.add(this.x0,this.y0),t.add(this.x1,this.y1)},Order1.prototype.getSubCurve=function(t,r,e){if(void 0===e&&(e=this.direction),t===this.y0&&r===this.y1)return this.getWithDirection(e);if(this.x0===this.x1)return new Order1(this.x0,t,this.x1,r,e);var i=this.x0-this.x1,s=this.y0-this.y1,n=this.x0+(t-this.y0)*i/s,o=this.x0+(r-this.y0)*i/s;return new Order1(n,t,o,r,e)},Order1.prototype.getReversedCurve=function(){return new Order1(this.x0,this.y0,this.x1,this.y1,-this.direction)},Order1.prototype.compareTo=function(t,r){if(!(t instanceof Order1))return Curve.prototype.compareTo.call(this,t,r);var e=t;if(r[1]<=r[0])throw new InternalError("yrange already screwed up...");if(r[1]=Math.min(Math.min(r[1],this.y1),e.y1),r[1]<=r[0])throw new InternalError("backstepping from "+r[0]+" to "+r[1]);if(this.xmax<=e.xmin)return this.xmin===e.xmax?0:-1;if(this.xmin>=e.xmax)return 1;var i,s=this.x1-this.x0,n=this.y1-this.y0,o=e.x1-e.x0,f=e.y1-e.y0,a=o*n-s*f;if(0!==a){var h=(this.x0-e.x0)*n*f-this.y0*s*f+e.y0*o*n;i=h/a,i<=r[0]?i=Math.min(this.y1,e.y1):(i<r[1]&&(r[1]=i),i=Math.max(this.y0,e.y0))}else i=Math.max(this.y0,e.y0);return Curve.orderof(this.XforY(i),e.XforY(i))},Order1.prototype.getSegment=function(t){return this.direction===Curve.INCREASING?(t[0]=this.x1,t[1]=this.y1):(t[0]=this.x0,t[1]=this.y0),PathIterator.SEG_LINETO},Order2.prototype=Object.create(Curve.prototype),Order2.prototype.constructor=Order1,Order2.prototype.getOrder=function(){return 2},Order2.prototype.getXTop=function(){return this.x0},Order2.prototype.getYTop=function(){return this.y0},Order2.prototype.getXBot=function(){return this.x1},Order2.prototype.getYBot=function(){return this.y1},Order2.prototype.getXMin=function(){return this.xmin},Order2.prototype.getXMax=function(){return this.xmax},Order2.prototype.getX0=function(){return this.direction===Curve.INCREASING?this.x0:this.x1},Order2.prototype.getY0=function(){return this.direction===Curve.INCREASING?this.y0:this.y1},Order2.prototype.getCX0=function(){return this.cx0},Order2.prototype.getCY0=function(){return this.cy0},Order2.prototype.getX1=function(){return this.direction===Curve.DECREASING?this.x0:this.x1},Order2.prototype.getY1=function(){return this.direction===Curve.DECREASING?this.y0:this.y1},Order2.prototype.XforY=function(t){return t<=this.y0?this.x0:t>=this.y1?this.x1:this.XforT(this.TforY(t))},Order2.prototype.TforY=function(t){return t<=this.y0?0:t>=this.y1?1:Order2.TforY(t,this.ycoeff0,this.ycoeff1,this.ycoeff2)},Order2.insert=function(t,r,e,i,s,n,o,f,a){var h=Order2.getHorizontalParams(i,n,f,r);if(0===h)return void Order2.addInstance(t,e,i,s,n,o,f,a);var u=r[0];r[0]=e,r[1]=i,r[2]=s,r[3]=n,r[4]=o,r[5]=f,Order2.split(r,0,u);var A=a===Curve.INCREASING?0:4,T=4-A;Order2.addInstance(t,r[A],r[A+1],r[A+2],r[A+3],r[A+4],r[A+5],a),Order2.addInstance(t,r[T],r[T+1],r[T+2],r[T+3],r[T+4],r[T+5],a)},Order2.addInstance=function(t,r,e,i,s,n,o,f){e>o?t.push(new Order2(n,o,i,s,r,e,-f)):o>e&&t.push(new Order2(r,e,i,s,n,o,f))},Order2.getHorizontalParams=function(t,r,e,i){if(r>=t&&e>=r)return 0;t-=r,e-=r;var s=t+e;if(0===s)return 0;var n=t/s;return 0>=n||n>=1?0:(i[0]=n,1)},Order2.split=function(t,r,e){var i,s,n,o,f,a;t[r+8]=f=t[r+4],t[r+9]=a=t[r+5],n=t[r+2],o=t[r+3],f=n+(f-n)*e,a=o+(a-o)*e,i=t[r+0],s=t[r+1],i+=(n-i)*e,s+=(o-s)*e,n=i+(f-i)*e,o=s+(a-s)*e,t[r+2]=i,t[r+3]=s,t[r+4]=n,t[r+5]=o,t[r+6]=f,t[r+7]=a},Order2.TforY=function(t,r,e,i){if(r-=t,0===i){var s=-r/e;if(s>=0&&1>=s)return s}else{var n=e*e-4*i*r;if(n>=0){n=Math.sqrt(n),0>e&&(n=-n);var o=(e+n)/-2,s=o/i;if(s>=0&&1>=s)return s;if(0!==o&&(s=r/o,s>=0&&1>=s))return s}}var f=r,a=r+e+i;return(f+a)/2>0?0:1},Order2.prototype.XforT=function(t){return(this.xcoeff2*t+this.xcoeff1)*t+this.xcoeff0},Order2.prototype.YforT=function(t){return(this.ycoeff2*t+this.ycoeff1)*t+this.ycoeff0},Order2.prototype.dXforT=function(t,r){switch(r){case 0:return(this.xcoeff2*t+this.xcoeff1)*t+this.xcoeff0;case 1:return 2*this.xcoeff2*t+this.xcoeff1;case 2:return 2*this.xcoeff2;default:return 0}},Order2.prototype.dYforT=function(t,r){switch(r){case 0:return(this.ycoeff2*t+this.ycoeff1)*t+this.ycoeff0;case 1:return 2*this.ycoeff2*t+this.ycoeff1;case 2:return 2*this.ycoeff2;default:return 0}},Order2.prototype.nextVertical=function(t,r){var e=-this.xcoeff1/(2*this.xcoeff2);return e>t&&r>e?e:r},Order2.prototype.enlarge=function(t){t.add(this.x0,this.y0);var r=-this.xcoeff1/(2*this.xcoeff2);r>0&&1>r&&t.add(this.XforT(r),this.YforT(r)),t.add(this.x1,this.y1)},Order2.prototype.getSubCurve=function(t,r,e){void 0===e&&(e=this.direction);var i,s;if(t<=this.y0){if(r>=this.y1)return this.getWithDirection(e);i=0}else i=Order2.TforY(t,this.ycoeff0,this.ycoeff1,this.ycoeff2);s=r>=y1?1:Order2.TforY(r,this.ycoeff0,this.ycoeff1,this.ycoeff2);var n=new Array(10);n[0]=this.x0,n[1]=this.y0,n[2]=this.cx0,n[3]=this.cy0,n[4]=this.x1,n[5]=this.y1,1>s&&Order2.split(n,0,s);var o;return 0>=i?o=0:(Order2.split(n,0,i/s),o=4),new Order2(n[o+0],t,n[o+2],n[o+3],n[o+4],r,e)},Order2.prototype.getReversedCurve=function(){return new Order2(this.x0,this.y0,this.cx0,this.cy0,this.x1,this.y1,-this.direction)},Order2.prototype.getSegment=function(t){return t[0]=this.cx0,t[1]=this.cy0,this.direction===Curve.INCREASING?(t[2]=this.x1,t[3]=this.y1):(t[2]=this.x0,t[3]=this.y0),PathIterator.SEG_QUADTO},Order3.prototype=Object.create(Curve.prototype),Order3.prototype.constructor=Order3,Order3.prototype.getOrder=function(){return 3},Order3.prototype.getXTop=function(){return this.x0},Order3.prototype.getYTop=function(){return this.y0},Order3.prototype.getXBot=function(){return this.x1},Order3.prototype.getYBot=function(){return this.y1},Order3.prototype.getXMin=function(){return this.xmin},Order3.prototype.getXMax=function(){return this.xmax},Order3.prototype.getX0=function(){return this.direction===Curve.INCREASING?this.x0:this.x1},Order3.prototype.getY0=function(){return this.direction===Curve.INCREASING?this.y0:this.y1},Order3.prototype.getCX0=function(){return this.direction===Curve.INCREASING?this.cx0:this.cx1},Order3.prototype.getCY0=function(){return this.direction===Curve.INCREASING?this.cy0:this.cy1},Order3.prototype.getCX1=function(){return this.direction===Curve.DECREASING?this.cx0:this.cx1},Order3.prototype.getCY1=function(){return this.direction===Curve.DECREASING?this.cy0:this.cy1},Order3.prototype.getX1=function(){return this.direction===Curve.DECREASING?this.x0:this.x1},Order3.prototype.getY1=function(){return this.direction===Curve.DECREASING?this.y0:this.y1},Order3.insert=function(t,r,e,i,s,n,o,f,a,h,u){var A=Order3.getHorizontalParams(i,n,f,h,r);if(0===A)return void Order3.addInstance(t,e,i,s,n,o,f,a,h,u);r[3]=e,r[4]=i,r[5]=s,r[6]=n,r[7]=o,r[8]=f,r[9]=a,r[10]=h;var T=r[0];A>1&&T>r[1]&&(r[0]=r[1],r[1]=T,T=r[0]),Order3.split(r,3,T),A>1&&(T=(r[1]-T)/(1-T),Order3.split(r,9,T));var c=3;for(u===Curve.DECREASING&&(c+=6*A);A>=0;)Order3.addInstance(t,r[c+0],r[c+1],r[c+2],r[c+3],r[c+4],r[c+5],r[c+6],r[c+7],u),A--,u===Curve.INCREASING?c+=6:c-=6},Order3.addInstance=function(t,r,e,i,s,n,o,f,a,h){e>a?t.push(new Order3(f,a,n,o,i,s,r,e,-h)):a>e&&t.push(new Order3(r,e,i,s,n,o,f,a,h))},Order3.getHorizontalParams=function(t,r,e,i,s){if(r>=t&&e>=r&&i>=e)return 0;i-=e,e-=r,r-=t,s[0]=r,s[1]=2*(e-r),s[2]=i-e-e+r;for(var n=QuadCurve2D.solveQuadratic(s,s),o=0,f=0;n>f;f++){var a=s[f];a>0&&1>a&&(f>o&&(s[o]=a),o++)}return o},Order3.split=function(t,r,e){var i,s,n,o,f,a,h,u;t[r+12]=h=t[r+6],t[r+13]=u=t[r+7],f=t[r+4],a=t[r+5],h=f+(h-f)*e,u=a+(u-a)*e,i=t[r+0],s=t[r+1],n=t[r+2],o=t[r+3],i+=(n-i)*e,s+=(o-s)*e,n+=(f-n)*e,o+=(a-o)*e,f=n+(h-n)*e,a=o+(u-o)*e,n=i+(n-i)*e,o=s+(o-s)*e,t[r+2]=i,t[r+3]=s,t[r+4]=n,t[r+5]=o,t[r+6]=n+(f-n)*e,t[r+7]=o+(a-o)*e,t[r+8]=f,t[r+9]=a,t[r+10]=h,t[r+11]=u},Order3.prototype.TforY=function(t){if(t<=this.y0)return 0;if(t>=this.y1)return 1;if(t===this.YforT1)return this.TforY1;if(t===this.YforT2)return this.TforY2;if(t===this.YforT3)return this.TforY3;if(0===this.ycoeff3)return Order2.TforY(t,this.ycoeff0,this.ycoeff1,this.ycoeff2);var r,e=this.ycoeff2/this.ycoeff3,i=this.ycoeff1/this.ycoeff3,s=(this.ycoeff0-t)/this.ycoeff3,n=(e*e-3*i)/9,o=(2*e*e*e-9*e*i+27*s)/54,f=o*o,a=n*n*n,h=e/3;if(a>f){var u=Math.acos(o/Math.sqrt(a));n=-2*Math.sqrt(n),r=this.refine(e,i,s,t,n*Math.cos(u/3)-h),0>r&&(r=this.refine(e,i,s,t,n*Math.cos((u+2*Math.PI)/3)-h)),0>r&&(r=this.refine(e,i,s,t,n*Math.cos((u-2*Math.PI)/3)-h))}else{var A=0>o,T=Math.sqrt(f-a);A&&(o=-o);var c=Math.pow(o+T,1/3);A||(c=-c);var m=0===c?0:n/c;r=this.refine(e,i,s,t,c+m-h)}if(0>r)for(var p=0,E=1;;){if(r=(p+E)/2,r===p||r===E)break;var P=this.YforT(r);if(t>P)p=r;else{if(!(P>t))break;E=r}}return r>=0&&(this.TforY3=this.TforY2,this.YforT3=this.YforT2,this.TforY2=this.TforY1,this.YforT2=this.YforT1,this.TforY1=r,this.YforT1=t),r},Order3.prototype.refine=function(t,r,e,i,s){if(-.1>s||s>1.1)return-1;var n,o,f=this.YforT(s);i>f?(n=s,o=1):(n=0,o=s);for(var a=!0;f!==i;){if(a){var h=this.dYforT(s,1);if(0===h){a=!1;continue}var u=s+(i-f)/h;if(u===s||n>=u||u>=o){a=!1;continue}s=u}else{var u=(n+o)/2;if(u===n||u===o)break;s=u}if(f=this.YforT(s),i>f)n=s;else{if(!(f>i))break;o=s}}return s>1?-1:s},Order3.prototype.XforY=function(t){return t<=this.y0?this.x0:t>=this.y1?this.x1:this.XforT(this.TforY(t))},Order3.prototype.XforT=function(t){return((this.xcoeff3*t+this.xcoeff2)*t+this.xcoeff1)*t+this.xcoeff0},Order3.prototype.YforT=function(t){return((this.ycoeff3*t+this.ycoeff2)*t+this.ycoeff1)*t+this.ycoeff0},Order3.prototype.dXforT=function(t,r){switch(r){case 0:return((this.xcoeff3*t+this.xcoeff2)*t+this.xcoeff1)*t+this.xcoeff0;case 1:return(3*this.xcoeff3*t+2*this.xcoeff2)*t+this.xcoeff1;case 2:return 6*this.xcoeff3*t+2*this.xcoeff2;case 3:return 6*this.xcoeff3;default:return 0}},Order3.prototype.dYforT=function(t,r){switch(r){case 0:return((this.ycoeff3*t+this.ycoeff2)*t+this.ycoeff1)*t+this.ycoeff0;case 1:return(3*this.ycoeff3*t+2*this.ycoeff2)*t+this.ycoeff1;case 2:return 6*this.ycoeff3*t+2*this.ycoeff2;case 3:return 6*this.ycoeff3;default:return 0}},Order3.prototype.nextVertical=function(t,r){for(var e=[this.xcoeff1,2*this.xcoeff2,3*this.xcoeff3],i=QuadCurve2D.solveQuadratic(e,e),s=0;i>s;s++)e[s]>t&&e[s]<r&&(r=e[s]);return r},Order3.prototype.enlarge=function(t){t.add(this.x0,this.y0);for(var r=[this.xcoeff1,2*this.xcoeff2,3*this.xcoeff3],e=QuadCurve2D.solveQuadratic(r,r),i=0;e>i;i++){var s=r[i];s>0&&1>s&&t.add(this.XforT(s),this.YforT(s))}t.add(this.x1,this.y1)},Order3.prototype.getSubCurve=function(t,r,e){if(void 0===e&&(e=this.direction),t<=this.y0&&r>=this.y1)return this.getWithDirection(e);var i,s,n=new Array(14);if(i=this.TforY(t),s=this.TforY(r),n[0]=this.x0,n[1]=this.y0,n[2]=this.cx0,n[3]=this.cy0,n[4]=this.cx1,n[5]=this.cy1,n[6]=this.x1,n[7]=this.y1,i>s){var o=i;i=s,s=o}1>s&&Order3.split(n,0,s);var f;return 0>=i?f=0:(Order3.split(n,0,i/s),f=6),new Order3(n[f+0],t,n[f+2],n[f+3],n[f+4],n[f+5],n[f+6],r,e)},Order3.prototype.getReversedCurve=function(){return new Order3(this.x0,this.y0,this.cx0,this.cy0,this.cx1,this.cy1,this.x1,this.y1,-this.direction)},Order3.prototype.getSegment=function(t){return this.direction===Curve.INCREASING?(t[0]=this.cx0,t[1]=this.cy0,t[2]=this.cx1,t[3]=this.cy1,t[4]=this.x1,t[5]=this.y1):(t[0]=this.cx1,t[1]=this.cy1,t[2]=this.cx0,t[3]=this.cy0,t[4]=this.x0,t[5]=this.y0),PathIterator.SEG_CUBICTO},Crossings.prototype.getXLo=function(){return this.xlo},Crossings.prototype.getYLo=function(){return this.ylo},Crossings.prototype.getXHi=function(){return this.xhi},Crossings.prototype.getYHi=function(){return this.yhi},Crossings.prototype.isEmpty=function(){return 0===this.limit},Crossings.findCrossings=function(t,r,e,i,s){for(var n=new CrossingsEvenOdd(r,e,i,s),o=0;o<t.length;o++){var f=t[o];if(f.accumulateCrossings(n))return null}return n},Crossings.findCrossings=function(t,r,e,i,s){var n;n=t.getWindingRule()===PathIterator.WIND_EVEN_ODD?new CrossingsEvenOdd(r,e,i,s):new CrossingsNonZero(r,e,i,s);for(var o,f,a=new Array(23),h=0,u=0,A=0,T=0;!t.isDone();){var c=t.currentSegment(a);switch(c){case PathIterator.SEG_MOVETO:if(u!==T&&n.accumulateLine(A,T,h,u))return null;h=A=a[0],u=T=a[1];break;case PathIterator.SEG_LINETO:if(o=a[0],f=a[1],n.accumulateLine(A,T,o,f))return null;A=o,T=f;break;case PathIterator.SEG_QUADTO:if(o=a[2],f=a[3],n.accumulateQuad(A,T,a))return null;A=o,T=f;break;case PathIterator.SEG_CUBICTO:if(o=a[4],f=a[5],n.accumulateCubic(A,T,a))return null;A=o,T=f;break;case PathIterator.SEG_CLOSE:if(u!==T&&n.accumulateLine(A,T,h,u))return null;A=h,T=u}t.next()}return u!==T&&n.accumulateLine(A,T,h,u)?null:n},Crossings.prototype.accumulateLine=function(t,r,e,i,s){if(void 0===s)return i>=r?this.accumulateLine(t,r,e,i,1):this.accumulateLine(e,i,t,r,-1);if(this.yhi<=r||this.ylo>=i)return!1;if(t>=this.xhi&&e>=this.xhi)return!1;if(r===i)return t>=this.xlo||e>=this.xlo;var n,o,f,a,h=e-t,u=i-r;return r<this.ylo?(n=t+(this.ylo-r)*h/u,o=this.ylo):(n=t,o=r),this.yhi<i?(f=t+(this.yhi-r)*h/u,a=this.yhi):(f=e,a=i),n>=this.xhi&&f>=this.xhi?!1:n>this.xlo||f>this.xlo?!0:(this.record(o,a,s),!1)},Crossings.prototype.accumulateQuad=function(t,r,e){if(r<this.ylo&&e[1]<this.ylo&&e[3]<this.ylo)return!1;if(r>this.yhi&&e[1]>this.yhi&&e[3]>this.yhi)return!1;if(t>this.xhi&&e[0]>this.xhi&&e[2]>this.xhi)return!1;if(t<this.xlo&&e[0]<this.xlo&&e[2]<this.xlo)return r<e[3]?this.record(Math.max(r,this.ylo),Math.min(e[3],this.yhi),1):r>e[3]&&this.record(Math.max(e[3],this.ylo),Math.min(r,this.yhi),-1),!1;var i=[];Curve.insertQuad(i,t,r,e);for(var s=0;s<i.length;s++){var n=i[s];if(n.accumulateCrossings(this))return!0}return!1},Crossings.prototype.accumulateCubic=function(t,r,e){if(r<this.ylo&&e[1]<this.ylo&&e[3]<this.ylo&&e[5]<this.ylo)return!1;if(r>this.yhi&&e[1]>this.yhi&&e[3]>this.yhi&&e[5]>this.yhi)return!1;if(t>this.xhi&&e[0]>this.xhi&&e[2]>this.xhi&&e[4]>this.xhi)return!1;if(t<this.xlo&&e[0]<this.xlo&&e[2]<this.xlo&&e[4]<this.xlo)return r<=e[5]?this.record(Math.max(r,this.ylo),Math.min(e[5],this.yhi),1):this.record(Math.max(e[5],this.ylo),Math.min(r,this.yhi),-1),!1;var i=[];Curve.insertCubic(this.tmp,t,r,e);for(var s=0;s<i.length;s++){var n=i[s];if(n.accumulateCrossings(this))return!0}return!1},CrossingsEvenOdd.prototype=Object.create(Crossings.prototype),CrossingsEvenOdd.prototype.constructor=CrossingsEvenOdd,CrossingsEvenOdd.prototype.covers=function(t,r){return 2===this.limit&&this.yranges[0]<=t&&this.yranges[1]>=r},CrossingsEvenOdd.prototype.record=function(t,r,e){if(!(t>=r)){for(var i=0;i<this.limit&&t>this.yranges[i+1];)i+=2;for(var s=i;i<this.limit;){var n=this.yranges[i++],o=this.yranges[i++];if(n>r)this.yranges[s++]=t,this.yranges[s++]=r,t=n,r=o;else{var f,a,h,u;if(n>t?(f=t,a=n):(f=n,a=t),o>r?(h=r,u=o):(h=o,u=r),a===h?(t=f,r=u):(a>h&&(t=h,h=a,a=t),f!==a&&(this.yranges[s++]=f,this.yranges[s++]=a),t=h,r=u),t>=r)break}}if(i>s&&i<this.limit&&System.arraycopy(this.yranges,i,this.yranges,s,this.limit-i),s+=this.limit-i,r>t){if(s>=this.yranges.length){var A=new Array(s+10);System.arraycopy(this.yranges,0,A,0,s),this.yranges=A}this.yranges[s++]=t,this.yranges[s++]=r}this.limit=s}},CrossingsNonZero.prototype=Object.create(Crossings.prototype),CrossingsNonZero.prototype.constructor=CrossingsNonZero,CrossingsNonZero.prototype.covers=function(t,r){for(var e=0;e<this.limit;){var i=this.yranges[e++],s=this.yranges[e++];if(!(t>=s)){if(i>t)return!1;if(s>=r)return!0;t=s}}return t>=r},CrossingsNonZero.prototype.remove=function(t){this.limit-=2;var r=this.limit-t;r>0&&(System.arraycopy(this.yranges,t+2,this.yranges,t,r),System.arraycopy(crosscounts,t/2+1,crosscounts,t/2,r/2))},CrossingsNonZero.prototype.insert=function(t,r,e,i){var s=this.limit-t,n=this.yranges,o=crosscounts;this.limit>=this.yranges.length&&(this.yranges=new Array(this.limit+10),System.arraycopy(n,0,this.yranges,0,t),crosscounts=new Array((this.limit+10)/2),System.arraycopy(o,0,crosscounts,0,t/2)),s>0&&(System.arraycopy(n,t,this.yranges,t+2,s),System.arraycopy(o,t/2,crosscounts,t/2+1,s/2)),this.yranges[t+0]=r,this.yranges[t+1]=e,crosscounts[t/2]=i,this.limit+=2},CrossingsNonZero.prototype.record=function(t,r,e){if(!(t>=r)){for(var i=0;i<this.limit&&t>this.yranges[i+1];)i+=2;if(i<this.limit){var s=crosscounts[i/2],n=this.yranges[i+0],o=this.yranges[i+1];if(o===t&&s===e){if(i+2===this.limit)return void(this.yranges[i+1]=r);this.remove(i),t=n,s=crosscounts[i/2],n=this.yranges[i+0],o=this.yranges[i+1]}if(n>r)return void this.insert(i,t,r,e);if(r===n&&s===e)return void(this.yranges[i]=t);n>t?(this.insert(i,t,n,e),i+=2,t=n):t>n&&(this.insert(i,n,t,s),i+=2,n=t);var f=s+e,a=Math.min(r,o);0===f?this.remove(i):(crosscounts[i/2]=f,this.yranges[i++]=t,this.yranges[i++]=a),t=n=a,o>n&&this.insert(i,n,o,s)}r>t&&this.insert(i,t,r,e)}},AreaOp.CTAG_LEFT=0,AreaOp.CTAG_RIGHT=1,AreaOp.ETAG_IGNORE=0,AreaOp.ETAG_ENTER=1,AreaOp.ETAG_EXIT=-1,AreaOp.RSTAG_INSIDE=1,AreaOp.RSTAG_OUTSIDE=-1,AreaOp.EmptyLinkList=[null,null],AreaOp.EmptyChainList=[null,null],AreaOp.prototype.calculate=function(t,r){var e=[];return AreaOp.addEdges(e,t,AreaOp.CTAG_LEFT),AreaOp.addEdges(e,r,AreaOp.CTAG_RIGHT),e=this.pruneEdges(e)},AreaOp.addEdges=function(t,r,e){for(var i=0;i<r.length;i++){var s=r[i];s.getOrder()>0&&t.push(new Edge(s,e))}},AreaOp.YXTopComparator=function(t,r){var e,i,s=t.getCurve(),n=r.getCurve();return(e=s.getYTop())===(i=n.getYTop())&&(e=s.getXTop())===(i=n.getXTop())?0:i>e?-1:1},AreaOp.prototype.pruneEdges=function(t){var r=t.length;if(2>r)return t;var e=t.slice(0);e.sort(AreaOp.YXTopComparator);for(var i,s=0,n=0,o=0,f=0,a=[0,0],h=[],u=[],A=[];r>s;){var T=a[0];for(o=f=n-1;o>=s;o--)i=e[o],i.getCurve().getYBot()>T&&(f>o&&(e[f]=i),f--);if(s=f+1,s>=n){if(n>=r)break;T=e[n].getCurve().getYTop(),T>a[0]&&AreaOp.finalizeSubCurves(h,u),a[0]=T}for(;r>n&&(i=e[n],!(i.getCurve().getYTop()>T));)n++;a[1]=e[s].getCurve().getYBot(),r>n&&(T=e[n].getCurve().getYTop(),a[1]>T&&(a[1]=T));var c=1;for(o=s;n>o;o++){for(i=e[o],i.setEquivalence(0),f=o;f>s;f--){var m=e[f-1],p=i.compareTo(m,a);if(a[1]<=a[0])throw new InternalError("backstepping to "+a[1]+" from "+a[0]);if(p>=0){if(0===p){var E=m.getEquivalence();0===E&&(E=c++,m.setEquivalence(E)),i.setEquivalence(E)}break}e[f]=m}e[f]=i}this.newRow();var P=a[0],d=a[1];for(o=s;n>o;o++){i=e[o];var g,E=i.getEquivalence();if(0!==E){var l=this.getState();g=l===AreaOp.RSTAG_INSIDE?AreaOp.ETAG_EXIT:AreaOp.ETAG_ENTER;var v=null,C=i,y=d;do this.classify(i),null===v&&i.isActiveFor(P,g)&&(v=i),T=i.getCurve().getYBot(),T>y&&(C=i,y=T);while(++o<n&&(i=e[o]).getEquivalence()===E);--o,this.getState()===l?g=AreaOp.ETAG_IGNORE:i=null!==v?v:C}else g=this.classify(i);g!==AreaOp.ETAG_IGNORE&&(i.record(d,g),A.push(new CurveLink(i.getCurve(),P,d,g)))}if(this.getState()!==AreaOp.RSTAG_OUTSIDE)for(o=s;n>o;o++)i=e[o];AreaOp.resolveLinks(h,u,A),A.length=0,a[0]=d}AreaOp.finalizeSubCurves(h,u);for(var L=[],Y=0;Y<h.length;Y++){var I=h[Y];L.push(I.getMoveto());for(var _=I;null!==(_=_.getNext());)I.absorb(_)||(L.push(I.getSubCurve()),I=_);L.push(I.getSubCurve())}return L},AreaOp.finalizeSubCurves=function(t,r){var e=r.length;if(0!==e){if(0!==(1&e))throw new InternalError("Odd number of chains!");for(var i=r.slice(0),s=1;e>s;s+=2){var n=i[s-1],o=i[s],f=n.linkTo(o);null!==f&&t.push(f)}r.length=0}},AreaOp.resolveLinks=function(t,r,e){var i,s=e.length;if(0===s)i=AreaOp.EmptyLinkList;else{if(0!==(1&s))throw new InternalError("Odd number of new curves!");
i=e.slice(0),i.push(null,null)}var n,o=r.length;if(0===o)n=AreaOp.EmptyChainList;else{if(0!==(1&o))throw new InternalError("Odd number of chains!");n=r.slice(0),n.push(null,null)}var f=0,a=0;r.length=0;for(var h=n[0],u=n[1],A=i[0],T=i[1];null!==h||null!==A;){var c=null===A,m=null===h;if(!(c||m||(c=0===(1&f)&&h.getX()===u.getX(),m=0===(1&a)&&A.getX()===T.getX(),c||m))){var p=h.getX(),E=A.getX();c=null!==u&&E>p&&AreaOp.obstructs(u.getX(),E,f),m=null!==T&&p>E&&AreaOp.obstructs(T.getX(),p,a)}if(c){var P=h.linkTo(u);null!==P&&t.push(P),f+=2,h=n[f],u=n[f+1]}if(m){var d=new ChainEnd(A,null),g=new ChainEnd(T,d);d.setOtherEnd(g),r.push(d),r.push(g),a+=2,A=i[a],T=i[a+1]}c||m||(h.addLink(A),r.push(h),f++,h=u,u=n[f+1],a++,A=T,T=i[a+1])}},AreaOp.obstructs=function(t,r,e){return 0===(1&e)?r>=t:r>t},AreaOpCAGOp.prototype=Object.create(AreaOp.prototype),AreaOpCAGOp.prototype.constructor=AreaOpCAGOp,AreaOpCAGOp.prototype.newRow=function(){this.inLeft=!1,this.inRight=!1,this.inResult=!1},AreaOpCAGOp.prototype.classify=function(t){t.getCurveTag()===AreaOp.CTAG_LEFT?this.inLeft=!this.inLeft:this.inRight=!this.inRight;var r=this.newClassification(this.inLeft,this.inRight);return this.inResult===r?AreaOp.ETAG_IGNORE:(this.inResult=r,r?AreaOp.ETAG_ENTER:AreaOp.ETAG_EXIT)},AreaOpCAGOp.prototype.getState=function(){return this.inResult?AreaOp.RSTAG_INSIDE:AreaOp.RSTAG_OUTSIDE},AreaOpAddOp.prototype=Object.create(AreaOpCAGOp.prototype),AreaOpAddOp.prototype.constructor=AreaOpAddOp,AreaOpAddOp.prototype.newClassification=function(t,r){return t||r},AreaOpSubOp.prototype=Object.create(AreaOpCAGOp.prototype),AreaOpSubOp.prototype.constructor=AreaOpSubOp,AreaOpSubOp.prototype.newClassification=function(t,r){return t&&!r},AreaOpIntOp.prototype=Object.create(AreaOpCAGOp.prototype),AreaOpIntOp.prototype.constructor=AreaOpIntOp,AreaOpIntOp.prototype.newClassification=function(t,r){return t&&r},AreaOpXorOp.prototype=Object.create(AreaOpCAGOp.prototype),AreaOpXorOp.prototype.constructor=AreaOpXorOp,AreaOpXorOp.prototype.newClassification=function(t,r){return t!==r},AreaOpNZWindOp.prototype=Object.create(AreaOp.prototype),AreaOpNZWindOp.prototype.constructor=AreaOpNZWindOp,AreaOpNZWindOp.prototype.newRow=function(){this.count=0},AreaOpNZWindOp.prototype.classify=function(t){var r=this.count,e=0===r?AreaOp.ETAG_ENTER:AreaOp.ETAG_IGNORE;return r+=t.getCurve().getDirection(),this.count=r,0===r?AreaOp.ETAG_EXIT:e},AreaOpNZWindOp.prototype.getState=function(){return 0===this.count?AreaOp.RSTAG_OUTSIDE:AreaOp.RSTAG_INSIDE},AreaOpEOWindOp.prototype=Object.create(AreaOp.prototype),AreaOpEOWindOp.prototype.constructor=AreaOpEOWindOp,AreaOpEOWindOp.prototype.newRow=function(){inside=!1},AreaOpEOWindOp.prototype.classify=function(t){var r=!this.inside;return this.inside=r,r?AreaOp.ETAG_ENTER:AreaOp.ETAG_EXIT},AreaOpEOWindOp.prototype.getState=function(){return inside?AreaOp.RSTAG_INSIDE:AreaOp.RSTAG_OUTSIDE},ChainEnd.prototype.getChain=function(){return this.head},ChainEnd.prototype.setOtherEnd=function(t){this.partner=t},ChainEnd.prototype.getPartner=function(){return this.partner},ChainEnd.prototype.linkTo=function(t){if(this.etag===AreaOp.ETAG_IGNORE||t.etag===AreaOp.ETAG_IGNORE)throw new InternalError("ChainEnd linked more than once!");if(this.etag===t.etag)throw new InternalError("Linking chains of the same type!");var r,e;if(this.etag===AreaOp.ETAG_ENTER?(r=this,e=t):(r=t,e=this),this.etag=AreaOp.ETAG_IGNORE,t.etag=AreaOp.ETAG_IGNORE,r.tail.setNext(e.head),r.tail=e.tail,this.partner===t)return r.head;var i=e.partner,s=r.partner;return i.partner=s,s.partner=i,r.head.getYTop()<i.head.getYTop()?(r.tail.setNext(i.head),i.head=r.head):(s.tail.setNext(r.head),s.tail=r.tail),null},ChainEnd.prototype.addLink=function(t){this.etag===AreaOp.ETAG_ENTER?(this.tail.setNext(t),this.tail=t):(t.setNext(this.head),this.head=t)},ChainEnd.prototype.getX=function(){return this.etag===AreaOp.ETAG_ENTER?this.tail.getXBot():this.head.getXBot()},CurveLink.prototype.absorb=function(t){return this.absorb(t.curve,t.ytop,t.ybot,t.etag)},CurveLink.prototype.absorb=function(t,r,e,i){if(this.curve!==t||this.etag!==i||this.ybot<r||this.ytop>e)return!1;if(r<t.getYTop()||e>t.getYBot())throw new InternalError("bad curvelink ["+r+"=>"+e+"] for "+t);return this.ytop=Math.min(this.ytop,r),this.ybot=Math.max(this.ybot,e),!0},CurveLink.prototype.isEmpty=function(){return this.ytop===this.ybot},CurveLink.prototype.getCurve=function(){return this.curve},CurveLink.prototype.getSubCurve=function(){return this.ytop===this.curve.getYTop()&&this.ybot===this.curve.getYBot()?this.curve.getWithDirection(this.etag):this.curve.getSubCurve(this.ytop,this.ybot,this.etag)},CurveLink.prototype.getMoveto=function(){return new Order0(this.getXTop(),this.getYTop())},CurveLink.prototype.getXTop=function(){return this.curve.XforY(this.ytop)},CurveLink.prototype.getYTop=function(){return this.ytop},CurveLink.prototype.getXBot=function(){return this.curve.XforY(this.ybot)},CurveLink.prototype.getYBot=function(){return this.ybot},CurveLink.prototype.getX=function(){return this.curve.XforY(this.ytop)},CurveLink.prototype.getEdgeTag=function(){return this.etag},CurveLink.prototype.setNext=function(t){this.next=t},CurveLink.prototype.getNext=function(){return this.next},Edge.prototype.getCurve=function(){return this.curve},Edge.prototype.getCurveTag=function(){return this.ctag},Edge.prototype.getEdgeTag=function(){return this.etag},Edge.prototype.setEdgeTag=function(t){this.etag=t},Edge.prototype.getEquivalence=function(){return this.equivalence},Edge.prototype.setEquivalence=function(t){this.equivalence=t},Edge.prototype.compareTo=function(t,r){if(t===this.lastEdge&&r[0]<this.lastLimit)return r[1]>this.lastLimit&&(r[1]=this.lastLimit),this.lastResult;if(this===t.lastEdge&&r[0]<t.lastLimit)return r[1]>t.lastLimit&&(r[1]=t.lastLimit),0-t.lastResult;var e=this.curve.compareTo(t.curve,r);return this.lastEdge=t,this.lastLimit=r[1],this.lastResult=e,e},Edge.prototype.record=function(t,r){this.activey=t,this.etag=r},Edge.prototype.isActiveFor=function(t,r){return this.etag===r&&this.activey>=t};