/*
 * triangulator-min.js
 * 
 * Copyright (c) 2016 Emmanuel PUYBARET / eTeks <info@eteks.com>
 * 
 * Copyright (c) 2007 Sun Microsystems, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * - Redistribution of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 *
 * - Redistribution in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in
 *   the documentation and/or other materials provided with the
 *   distribution.
 *
 * Neither the name of Sun Microsystems, Inc. or the names of
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 * This software is provided "AS IS," without a warranty of any
 * kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
 * EXCLUDED. SUN MICROSYSTEMS, INC. ("SUN") AND ITS LICENSORS SHALL
 * NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF
 * USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
 * DERIVATIVES. IN NO EVENT WILL SUN OR ITS LICENSORS BE LIABLE FOR
 * ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
 * CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
 * REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
 * INABILITY TO USE THIS SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGES.
 *
 * You acknowledge that this software is not designed, licensed or
 * intended for use in the design, construction, operation or
 * maintenance of any nuclear facility.
 */

// Java 3D com.sun.j3d.utils.geometry.Triangulator class translated to Javascript
function Triangulator(){this.loops=null,this.chains=null,this.points=null,this.numPoints=0,this.triangles=null,this.list=null,this.firstNode=0,this.pointsUnsorted=null,this.maxNumPUnsorted=0,this.noHashingEdges=!1,this.noHashingPnts=!1,this.loopMin=0,this.loopMax=0,this.vertexList=null,this.reflexVertices=0,this.numReflex=0,this.distances=null,this.maxNumDist=0,this.heap=null,this.numHeap=0,this.numZero=0,this.polyArea=null,this.ccwLoop=!0,this.identCntr,this.epsilon=1e-12}function ListNode(t){this.index=t,this.prev=-1,this.next=-1,this.convex=0,this.vcntIndex=-1}function Triangle(t,i,e){this.v1=t,this.v2=i,this.v3=e}function BoundingBox(t,i,e){this.imin=Math.min(i,e),this.imax=Math.max(i,e),this.ymin=Math.min(t.points[this.imin][1],t.points[this.imax][1]),this.ymax=Math.max(t.points[this.imin][1],t.points[this.imax][1])}function HeapNode(){this.index=0,this.prev=0,this.next=0,this.ratio=0}function Distance(){this.ind=0,this.dist=0}function PointNode(){this.pnt=0,this.next=0}Triangulator.ZERO=1e-8,Triangulator.prototype.triangulate=function(t,i,e,s,n,h,r,a){this.vertices=t,this.maxNumDist=0,this.maxNumPUnsorted=0,this.loops=[],this.list=[],this.numReflex=0,this.numPoints=0;var o=0;null===n&&(n=[i.length]);for(var c=0;c<n.length;c++){for(var l=this.makeLoopHeader(),p=this.loops[l],f=0;f<n[c];f++){var u=this.list.length;this.list.push(new ListNode(i[o])),this.insertAfter(p,u),this.list[u].setCommonIndex(o),p=u,o++}this.deleteHook(l)}this.triangles=[],this.epsilon=Triangulator.ZERO;for(var v=!1,g=!1,x=[!1],D=[!1],c=0;c<n.length;c++)if(this.ccwLoop=!0,!this.simpleFace(this.loops[c])){this.preProcessList(c),this.projectFace(c,c+1);this.cleanPolyhedralFace(c,c+1);for(this.determineOrientation(this.loops[c]),this.noHashingEdges=!1,this.noHashingPnts=!1,this.classifyAngles(this.loops[c]),this.resetPolyList(this.loops[c]),this.prepareNoHashPoints(c),this.classifyEars(this.loops[c]),x[0]=!1;!x[0];){if(this.clipEar(x))v=!1;else if(v){var u=this.getNode();if(this.resetPolyList(u),this.loops[c]=u,this.desperate(u,c,x)){if(!this.letsHope(u))return}else v=!1}else{g=!0;var u=this.getNode();this.resetPolyList(u),this.classifyEars(u),v=!0}if(x[0]){var u=this.getNextChain(D);D[0]&&(this.resetPolyList(u),this.loops[c]=u,this.noHashingPnts=!1,this.prepareNoHashPoints(c),this.classifyEars(u),v=!1,x[0]=!1)}}}this.copyToTriangles(i,e,s,h,r,a)},Triangulator.prototype.preProcessList=function(t){this.resetPolyList(this.loops[t]);for(var i=this.loops[t],e=i,s=this.list[e].next;s!==i;)this.list[e].index===this.list[s].index&&(s===this.loops[t]&&(this.loops[t]=this.list[s].next),this.deleteLinks(s)),e=this.list[e].next,s=this.list[e].next},Triangulator.prototype.copyToTriangles=function(t,i,e,s,n,h){for(var r=0;r<this.triangles.length;r++){var a=this.list[this.triangles[r].v1].getCommonIndex();s.push(t[a]),a=this.list[this.triangles[r].v2].getCommonIndex(),s.push(t[a]),a=this.list[this.triangles[r].v3].getCommonIndex(),s.push(t[a])}if(null!==i&&i.length>0)for(var r=0;r<this.triangles.length;r++){var a=this.list[this.triangles[r].v1].getCommonIndex();n.push(i[a]),a=this.list[this.triangles[r].v2].getCommonIndex(),n.push(i[a]),a=this.list[this.triangles[r].v3].getCommonIndex(),n.push(i[a])}if(null!==e&&e.length){currIndex=0;for(var r=0;r<this.triangles.length;r++){var a=this.list[this.triangles[r].v1].getCommonIndex();h.push(e[a]),a=this.list[this.triangles[r].v2].getCommonIndex(),h.push(e[a]),a=this.list[this.triangles[r].v3].getCommonIndex(),h.push(e[a])}}},Triangulator.prototype.isInPolyList=function(t){return t>=0&&t<this.list.length},Triangulator.prototype.updateIndex=function(t,i){this.list[t].index=i},Triangulator.prototype.getAngle=function(t){return this.list[t].convex},Triangulator.prototype.setAngle=function(t,i){this.list[t].convex=i},Triangulator.prototype.resetPolyList=function(t){this.firstNode=t},Triangulator.prototype.getNode=function(){return this.firstNode},Triangulator.prototype.deleteHook=function(t){var i=this.loops[t],e=this.list[i].next;this.isInPolyList(i)&&this.isInPolyList(e)&&(this.deleteLinks(i),this.loops[t]=e)},Triangulator.prototype.deleteLinks=function(t){this.isInPolyList(t)&&this.isInPolyList(this.list[t].prev)&&this.isInPolyList(this.list[t].next)&&(this.firstNode===t&&(this.firstNode=this.list[t].next),this.list[this.list[t].next].prev=this.list[t].prev,this.list[this.list[t].prev].next=this.list[t].next,this.list[t].prev=this.list[t].next=t)},Triangulator.prototype.rotateLinks=function(t,i){var e=this.list[t].next,s=this.list[i].next,n=this.list[t].next;this.list[t].next=this.list[i].next,this.list[i].next=n,this.list[e].prev=i,this.list[s].prev=t},Triangulator.prototype.storeChain=function(t){null===this.chains&&(this.chains=[]),this.chains.push(t)},Triangulator.prototype.getNextChain=function(t){return null!==this.chains&&this.chains.length>0?(t[0]=!0,this.chains.pop()):(t[0]=!1,this.chains=null,0)},Triangulator.prototype.splitSplice=function(t,i,e,s){this.list[t].next=s,this.list[s].prev=t,this.list[i].prev=e,this.list[e].next=i},Triangulator.prototype.makeHook=function(){var t=new ListNode(-1);return t.prev=this.list.length,t.next=this.list.length,this.list.push(t),this.list.length-1},Triangulator.prototype.makeLoopHeader=function(){return this.loops.push(this.makeHook()),this.loops.length-1},Triangulator.prototype.makeNode=function(t){return this.list.push(new ListNode(t)),this.list.length-1},Triangulator.prototype.insertAfter=function(t,i){if(this.isInPolyList(t)&&this.isInPolyList(i)){this.list[i].next=this.list[t].next,this.list[i].prev=t,this.list[t].next=i;var e=this.list[i].next;this.isInPolyList(e)&&(this.list[e].prev=i)}},Triangulator.prototype.fetchNextData=function(t){return this.list[t].next},Triangulator.prototype.fetchData=function(t){return this.list[t].index},Triangulator.prototype.fetchPrevData=function(t){return this.list[t].prev},Triangulator.prototype.swapLinks=function(t){var i=this.list[t].next;this.list[t].next=this.list[t].prev,this.list[t].prev=i;for(var e=i;i!==t;)e=this.list[i].next,this.list[i].next=this.list[i].prev,this.list[i].prev=e,i=e},Triangulator.prototype.storeTriangle=function(t,i,e){this.ccwLoop?this.triangles.push(new Triangle(t,i,e)):this.triangles.push(new Triangle(i,t,e))},Triangulator.prototype.initPoints=function(t){this.points=[];for(var i=0;t>i;i++)this.points[i]=[0,0];this.numPoints=0},Triangulator.prototype.inPointsList=function(t){return t>=0&&t<this.numPoints},Triangulator.prototype.storePoint=function(t,i){return null===this.points&&(this.points=[]),this.points[this.numPoints]=[t,i],this.numPoints++},Triangulator.prototype.simpleFace=function(t){var i=this.fetchPrevData(t);this.fetchData(i);if(i===t)return!0;var e=this.fetchNextData(t),s=this.fetchData(e);if(i===e)return!0;var n=this.fetchNextData(e),h=this.fetchData(n);if(i===n)return this.storeTriangle(t,e,n),!0;var r=this.fetchNextData(n),a=this.fetchData(r);if(i===r){this.initPoints(5);var o=this.fetchData(t),c=vec3.subtract(vec3.create(),this.vertices[o],this.vertices[s]),l=vec3.subtract(vec3.create(),this.vertices[h],this.vertices[s]),p=vec3.cross(vec3.create(),c,l),f=Math.abs(p[0]),u=Math.abs(p[1]),v=Math.abs(p[2]);v>=f&&v>=u?(this.points[1][0]=this.vertices[o][0],this.points[1][1]=this.vertices[o][1],this.points[2][0]=this.vertices[s][0],this.points[2][1]=this.vertices[s][1],this.points[3][0]=this.vertices[h][0],this.points[3][1]=this.vertices[h][1],this.points[4][0]=this.vertices[a][0],this.points[4][1]=this.vertices[a][1]):f>=u&&f>=v?(this.points[1][0]=this.vertices[o][2],this.points[1][1]=this.vertices[o][1],this.points[2][0]=this.vertices[s][2],this.points[2][1]=this.vertices[s][1],this.points[3][0]=this.vertices[h][2],this.points[3][1]=this.vertices[h][1],this.points[4][0]=this.vertices[a][2],this.points[4][1]=this.vertices[a][1]):(this.points[1][0]=this.vertices[o][0],this.points[1][1]=this.vertices[o][2],this.points[2][0]=this.vertices[s][0],this.points[2][1]=this.vertices[s][2],this.points[3][0]=this.vertices[h][0],this.points[3][1]=this.vertices[h][2],this.points[4][0]=this.vertices[a][0],this.points[4][1]=this.vertices[a][2]),this.numPoints=5;var g=this.orientation(1,2,3),x=this.orientation(1,3,4);return g>0&&x>0||0>g&&0>x?(this.storeTriangle(t,e,n),this.storeTriangle(t,n,r)):(this.storeTriangle(e,n,r),this.storeTriangle(e,r,t)),!0}return!1},Triangulator.prototype.max3=function(t,i,e){return t>i?t>e?t:e:i>e?i:e},Triangulator.prototype.min3=function(t,i,e){return i>t?e>t?t:e:e>i?i:e},Triangulator.prototype.baseLength=function(t,i){return Math.abs(i[0]-t[0])+Math.abs(i[1]-t[1])},Triangulator.prototype.sideLength=function(t,i){var e=i[0]-t[0],s=i[1]-t[1];return e*e+s*s},Triangulator.prototype.inBetween=function(t,i,e){return e>=t&&i>=e},Triangulator.prototype.strictlyInBetween=function(t,i,e){return e>t&&i>e},Triangulator.prototype.stableDet2D=function(t,i,e){var s;if(t===i||t===e||i===e)s=0;else{var n=this.points[t],h=this.points[i],r=this.points[e];s=i>t?e>i?this.det2D(n,h,r):e>t?-this.det2D(n,r,h):this.det2D(r,n,h):e>t?-this.det2D(h,n,r):e>i?this.det2D(h,r,n):-this.det2D(r,h,n)}return s},Triangulator.prototype.det2D=function(t,i,e){return(t[0]-i[0])*(i[1]-e[1])+(i[1]-t[1])*(i[0]-e[0])},Triangulator.prototype.orientation=function(t,i,e){var s=this.stableDet2D(t,i,e);return s<-this.epsilon?-1:s<=this.epsilon?0:1},Triangulator.prototype.isInCone=function(t,i,e,s,n){if(n){if(t!==i){var h=this.orientation(t,i,s);if(0>h)return!1;if(0===h)if(i>t){if(!this.inBetween(t,i,s))return!1}else if(!this.inBetween(i,t,s))return!1}if(i!==e){var r=this.orientation(i,e,s);if(0>r)return!1;if(0===r)if(e>i){if(!this.inBetween(i,e,s))return!1}else if(!this.inBetween(e,i,s))return!1}}else if(this.orientation(t,i,s)<=0&&this.orientation(i,e,s)<0)return!1;return!0},Triangulator.prototype.isConvexAngle=function(t,i,e,s){if(t===i)return 1;if(i===e)return-1;var n=this.orientation(t,i,e);if(n>0)return 1;if(0>n)return-1;var h=[this.points[t][0]-this.points[i][0],this.points[t][1]-this.points[i][1]],r=[this.points[e][0]-this.points[i][0],this.points[e][1]-this.points[i][1]],a=h[0]*r[0]+h[1]*r[1];return 0>a?0:this.spikeAngle(t,i,e,s)},Triangulator.prototype.isPointInTriangle=function(t,i,e,s){var n=this.orientation(i,e,s);return n>=0&&(n=this.orientation(t,i,s),n>=0&&(n=this.orientation(e,t,s),n>=0))?!0:!1},Triangulator.prototype.isVertexInTriangle=function(t,i,e,s,n){var h=this.orientation(i,e,s);if(h>=0)if(h=this.orientation(t,i,s),h>0){if(h=this.orientation(e,t,s),h>0)return n[0]=0,!0;if(0===h)return n[0]=1,!0}else if(0===h){if(h=this.orientation(e,t,s),h>0)return n[0]=2,!0;if(0===h)return n[0]=3,!0}return!1},Triangulator.prototype.segmentsIntersect=function(t,i,e,s,n){if(t===i||e===s)return!1;if(t===e&&i===s)return!0;(e===n||s===n)&&++this.identCntr;var h=this.orientation(t,i,e),r=this.orientation(t,i,s);if(1===h&&1===r||-1===h&&-1===r)return!1;if(0===h){if(this.strictlyInBetween(t,i,e))return!0;if(0!==r)return!1;if(this.strictlyInBetween(t,i,s))return!0}else if(0===r)return this.strictlyInBetween(t,i,s)?!0:!1;var a=this.orientation(e,s,t),o=this.orientation(e,s,i);return 0>=a&&0>=o||a>=0&&o>=0?!1:!0},Triangulator.prototype.getRatio=function(t,i,e){var s=this.points[t],n=this.points[i],h=this.points[e],r=this.baseLength(s,n),a=this.baseLength(s,h),o=this.baseLength(h,n),c=this.max3(r,a,o);if(10*r<Math.min(a,o))return.1;var l=this.stableDet2D(t,i,e);if(l<-this.epsilon)l=-l;else if(l<=this.epsilon)return c>r?.1:Number.MAX_VALUE;var p=c*c/l;return 10>p?p:c>r?.1:p},Triangulator.prototype.spikeAngle=function(t,i,e,s){var n=s,h=(this.fetchData(n),this.fetchPrevData(n)),r=(this.fetchData(h),this.fetchNextData(n));this.fetchData(r);return this.recSpikeAngle(t,i,e,h,r)},Triangulator.prototype.recSpikeAngle=function(t,i,e,s,n){if(s===n)return-2;if(t!==e){var h,r;if(i>t?(h=t,r=i):(h=i,r=t),this.inBetween(h,r,e)){if(i=e,n=this.fetchNextData(n),e=this.fetchData(n),s===n)return 2;var a=this.orientation(t,i,e);return a>0?2:0>a?-2:this.recSpikeAngle(t,i,e,s,n)}if(i=t,s=this.fetchPrevData(s),t=this.fetchData(s),s===n)return 2;var a=this.orientation(t,i,e);return a>0?2:0>a?-2:this.recSpikeAngle(t,i,e,s,n)}var o=i;if(i=t,s=this.fetchPrevData(s),t=this.fetchData(s),s===n)return 2;if(n=this.fetchNextData(n),e=this.fetchData(n),s===n)return 2;if(a=this.orientation(t,i,e),a>0)return this.orientation(t,i,o)>0&&this.orientation(i,e,o)>0?-2:2;if(0>a)return this.orientation(i,t,o)>0&&this.orientation(e,i,o)>0?2:-2;var c=[this.points[t][0]-this.points[i][0],this.points[t][1]-this.points[i][1]],l=[this.points[e][0]-this.points[i][0],this.points[e][1]-this.points[i][1]],p=c[0]*l[0]+c[1]*l[1];return 0>p?this.orientation(i,t,o)>0?2:-2:this.recSpikeAngle(t,i,e,s,n)},Triangulator.prototype.angle=function(t,i,e){var s=(e[0]-t[0])*(t[1]-i[1])+(t[1]-e[1])*(t[0]-i[0]),n=s<=this.epsilon?s<-this.epsilon?-1:0:1;if(0===n)return 0;var h=[i[0]-t[0],i[1]-t[1]],r=[e[0]-t[0],e[1]-t[1]],a=Math.atan2(h[1],h[0]),o=Math.atan2(r[1],r[0]);0>a&&(a+=2*Math.PI),0>o&&(o+=2*Math.PI);var c=a-o;return c>Math.PI?c=2*Math.PI-c:c<-Math.PI&&(c=2*Math.PI+c),1===n?0>c?-c:c:c>0?-c:c},Triangulator.prototype.projectFace=function(t,i){var e=vec3.create(),s=vec3.create();this.determineNormal(this.loops[t],e);var n=t+1;if(i>n){for(var h=n;i>h;h++)this.determineNormal(this.loops[h],s),vec3.dot(e,s)<0&&vec3.negate(s,s),vec3.add(e,s,e);var r=vec3.length(e);r<=Triangulator.ZERO?(e[0]=e[1]=0,e[2]=1):vec3.scale(e,e,1/r)}this.projectPoints(t,i,e)},Triangulator.prototype.determineNormal=function(t,i){var e=t,s=this.fetchData(e),n=this.fetchPrevData(e),h=this.fetchData(n),r=this.fetchNextData(e),a=this.fetchData(r),o=vec3.subtract(vec3.create(),this.vertices[h],this.vertices[s]),c=vec3.subtract(vec3.create(),this.vertices[a],this.vertices[s]),l=vec3.cross(vec3.create(),o,c),p=vec3.length(l);for(p<=Triangulator.ZERO?i[0]=i[1]=i[2]=0:vec3.scale(i,l,1/p),vec3.copy(o,c),e=r,r=this.fetchNextData(e),a=this.fetchData(r);e!==t;)vec3.subtract(c,this.vertices[a],this.vertices[s]),vec3.cross(l,o,c),p=vec3.length(l),p<=Triangulator.ZERO||(vec3.scale(l,l,1/p),vec3.dot(i,l)<0&&vec3.negate(l,l),vec3.add(i,l,i)),vec3.copy(o,c),e=r,r=this.fetchNextData(e),a=this.fetchData(r);p=vec3.length(i),p<=Triangulator.ZERO?(i[0]=i[1]=0,i[2]=1):vec3.scale(i,i,1/p)},Triangulator.prototype.projectPoints=function(t,i,e){var s=vec3.create(),n=vec3.create();Math.abs(e[0])>.1||Math.abs(e[1])>.1?(s[0]=-e[1],s[1]=e[0],s[2]=0):(s[0]=e[2],s[2]=-e[0],s[1]=0);var h=vec3.length(s);vec3.scale(s,s,1/h),vec3.cross(n,s,e),h=vec3.length(n),vec3.scale(n,n,1/h);var r=mat4.create();r[0]=s[0],r[4]=s[1],r[8]=s[2],r[1]=n[0],r[5]=n[1],r[9]=n[2],r[2]=e[0],r[6]=e[1],r[10]=e[2];var a=vec3.create();this.initPoints(20);for(var o=t;i>o;o++){var c=this.loops[o],l=c,p=this.fetchData(l);for(vec3.transformMat4(a,this.vertices[p],r),p=this.storePoint(a[0],a[1]),this.updateIndex(l,p),l=this.fetchNextData(l),p=this.fetchData(l);l!==c;)vec3.transformMat4(a,this.vertices[p],r),p=this.storePoint(a[0],a[1]),this.updateIndex(l,p),l=this.fetchNextData(l),p=this.fetchData(l)}},Triangulator.prototype.initPointsUnsorted=function(t){if(t>this.maxNumPUnsorted){this.maxNumPUnsorted=t,this.pointsUnsorted=new Array(this.maxNumPUnsorted);for(var i=0;i<this.maxNumPUnsorted;i++)this.pointsUnsorted[i]=[0,0]}},Triangulator.prototype.cleanPolyhedralFace=function(t,i){this.initPointsUnsorted(this.numPoints);for(var e=0;e<this.numPoints;e++)this.pointsUnsorted[e][0]=this.points[e][0],this.pointsUnsorted[e][1]=this.points[e][1];this.sortPoints(this.points,this.numPoints);var s,e=0;for(s=1;s<this.numPoints;s++)0!==this.comparePoints(this.points[e],this.points[s])&&(this.points[++e]=this.points[s]);var n=e+1,h=this.numPoints-n;for(e=t;i>e;++e){for(var r=this.loops[e],a=this.fetchNextData(r),o=this.fetchData(a);a!==r;)s=this.findPointIndex(this.points,n,this.pointsUnsorted[o]),this.updateIndex(a,s),a=this.fetchNextData(a),o=this.fetchData(a);s=this.findPointIndex(this.points,n,this.pointsUnsorted[o]),this.updateIndex(a,s)}return this.numPoints=n,h},Triangulator.prototype.sortPoints=function(t,i){for(var e=0;i>e;e++)for(var s=e+1;i>s;s++)if(this.comparePoints(t[e],t[s])>0){var n=t[e][0],h=t[e][1];t[e][0]=t[s][0],t[e][1]=t[s][1],t[s][0]=n,t[s][1]=h}},Triangulator.prototype.findPointIndex=function(t,i,e){for(var s=0;i>s;s++)if(e[0]===t[s][0]&&e[1]===t[s][1])return s;return-1},Triangulator.prototype.comparePoints=function(t,i){return t[0]<i[0]?-1:t[0]>i[0]?1:t[1]<i[1]?-1:t[1]>i[1]?1:0},Triangulator.prototype.polygonArea=function(t){var i=0,e=t,s=this.fetchData(e),n=this.fetchNextData(e),h=this.fetchData(n),r=this.stableDet2D(i,s,h);for(e=n,s=h;e!==t;)n=this.fetchNextData(e),h=this.fetchData(n),r+=this.stableDet2D(i,s,h),e=n,s=h;return r},Triangulator.prototype.determineOrientation=function(t){this.polygonArea(t)<0&&(this.swapLinks(t),this.ccwLoop=!1)},Triangulator.prototype.classifyAngles=function(t){var i=t,e=this.fetchData(i),s=this.fetchPrevData(i),n=this.fetchData(s);do{var h=this.fetchNextData(i),r=this.fetchData(h),a=this.isConvexAngle(n,e,r,i);this.setAngle(i,a),n=e,e=r,i=h}while(i!==t)},Triangulator.prototype.classifyEars=function(t){var i=[0],e=[0],s=[0];this.initHeap();var n=t,h=this.fetchData(n);do this.getAngle(n)>0&&this.isEar(n,i,e,s)&&this.dumpOnHeap(s[0],n,i[0],e[0]),n=this.fetchNextData(n),h=this.fetchData(n);while(n!==t)},Triangulator.prototype.isEar=function(t,i,e,s){var n=this.fetchData(t);e[0]=this.fetchNextData(t);var h=this.fetchData(e[0]),r=this.fetchNextData(e[0]),a=this.fetchData(r);i[0]=this.fetchPrevData(t);var o=this.fetchData(i[0]),c=this.fetchPrevData(i[0]),l=this.fetchData(c);if(o===h||o===n||n===h||2===this.getAngle(t))return s[0]=0,!0;if(l===h)return this.getAngle(c)<0||this.getAngle(e[0])<0?(s[0]=0,!0):!1;if(o===a)return this.getAngle(i[0])<0||this.getAngle(r)<0?(s[0]=0,!0):!1;var p=this.getAngle(i[0])>0,f=this.isInCone(l,o,n,h,p);if(!f)return!1;var p=this.getAngle(e[0])>0,f=this.isInCone(n,h,a,o,p);if(f){var u=new BoundingBox(this,o,h);if(!this.noHashIntersectionExists(n,t,h,o,u))return s[0]=1,!0}return!1},Triangulator.prototype.clipEar=function(t){var i,e,s,n,h=[0],r=[0],a=[0];do{if(!this.deleteFromHeap(a,h,r))return!1;i=this.fetchPrevData(a[0]),s=this.fetchData(i),e=this.fetchNextData(a[0]),n=this.fetchData(e)}while(h[0]!==i||r[0]!==e);this.fetchData(a[0]);this.deleteLinks(a[0]),this.storeTriangle(i,a[0],e);var o=this.fetchPrevData(i),c=this.fetchData(o);if(o===e)return t[0]=!0,!0;var l=this.isConvexAngle(c,s,n,i),p=this.fetchNextData(e),f=this.fetchData(p),u=this.isConvexAngle(s,n,f,e);s!==n?(l>=0&&this.getAngle(i)<0&&this.deleteReflexVertex(i),u>=0&&this.getAngle(e)<0&&this.deleteReflexVertex(e)):l>=0&&this.getAngle(i)<0?this.deleteReflexVertex(i):u>=0&&this.getAngle(e)<0&&this.deleteReflexVertex(e),this.setAngle(i,l),this.setAngle(e,u);var v=[0],g=[0],x=[0];l>0&&this.isEar(i,g,x,v)&&this.insertIntoHeap(v[0],i,g[0],x[0]);var D=[0];return u>0&&this.isEar(e,x,D,v)&&this.insertIntoHeap(v[0],e,x[0],D[0]),o=this.fetchPrevData(i),c=this.fetchData(o),p=this.fetchNextData(e),f=this.fetchData(p),o===p?(this.storeTriangle(i,e,p),t[0]=!0):t[0]=!1,!0},Triangulator.prototype.insertAfterVertex=function(t){null===this.vertexList&&(this.vertexList=[]);var i=new PointNode;i.pnt=t,i.next=this.reflexVertices,this.vertexList.push(i),this.reflexVertices=this.vertexList.length-1,++this.numReflex},Triangulator.prototype.deleteFromList=function(t){if(0!==this.numReflex){var i=this.reflexVertices,e=this.vertexList[i].pnt;if(e===t)this.reflexVertices=this.vertexList[i].next,--this.numReflex;else for(var s=this.vertexList[i].next;-1!==s;)e=this.vertexList[s].pnt,e===t?(this.vertexList[i].next=this.vertexList[s].next,s=-1,--this.numReflex):(i=s,s=this.vertexList[i].next)}},Triangulator.prototype.freeNoHash=function(){this.noHashingEdges=!1,this.noHashingPnts=!1,this.vertexList=null},Triangulator.prototype.prepareNoHashEdges=function(t,i){this.loopMin=t,this.loopMax=i,this.noHashingEdges=!0},Triangulator.prototype.prepareNoHashPoints=function(t){this.vertexList=null,this.reflexVertices=-1;var i=this.loops[t],e=i;this.numReflex=0;var s=this.fetchData(e);do this.getAngle(e)<0&&this.insertAfterVertex(e),e=this.fetchNextData(e),s=this.fetchData(e);while(e!==i);this.noHashingPnts=!0},Triangulator.prototype.noHashIntersectionExists=function(t,i,e,s,n){if(this.numReflex<=0)return!1;t<n.imin?n.imin=t:t>n.imax&&(n.imax=t);var h=this.points[t][1];h<n.ymin?n.ymin=h:h>n.ymax&&(n.ymax=h);var r=this.reflexVertices,a=[0];do{var o=this.vertexList[r].pnt,c=this.fetchData(o);if(n.isInBoundingBox(this.points[c],c)){var l=this.fetchNextData(o);this.fetchData(l);if(o!==i&&o!==l)if(c===t){if(this.handleDegeneracies(t,i,e,s,c,o))return!0}else if(c!==e&&c!==s&&this.isVertexInTriangle(t,e,s,c,a))return!0}r=this.vertexList[r].next}while(-1!==r);return!1},Triangulator.prototype.deleteReflexVertex=function(t){this.deleteFromList(t)},Triangulator.prototype.noHashEdgeIntersectionExists=function(t,i,e,s,n){this.identCntr=0;for(var h=this.loopMin;h<this.loopMax;h++){var r=this.loops[h],a=r,o=this.fetchData(a);do{a=this.fetchNextData(a);var c=this.fetchData(a),l=new BoundingBox(this,o,c);if(t.overlaps(l)&&this.segmentsIntersect(t.imin,t.imax,l.imin,l.imax,n))return!0;o=c}while(a!==r)}return this.identCntr>=4?this.checkBottleNeck(n,i,e,s):!1},Triangulator.prototype.handleDegeneracies=function(t,i,e,s,n,h){var r=this.fetchPrevData(h),a=this.fetchData(r);if(a!==e&&a!==s){var o=[0],c=this.isVertexInTriangle(t,e,s,a,o);if(c&&0===o[0])return!0;if(c=s>=e?a>=n?this.segmentsIntersect(e,s,n,a,-1):this.segmentsIntersect(e,s,a,n,-1):a>=n?this.segmentsIntersect(s,e,n,a,-1):this.segmentsIntersect(s,e,a,n,-1))return!0}if(r=this.fetchNextData(h),a=this.fetchData(r),a!==e&&a!==s){var o=[0],c=this.isVertexInTriangle(t,e,s,a,o);if(c&&0===o[0])return!0;if(c=s>=e?a>=n?this.segmentsIntersect(e,s,n,a,-1):this.segmentsIntersect(e,s,a,n,-1):a>=n?this.segmentsIntersect(s,e,n,a,-1):this.segmentsIntersect(s,e,a,n,-1))return!0}var l=t,p=i,f=0;for(i=this.fetchNextData(i),t=this.fetchData(i);i!==h;){var u=this.fetchNextData(i);e=this.fetchData(u),area=this.stableDet2D(l,t,e),f+=area,i=u,t=e}var v=0;for(i=this.fetchPrevData(p),t=this.fetchData(i);i!==h;){var u=this.fetchPrevData(i);e=this.fetchData(u),area=this.stableDet2D(l,t,e),v+=area,i=u,t=e}return f<=this.ZERO&&v<=this.ZERO?!1:f<=-this.ZERO||v<=-this.ZERO?!0:!1},Triangulator.prototype.desperate=function(t,i,e){var s=[0],n=[0],h=[0],r=[0],a=[0],o=[0],c=[0],l=[0];return e[0]=!1,this.existsCrossOver(t,a,s,o,n,c,h,l,r)?(this.handleCrossOver(a[0],s[0],o[0],n[0],c[0],h[0],l[0],r[0]),!1):(this.prepareNoHashEdges(i,i+1),this.existsSplit(t,a,s,o,n)?(this.handleSplit(a[0],s[0],o[0],n[0]),e[0]=!0,!1):!0)},Triangulator.prototype.existsCrossOver=function(t,i,e,s,n,h,r,a,o){i[0]=t,e[0]=this.fetchData(i[0]),s[0]=this.fetchNextData(i[0]),n[0]=this.fetchData(s[0]),h[0]=this.fetchNextData(s[0]),r[0]=this.fetchData(h[0]),a[0]=this.fetchNextData(h[0]),o[0]=this.fetchData(a[0]);do{var c=new BoundingBox(this,e[0],n[0]),l=new BoundingBox(this,r[0],o[0]);if(c.overlaps(l)&&this.segmentsIntersect(c.imin,c.imax,l.imin,l.imax,-1))return!0;i[0]=s[0],e[0]=n[0],s[0]=h[0],n[0]=r[0],h[0]=a[0],r[0]=o[0],a[0]=this.fetchNextData(h[0]),o[0]=this.fetchData(a[0])}while(i[0]!==t);return!1},Triangulator.prototype.handleCrossOver=function(t,i,e,s,n,h,r,a){var o,c=this.getAngle(t),l=this.getAngle(r);o=l>c?!0:c>l?!1:!0,o?(this.deleteLinks(e),this.storeTriangle(t,e,n),this.setAngle(n,1),this.insertIntoHeap(0,n,t,r)):(this.deleteLinks(n),this.storeTriangle(e,n,r),this.setAngle(e,1),this.insertIntoHeap(0,e,t,r))},Triangulator.prototype.letsHope=function(t){var i=t;do{if(this.getAngle(i)>0){var e=this.fetchPrevData(i),s=this.fetchNextData(i);return this.insertIntoHeap(0,i,e,s),!0}i=this.fetchNextData(i)}while(i!==t);this.setAngle(t,1);var e=this.fetchPrevData(t),s=this.fetchNextData(t);return this.insertIntoHeap(0,t,e,s),!0},Triangulator.prototype.existsSplit=function(t,i,e,s,n){if(this.numPoints>this.maxNumDist){this.maxNumDist=this.numPoints,this.distances=new Array(this.maxNumDist);for(var h=0;h<this.maxNumDist;h++)this.distances[h]=new Distance}i[0]=t,e[0]=this.fetchData(i[0]);var r=this.fetchNextData(i[0]),a=this.fetchData(r),o=this.fetchNextData(r),c=this.fetchData(o),l=this.fetchPrevData(i[0]),p=this.fetchData(l);if(this.foundSplit(o,c,l,i[0],e[0],p,a,s,n))return!0;for(p=e[0],i[0]=r,e[0]=a,r=o,a=c,o=this.fetchNextData(r),c=this.fetchData(o);o!==t;){if(this.foundSplit(o,c,t,i[0],e[0],p,a,s,n))return!0;p=e[0],i[0]=r,e[0]=a,r=o,a=c,o=this.fetchNextData(r),c=this.fetchData(o)}return!1},Triangulator.prototype.windingNumber=function(t,i){for(var e=this.fetchData(t),s=this.fetchNextData(t),n=this.fetchData(s),h=this.angle(i,this.points[e],this.points[n]);s!==t;)e=n,s=this.fetchNextData(s),n=this.fetchData(s),h+=this.angle(i,this.points[e],this.points[n]);return h+=Math.PI,Math.floor(h/(2*Math.PI))},Triangulator.prototype.foundSplit=function(t,i,e,s,n,h,r,a,o){var c=0;do this.distances[c].dist=this.baseLength(this.points[n],this.points[i]),this.distances[c].ind=t,++c,t=this.fetchNextData(t),i=this.fetchData(t);while(t!==e);this.sortDistance(this.distances,c);for(var l=0;c>l;l++)if(a[0]=this.distances[l].ind,o[0]=this.fetchData(a[0]),n!==o[0]){var p=this.fetchPrevData(a[0]),f=this.fetchData(p),u=this.fetchNextData(a[0]),v=this.fetchData(u),g=this.getAngle(a[0])>0;if(this.isInCone(f,o[0],v,n,g)&&(g=this.getAngle(s)>0,this.isInCone(h,n,r,o[0],g))){var x=new BoundingBox(this,n,o[0]);if(!this.noHashEdgeIntersectionExists(x,-1,-1,s,-1)){var D=[.5*(this.points[n][0]+this.points[o[0]][0]),.5*(this.points[n][1]+this.points[o[0]][1])];if(1===this.windingNumber(e,D))return!0}}}return!1},Triangulator.prototype.handleSplit=function(t,i,e,s){var n=this.makeNode(i);this.insertAfter(t,n);var h=this.list[t].getCommonIndex();this.list[n].setCommonIndex(h);var r=this.makeNode(s);this.insertAfter(e,r),h=this.list[e].getCommonIndex(),this.list[r].setCommonIndex(h),this.splitSplice(t,n,e,r),this.storeChain(t),this.storeChain(e);var a=this.fetchNextData(t),o=this.fetchData(a),c=this.fetchPrevData(t),l=this.fetchData(c),p=this.isConvexAngle(l,i,o,t);this.setAngle(t,p),a=this.fetchNextData(n),o=this.fetchData(a),c=this.fetchPrevData(n),l=this.fetchData(c),p=this.isConvexAngle(l,i,o,n),this.setAngle(n,p),a=this.fetchNextData(e),o=this.fetchData(a),c=this.fetchPrevData(e),l=this.fetchData(c),p=this.isConvexAngle(l,s,o,e),this.setAngle(e,p),a=this.fetchNextData(r),o=this.fetchData(a),c=this.fetchPrevData(r),l=this.fetchData(c),p=this.isConvexAngle(l,s,o,r),this.setAngle(r,p)},Triangulator.prototype.initHeap=function(){this.heap=[],this.numHeap=0,this.numZero=0},Triangulator.prototype.storeHeapData=function(t,i,e,s,n){this.heap[t]=new HeapNode,this.heap[t].ratio=i,this.heap[t].index=e,this.heap[t].prev=s,this.heap[t].next=n},Triangulator.prototype.dumpOnHeap=function(t,i,e,s){var n;0===t?(this.numZero<this.numHeap&&(void 0===this.heap[this.numHeap]?this.storeHeapData(this.numHeap,this.heap[this.numZero].ratio,this.heap[this.numZero].index,this.heap[this.numZero].prev,this.heap[this.numZero].next):this.heap[this.numHeap].copy(this.heap[this.numZero])),n=this.numZero,++this.numZero):n=this.numHeap,this.storeHeapData(n,t,i,e,s),++this.numHeap},Triangulator.prototype.insertIntoHeap=function(t,i,e,s){this.dumpOnHeap(t,i,e,s)},Triangulator.prototype.deleteFromHeap=function(t,i,e){return this.numZero>0?(--this.numZero,--this.numHeap,t[0]=this.heap[this.numZero].index,i[0]=this.heap[this.numZero].prev,e[0]=this.heap[this.numZero].next,this.numZero<this.numHeap&&this.heap[this.numZero].copy(this.heap[this.numHeap]),!0):this.numHeap<=0?(this.numHeap=0,!1):(--this.numHeap,t[0]=this.heap[this.numHeap].index,i[0]=this.heap[this.numHeap].prev,e[0]=this.heap[this.numHeap].next,!0)},Triangulator.prototype.sortDistance=function(t,i){for(var e=new Distance,s=0;i>s;s++)for(var n=s+1;i>n;n++)this.compareDistances(t[s],t[n])>0&&(e.copy(t[s]),t[s].copy(t[n]),t[n].copy(e))},Triangulator.prototype.compareDistances=function(t,i){return t.dist<i.dist?-1:t.dist>i.dist?1:0},Triangulator.prototype.checkArea=function(t,i){for(var e=this.fetchData(t),s=this.fetchNextData(t),n=this.fetchData(s),h=0,r=0;s!=i;){var a=this.fetchNextData(s),o=this.fetchData(a);h=this.stableDet2D(e,n,o),r+=h,s=a,n=o}if(r<=this.ZERO)return!1;s=this.fetchNextData(i),n=this.fetchData(s);for(var c=0;s!=t;){var a=this.fetchNextData(s),o=this.fetchData(a);h=this.stableDet2D(e,n,o),c+=h,s=a,n=o}return!(c<=this.ZERO)},Triangulator.prototype.checkBottleNeck=function(t,i,e,s){var n=t,h=this.fetchPrevData(s),r=this.fetchData(h);if(r!==i&&r!==e&&this.isPointInTriangle(t,i,e,r))return!0;var a;if(a=e>=i?r>=n?this.segmentsIntersect(i,e,n,r,-1):this.segmentsIntersect(i,e,r,n,-1):r>=n?this.segmentsIntersect(e,i,n,r,-1):this.segmentsIntersect(e,i,r,n,-1))return!0;if(h=this.fetchNextData(s),r=this.fetchData(h),r!==i&&r!==e&&this.isPointInTriangle(t,i,e,r))return!0;if(a=e>=i?r>=n?this.segmentsIntersect(i,e,n,r,-1):this.segmentsIntersect(i,e,r,n,-1):r>=n?this.segmentsIntersect(e,i,n,r,-1):this.segmentsIntersect(e,i,r,n,-1))return!0;for(h=this.fetchNextData(s),r=this.fetchData(h);h!==s;){if(n===r&&this.checkArea(s,h))return!0;h=this.fetchNextData(h),r=this.fetchData(h)}return!1},ListNode.prototype.setCommonIndex=function(t){this.vcntIndex=t},ListNode.prototype.getCommonIndex=function(){return this.vcntIndex},BoundingBox.prototype.isInBoundingBox=function(t,i){return this.imax>=i&&this.imin<=i&&this.ymax>=t[1]&&this.ymin<=t[1]},BoundingBox.prototype.overlaps=function(t){return this.imax>=t.imin&&this.imin<=t.imax&&this.ymax>=t.ymin&&this.ymin<=t.ymax},HeapNode.prototype.copy=function(t){this.index=t.index,this.prev=t.prev,this.next=t.next,this.ratio=t.ratio},Distance.prototype.copy=function(t){this.ind=t.ind,this.dist=t.dist};